unit MainFormDlg;

interface

uses
  Winapi.Windows,
  Winapi.Messages,
  System.SysUtils,
  System.Variants,
  System.Classes,
  Vcl.Graphics,
  Vcl.Controls,
  Vcl.Forms,
  Vcl.Dialogs,
  Vcl.ComCtrls,
  Vcl.OleServer,

  // Adding forms' unit here.
  GeneralDlg,
  AddLoginDlg,
  AddLineDlg,
  AddDirectProxyDlg,
  AddConfsDlg,
  StatusLogDlg,
  ErrorLogDlg,
  VaxTeleServerSIP;

  type TMainForm = class(TForm)

  // Variables

    TabPageControlMain: TPageControl;
    TabPageGeneral: TTabSheet;
    TabPageLogin: TTabSheet;
    TabPageLine: TTabSheet;
    TabPageDirectProxy: TTabSheet;
    TabPageConfs: TTabSheet;
    TabPageStatusLog: TTabSheet;
    TabPageErrorLog: TTabSheet;

    // Events

    procedure OnCreate(Sender: TObject);
    procedure OnMainTab_Click(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure OnClose(Sender: TObject; var Action: TCloseAction);

    private

    m_objGeneralDlg : TGeneralForm;
    m_objAddLoginDlg : TAddLoginForm;
    m_objAddLineDlg : TAddLineForm;
    m_objAddDirectProxyDlg : TAddDirectProxyForm;
    m_objAddConfsDlg : TAddConfsForm;
    m_objStatusLogDlg : TStatusLogForm;
    m_objErrorLogDlg : TErrorLogForm;

    public
    m_pVaxTeleSIP : TVaxTeleServerSIP;

  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

    procedure TMainForm.OnClose(Sender: TObject; var Action: TCloseAction);
    begin
      m_objGeneralDlg.StopServer();
    end;

    procedure TMainForm.OnCreate(Sender: TObject);
    begin

        m_pVaxTeleSIP := TVaxTeleServerSIP.Create();

        //TabPageGeneral.

        // Add GeneralDlg to MainTab

        m_objGeneralDlg := TGeneralForm.Create(TabPageGeneral, m_pVaxTeleSIP);
        m_objGeneralDlg.Parent := TabPageGeneral;
        m_objGeneralDlg.Align := alClient;
        m_objGeneralDlg.Visible := true;

        // Add LoginDlg to MainTab

        m_objAddLoginDlg := TAddLoginForm.Create(TabPageLogin, m_pVaxTeleSIP);
        m_objAddLoginDlg.Parent := TabPageLogin;
        m_objAddLoginDlg.Align := alClient;
        m_objAddLoginDlg.Visible := true;

        // Add LineDlg to MainTab

        m_objAddLineDlg := TAddLineForm.Create(TabPageLine, m_pVaxTeleSIP);
        m_objAddLineDlg.Parent := TabPageLine;
        m_objAddLineDlg.Align := alClient;
        m_objAddLineDlg.Visible := true;

        // Add DirectProxyDlg to MainTab

        m_objAddDirectProxyDlg := TAddDirectProxyForm.Create(TabPageDirectProxy, m_pVaxTeleSIP);
        m_objAddDirectProxyDlg.Parent := TabPageDirectProxy;
        m_objAddDirectProxyDlg.Align := alClient;
        m_objAddDirectProxyDlg.Visible := true;

        // Add ConfsDlg to MainTab

        m_objAddConfsDlg := TAddConfsForm.Create(TabPageConfs, m_pVaxTeleSIP);
        m_objAddConfsDlg.Parent := TabPageConfs;
        m_objAddConfsDlg.Align := alClient;
        m_objAddConfsDlg.Visible := true;

        // Add StatusLogDlg to MainTab

        m_objStatusLogDlg := TStatusLogForm.Create(TabPageStatusLog);
        m_objStatusLogDlg.Parent := TabPageStatusLog;
        m_objStatusLogDlg.Align := alClient;
        m_objStatusLogDlg.Visible := true;

        // Add ErrorLogDlg to MainTab

        m_objErrorLogDlg := TErrorLogForm.Create(TabPageErrorLog);
        m_objErrorLogDlg.Parent := TabPageErrorLog;
        m_objErrorLogDlg.Align := alClient;
        m_objErrorLogDlg.Visible := True;

        m_pVaxTeleSIP.m_objStatusLogDlg := m_objStatusLogDlg;
        m_pVaxTeleSIP.m_objErrorLogDlg := m_objErrorLogDlg;

        // Set the first tab page as the default

        TabPageControlMain.ActivePage := TabPageControlMain.Pages[0];

    end;

    procedure TMainForm.OnMainTab_Click(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    begin


        if(TabPageControlMain.ActivePage = TabPageControlMain.Pages[0]) then
            m_objGeneralDlg.OnSetActive();

        if TabPageControlMain.ActivePage = TabPageControlMain.Pages[1] then
            m_objAddLoginDlg.OnSetActive();

        if TabPageControlMain.ActivePage = TabPageControlMain.Pages[2] then
            m_objAddLineDlg.OnSetActive();

        if TabPageControlMain.ActivePage = TabPageControlMain.Pages[3] then
            m_objAddDirectProxyDlg.OnSetActive();

    end;

end.
