unit VaxServerCOM;

interface

uses
    Classes,
    ComObj,
    Vcl.OleCtrls,
    Vcl.ComCtrls,
    Vcl.Forms,
    Vcl.OleServer,
    VaxTeleServerCOMLib_TLB;

type TVaxServerCOM = class(TVaxServerSIP)


        {///////////////////////////////////////////////////////////////////////////////
        ///////////////////     Events
        ///////////////////////////////////////////////////////////////////////////////}

        procedure OnLineRegisterTrying( sLineName : string); virtual;
        procedure OnLineRegisterFail( sLineName : string; nStatusCode : integer;  sReasonPhrase : string); virtual;
        procedure OnLineRegisterSuccess( sLineName : string); virtual;
        procedure OnLineUnRegisterTrying( sLineName : string); virtual;
        procedure OnLineUnRegisterFail( sLineName : string; nStatusCode : integer;  sReasonPhrase : string); virtual;
        procedure OnLineUnRegisterSuccess( sLineName : string); virtual;

        procedure OnUnRegisterUser( sUserLogin : WideString); virtual;
        procedure OnRegisterUser(sUserLogin: WideString; sDomain: WideString; sFromIP: WideString; nFromPort: Integer); virtual;
        procedure OnRegisterUserSuccess(sUserLogin: WideString); virtual;
        procedure OnRegisterUserFail( sUserLogin : WideString); virtual;

        procedure OnChatMessageText( nChatMsgId : integer;  sMsgFrom : string;  sMsgTo : string;  sMsgTt : string;  nFromPeerType : integer;  sFromPeerName : string;  sFromIP : string;  nFromPort : integer); virtual;
        procedure OnChatMessageTyping( nChatMsgId : integer;  sMsgFrom : string;  sMsgTo : string;  IsTypingStart : integer;  nFromPeerType : integer;  sFromPeerName : string;  sFromIP : string;  nFromPort : integer); virtual;
        procedure OnChatStatusSubscribe( nSubscrbId : integer;  sMsgFrom : string;  sMsgTo : string;  nFromPeerType : integer;  sFromPeerName : string;  sFromIP : string;  nFromPort : integer); virtual;

        procedure OnChatMessageSuccess( nChatMsgId : integer); virtual;
        procedure OnChatMessageFailure( ChatMsgId: Integer; StatusCode: Integer; const ReasonPhrase: WideString); virtual;
        procedure OnChatMessageTimeout( nChatMsgId : integer); virtual;

        procedure OnCallSessionOpen( nSessionId : integer;  sCallerName : string;  sCallerId : string;  sDialNo : string;  nFromPeerType : integer;  sFromPeerName : string;  sFromIP : string;  nFromPort : integer); virtual;
        procedure OnCallSessionFailed( nSessionId : integer; CallType: Integer; StatusCode: Integer; const ReasonPhrase: WideString); virtual;
        procedure OnCallSessionConnected( nSessionId : integer); virtual;
        procedure OnCallSessionClosed( nSessionId : integer; CallType: Integer; ReasonCode: Integer); virtual;

        procedure OnCallSessionConnecting(SessionId: Integer; CallType: Integer;StatusCode: Integer; const ReasonPhrase: WideString); virtual;
        procedure OnCallSessionLost(SessionId: Integer; CallType: Integer); virtual;
        procedure OnCallSessionHangup(SessionId: Integer;CallType: Integer); virtual;
        procedure OnCallSessionTimeout(SessionId: Integer; CallType: Integer); virtual;
        procedure OnCallSessionCancelled(SessionId: Integer); virtual;


        procedure OnCallSessionOnHold( nSessionId : integer; CallType: Integer); virtual;
        procedure OnCallSessionOffHold( nSessionId : integer; CallType: Integer); virtual;

        procedure OnCallSessionTransferBlind(TransfererSessionId: Integer; lTransfererCallType: Integer; const Transferer: WideString;
                                            const Transferee: WideString; const TransferTo: WideString); virtual;
        procedure OnCallSessionTransferConsult(TransfererSessionId: Integer; TransfereeSessionId: Integer; TransferToSessionId: Integer;
                                                lTransfererCallType: Integer; lTransfereeCallType: Integer;lTransferToCallType: Integer;
                                                const Transferer: WideString; const Transferee: WideString; const TransferTo: WideString); virtual;

        procedure OnCallSessionTransfering( nSessionId : integer; TransferType: Integer; CallType: Integer; StatusCode: Integer; const ReasonPhrase: WideString); virtual;
        procedure OnCallSessionTransferFailed( nSessionId : integer; TransferType: Integer; CallType: Integer; StatusCode: Integer; const ReasonPhrase: WideString); virtual;
        procedure OnCallSessionTransferTimeout( nSessionId : integer; TransferType: Integer; CallType: Integer); virtual;
        procedure OnCallSessionTransfered( nSessionId : integer; TransferType: Integer); virtual;

        procedure OnDigitDetectDTMF( nSessionId : integer;  sDigitDTMF : string); virtual;

        procedure OnOutgoingDiagnosticLog( sMsgSIP : string;  sToIP : string;  nToPort : integer); virtual;
        procedure OnIncomingDiagnosticLog( sMsgSIP : string;  sFromIP : string;  nFromPort : integer); virtual;

        procedure OnVaxTeleTick( nTickId : integer); virtual;

        procedure OnSendTimeOutVM( nMsgIdVM : integer); virtual;
        procedure OnSendSuccessVM( nMsgIdVM : integer); virtual;

        procedure OnCallSessionDialToneStart( nSessionId : integer;  nWaveId : integer); virtual;
        procedure OnCallSessionDialToneStop( nSessionId : integer;  nWaveId : integer); virtual;

        procedure OnCallSessionPlayWaveDone(nSessionId : Integer;  nWaveId : integer); virtual;
        procedure OnConferenceRoomPlayWaveDone(sRoomName : string; nWaveId : Integer); virtual;

        procedure OnCallSessionCreated(nSessionId : Integer;  nCallType : integer;  nReasonCode : integer); virtual;

        procedure OnCallSessionOpenCall(nSessionId : Integer;  nCallType : integer;  nPeerType : integer;  sPeerName : string); virtual;
        procedure OnCallSessionCloseCall(nSessionId : Integer;  nCallType : integer;  nPeerType : integer;  sPeerName : string); virtual;

        procedure OnCallSessionDetectedAMD(nSessionId : Integer;  nCallType : integer;  bIsHuman : Boolean); virtual;

        {///////////////////////////////////////////////////////////////////////////////
        ///////////////////     Functions
        ///////////////////////////////////////////////////////////////////////////////}


        public

        constructor Create();

        procedure InvokeEvent(DispID: LongInt; var Params: TVariantArray); override;

        procedure SetLicenseKey(sLicenseKey : string);

        function Initialize(sDomainRealm : string;  sSIPListenIP : string; nSIPListenPort : integer ;  sRTPListenIP : string; nRTPListenPort : integer ) : boolean;

        procedure UnInitialize();

        function AddUser( sUserName : string;  sPassword : string;  sCodecList : string) : boolean;
        procedure RemoveUser( sUserName : string);

        function AcceptRegister( sUserName : string) : boolean;
        function RejectRegister( sUserName : string; lStatusCode : integer;  sReasonPhrase : string) : boolean;
        function AuthRegister( sUserName : string) : boolean;

        function AddLine( sLineName : string;  sDisplayName : string;  sUserName : string;  sAuthUser : string;  sAuthPwd : string;  sDomainRealm : string;  sProxySIP : string;  sOutboundProxySIP : string;  sCodecList : string) : boolean;
        procedure RemoveLine( sLineName : string);

        function RegisterLine( sLineName : string) : boolean;
        function UnRegisterLine( sLineName : string) : boolean;

        function AddDirectProxySIP( sProxyName : string;  sAuthLogin : string;  sAuthPwd : string;  sDomainRealm : string;  sProxyIP : string; lProxyPort : integer ;  sCodecList : string) : boolean;
        procedure RemoveDirectProxySIP( sProxyName : string);

        function AcceptCallSession(lSessionId : integer ;  sCallerName : string;  sCallerId : string;  sDialNo : string;  nToPeerType : integer ;  sToPeerName : string; lTimeOut : integer ) : boolean;
        procedure RejectCallSession(lSessionId : integer ; lStatusCode : integer ;  sReasonPhrase : string);
        procedure CloseCallSession(lSessionId : integer );

        function CreateCallSession( sCallerName : string;  sCallerId : string;  sDialNo : string;  nToPeerType : integer ;  sToPeerName : string; lTimeOut : integer ) : integer;
        function OpenCallSession( sCallerName : string;  sCallerId : string;  sDialNo : string;  nToPeerType : integer ;  sToPeerName : string; lTimeOut : integer ) : integer;

        function AcceptTransferBlind(lTransfererSessionId : integer ;  sCallerName : string;  sCallerId : string;  sTransferTo : string;  nToPeerType : integer ;  sToPeerName : string; lTimeOut : integer) : Integer;
        function AcceptTransferConsult(lTransfererSessionId : integer ; lTransferToSessionId : integer ) : Integer;
        procedure RejectTransfer(lSessionId : integer );

        function PlayWaveStartToCallSession(lSessionId : integer ; lWaveId : integer ; bLoop : boolean) : boolean;
        function PlayWaveStopToCallSession(lSessionId : integer ) : boolean;

        function RecordWaveStartToCallSession(lSessionId : integer ;  sFileName : string) : boolean;
        function RecordWaveStopToCallSession(lSessionId : integer ) : boolean;
        function RecordWavePauseToCallSession(lSessionId : integer ; bEnable : boolean) : boolean;

        function LoadWaveFile( sFileName : string) : integer;
        procedure UnLoadWaveFile(lWaveId : integer);

        function LoadMusicHold( sFileName : string) : boolean;
        procedure UnLoadMusicHold();

        function AcceptOnHoldRequest(lSessionId  : integer ) : boolean;
        function AcceptOffHoldRequest(lSessionId : integer ) : boolean;

        function AcceptChatMessage(lChatMsgId : integer ;  nToPeerType : integer ;  sToPeerName : string) : boolean;
        procedure RejectChatMessage(lChatMsgId : integer ; lStatusCode : integer ;  sReasonPhrase : string);

        function AcceptChatStatusSubscribe(lStatusSubscribe : integer ;  sMsgFrom : string;  sMsgTo : string;  nToPeerType : integer ;  sToPeerName : string) : boolean;
        procedure RejectChatStatusSubscribe(lStatusSubscribe : integer ;  sMsgFrom : string;  sMsgTo : string);

        function OpenConferenceRoom( sRoomName : string) : boolean;
        procedure CloseConferenceRoom( sRoomName : string);

        function AddCallSessionToConferenceRoom( sRoomName : string;  lSessionId : integer ;  nType : integer ) : boolean;
        function RemoveCallSessionFromConferenceRoom( lSessionId : integer ) : boolean;

        function PlayWaveStartToConferenceRoom( sRoomName : string;  lWaveId : integer ;  bLoop : boolean) : boolean;
        function PlayWaveStopToConferenceRoom( sRoomName : string) : boolean;

        function RecordWaveStartToConferenceRoom( sRoomName : string;  sFileName : string) : boolean;
        function RecordWaveStopToConferenceRoom( sRoomName : string) : boolean;
        function RecordWavePauseToConferenceRoom( sRoomName : string; bEnable : boolean) : boolean;

        function VoiceSessionLost(bEnable : boolean; lTimeOut : integer ) : boolean;

        function SendInfoVM( sUserLogin : string;  nNewMsgCount : integer ;  nOldMsgCount : integer ; bMsgWaiting : Boolean ) : integer;

        function StartVaxTeleTick(lTickId : integer ; lElapse : integer ) : boolean;
        function StopVaxTeleTick(lTickId : integer ) : boolean;

        function SetUserAgentName( sName : string) : boolean;
        function GetUserAgentName() : string;

        function SetSessionNameSDP( sName : string) : boolean;
        function GetSessionNameSDP() : string;

        function SendDTMFCallSession( lSessionId : integer ;  nTypeDTMF : integer ;  nDigit : integer ) : boolean;
        function DetectDTMFCallSession( lSessionId : integer ;  nTypeDTMF : integer ; bEnable : boolean;  nTimeout : integer ) : boolean;

        function GetVaxObjectError() : integer;

        function DialToneToCallSession( bEnable : boolean;  lSessionId : integer ;  lWaveId : integer ) : boolean;
        function DiagnosticLogSIP( bInbound : boolean;  bOutbound : boolean) : boolean;

        private
            m_pVaxServerLibCOM : TVaxServerSIP;

end;


implementation

{$ASSERTIONS ON}

        {///////////////////////////////////////////////////////////////////////////////
        ///////////////////     Events
        ///////////////////////////////////////////////////////////////////////////////}

        procedure TVaxServerCOM.OnLineRegisterTrying( sLineName : string);
        begin
        end;
        procedure TVaxServerCOM.OnLineRegisterFail( sLineName : string; nStatusCode : integer;  sReasonPhrase : string);
        begin
        end;
        procedure TVaxServerCOM.OnLineRegisterSuccess( sLineName : string);
        begin
        end;
        procedure TVaxServerCOM.OnLineUnRegisterTrying( sLineName : string);
        begin
        end;
        procedure TVaxServerCOM.OnLineUnRegisterFail( sLineName : string; nStatusCode : integer;  sReasonPhrase : string);
        begin
        end;
        procedure TVaxServerCOM.OnLineUnRegisterSuccess( sLineName : string);
        begin
        end;

        procedure TVaxServerCOM.OnUnRegisterUser( sUserLogin : WideString);
        begin
        end;
        procedure TVaxServerCOM.OnRegisterUser(sUserLogin: WideString; sDomain: WideString; sFromIP: WideString; nFromPort: Integer);
        begin
        end;
        procedure TVaxServerCOM.OnRegisterUserSuccess(sUserLogin: WideString);
        begin
        end;
        procedure TVaxServerCOM.OnRegisterUserFail( sUserLogin : WideString);
        begin
        end;

        procedure TVaxServerCOM.OnChatMessageText( nChatMsgId : integer;  sMsgFrom : string;  sMsgTo : string;  sMsgTt : string;  nFromPeerType : integer;  sFromPeerName : string;  sFromIP : string;  nFromPort : integer);
        begin
        end;
        procedure TVaxServerCOM.OnChatMessageTyping( nChatMsgId : integer;  sMsgFrom : string;  sMsgTo : string;  IsTypingStart : integer;  nFromPeerType : integer;  sFromPeerName : string;  sFromIP : string;  nFromPort : integer);
        begin
        end;
        procedure TVaxServerCOM.OnChatStatusSubscribe( nSubscrbId : integer;  sMsgFrom : string;  sMsgTo : string;  nFromPeerType : integer;  sFromPeerName : string;  sFromIP : string;  nFromPort : integer);
        begin
        end;

        procedure TVaxServerCOM.OnChatMessageSuccess( nChatMsgId : integer);
        begin
        end;
        procedure TVaxServerCOM.OnChatMessageFailure( ChatMsgId: Integer; StatusCode: Integer; const ReasonPhrase: WideString);
        begin
        end;
        procedure TVaxServerCOM.OnChatMessageTimeout( nChatMsgId : integer);
        begin
        end;

        procedure TVaxServerCOM.OnCallSessionOpen( nSessionId : integer;  sCallerName : string;  sCallerId : string;  sDialNo : string;  nFromPeerType : integer;  sFromPeerName : string;  sFromIP : string;  nFromPort : integer);
        begin
        end;
        procedure TVaxServerCOM.OnCallSessionFailed( nSessionId : integer; CallType: Integer; StatusCode: Integer; const ReasonPhrase: WideString);
        begin
        end;
        procedure TVaxServerCOM.OnCallSessionConnected( nSessionId : integer);
        begin
        end;
        procedure TVaxServerCOM.OnCallSessionClosed( nSessionId : integer; CallType: Integer; ReasonCode: Integer);
        begin
        end;

        procedure TVaxServerCOM.OnCallSessionConnecting(SessionId: Integer; CallType: Integer;StatusCode: Integer; const ReasonPhrase: WideString);
        begin
        end;
        procedure TVaxServerCOM.OnCallSessionLost(SessionId: Integer; CallType: Integer);
        begin
        end;
        procedure TVaxServerCOM.OnCallSessionHangup(SessionId: Integer;CallType: Integer);
        begin
        end;
        procedure TVaxServerCOM.OnCallSessionTimeout(SessionId: Integer; CallType: Integer);
        begin
        end;
        procedure TVaxServerCOM.OnCallSessionCancelled(SessionId: Integer);
        begin
        end;


        procedure TVaxServerCOM.OnCallSessionOnHold( nSessionId : integer; CallType: Integer);
        begin
        end;
        procedure TVaxServerCOM.OnCallSessionOffHold( nSessionId : integer; CallType: Integer);
        begin
        end;

        procedure TVaxServerCOM.OnCallSessionTransferBlind(TransfererSessionId: Integer; lTransfererCallType: Integer; const Transferer: WideString;
                                            const Transferee: WideString; const TransferTo: WideString);
        begin
        end;
        procedure TVaxServerCOM.OnCallSessionTransferConsult(TransfererSessionId: Integer; TransfereeSessionId: Integer; TransferToSessionId: Integer;
                                                lTransfererCallType: Integer; lTransfereeCallType: Integer;lTransferToCallType: Integer;
                                                const Transferer: WideString; const Transferee: WideString; const TransferTo: WideString);
        begin
        end;


        procedure TVaxServerCOM.OnCallSessionTransfering( nSessionId : integer; TransferType: Integer; CallType: Integer; StatusCode: Integer; const ReasonPhrase: WideString);
        begin
        end;

        procedure TVaxServerCOM.OnCallSessionTransferFailed( nSessionId : integer; TransferType: Integer; CallType: Integer; StatusCode: Integer; const ReasonPhrase: WideString);
        begin
        end;

        procedure TVaxServerCOM.OnCallSessionTransferTimeout( nSessionId : integer; TransferType: Integer; CallType: Integer);
        begin
        end;

        procedure TVaxServerCOM.OnCallSessionTransfered( nSessionId : integer; TransferType: Integer);
        begin
        end;

        procedure TVaxServerCOM.OnDigitDetectDTMF( nSessionId : integer;  sDigitDTMF : string);
        begin
        end;

        procedure TVaxServerCOM.OnOutgoingDiagnosticLog( sMsgSIP : string;  sToIP : string;  nToPort : integer);
        begin
        end;
        procedure TVaxServerCOM.OnIncomingDiagnosticLog( sMsgSIP : string;  sFromIP : string;  nFromPort : integer);
        begin
        end;

        procedure TVaxServerCOM.OnVaxTeleTick( nTickId : integer);
        begin
        end;

        procedure TVaxServerCOM.OnSendTimeOutVM( nMsgIdVM : integer);
        begin
        end;
        procedure TVaxServerCOM.OnSendSuccessVM( nMsgIdVM : integer);
        begin
        end;

        procedure TVaxServerCOM.OnCallSessionDialToneStart( nSessionId : integer;  nWaveId : integer);
        begin
        end;
        procedure TVaxServerCOM.OnCallSessionDialToneStop( nSessionId : integer;  nWaveId : integer);
        begin
        end;

        procedure TVaxServerCOM.OnCallSessionPlayWaveDone(nSessionId : Integer;  nWaveId : integer);
        begin
        end;
        procedure TVaxServerCOM.OnConferenceRoomPlayWaveDone(sRoomName : string; nWaveId : Integer);
        begin
        end;

        procedure TVaxServerCOM.OnCallSessionCreated(nSessionId : Integer;  nCallType : integer;  nReasonCode : integer);
        begin
        end;

        procedure TVaxServerCOM.OnCallSessionOpenCall(nSessionId : Integer;  nCallType : integer;  nPeerType : integer;  sPeerName : string);
        begin
        end;

        procedure TVaxServerCOM.OnCallSessionCloseCall(nSessionId : Integer;  nCallType : integer;  nPeerType : integer;  sPeerName : string);
        begin
        end;

        procedure TVaxServerCOM.OnCallSessionDetectedAMD(nSessionId : Integer;  nCallType : integer;  bIsHuman : Boolean);
        begin
        end;

        {///////////////////////////////////////////////////////////////////////////////
        ///////////////////     Functions
        ///////////////////////////////////////////////////////////////////////////////}

        constructor TVaxServerCOM.Create();
        begin
            if m_pVaxServerLibCOM = nil then
                m_pVaxServerLibCOM := inherited Create(Nil);
        end;

        procedure TVaxServerCOM.InvokeEvent(DispID: LongInt; var Params: TVariantArray);
        begin
          case DispID of
            -1: Exit;  // DISPID_UNKNOWN
            1: OnRegisterUser(Params[0] {const WideString},
                                 Params[1] {const WideString},
                                 Params[2] {const WideString},
                                 Params[3] {Integer});
            2: OnRegisterUserSuccess(Params[0] {const WideString});
            3: OnRegisterUserFail(Params[0] {const WideString});
            4: OnUnRegisterUser(Params[0] {const WideString});
            5: OnCallSessionOpen(Params[0] {Integer},
                                    Params[1] {const WideString},
                                    Params[2] {const WideString},
                                    Params[3] {const WideString},
                                    Params[4] {Integer},
                                    Params[5] {const WideString},
                                    Params[6] {const WideString},
                                    Params[7] {Integer});
            6: OnCallSessionFailed(Params[0] {Integer},
                                      Params[1] {Integer},
                                      Params[2] {Integer},
                                      Params[3] {const WideString});
            7: OnCallSessionConnected(Params[0] {Integer});
            8: OnCallSessionClosed(Params[0] {Integer},
                                      Params[1] {Integer},
                                      Params[2] {Integer});
            9: OnCallSessionOnHold(Params[0] {Integer},
                                      Params[1] {Integer});
            10: OnCallSessionOffHold(Params[0] {Integer},
                                       Params[1] {Integer});
            11: OnCallSessionTransferBlind(Params[0] {Integer},
                                             Params[1] {Integer},
                                             Params[2] {const WideString},
                                             Params[3] {const WideString},
                                             Params[4] {const WideString});
            12: OnCallSessionTransferConsult(Params[0] {Integer},
                                               Params[1] {Integer},
                                               Params[2] {Integer},
                                               Params[3] {Integer},
                                               Params[4] {Integer},
                                               Params[5] {Integer},
                                               Params[6] {const WideString},
                                               Params[7] {const WideString},
                                               Params[8] {const WideString});
            13: OnLineRegisterTrying(Params[0] {const WideString});
            14: OnLineRegisterFail(Params[0] {const WideString},
                                       Params[1] {Integer},
                                       Params[2] {const WideString});
            15: OnLineRegisterSuccess(Params[0] {const WideString});
            16: OnLineUnRegisterTrying(Params[0] {const WideString});
            17: OnLineUnRegisterFail(Params[0] {const WideString},
                                         Params[1] {Integer},
                                         Params[2] {const WideString});
            18: OnLineUnRegisterSuccess(Params[0] {const WideString});
            19: OnChatMessageText(Params[0] {Integer},
                                    Params[1] {const WideString},
                                    Params[2] {const WideString},
                                    Params[3] {const WideString},
                                    Params[4] {Integer},
                                    Params[5] {const WideString},
                                    Params[6] {const WideString},
                                    Params[7] {Integer});
            20: OnChatMessageTyping(Params[0] {Integer},
                                      Params[1] {const WideString},
                                      Params[2] {const WideString},
                                      Params[3] {Integer},
                                      Params[4] {Integer},
                                      Params[5] {const WideString},
                                      Params[6] {const WideString},
                                      Params[7] {Integer});
            21: OnChatStatusSubscribe(Params[0] {Integer},
                                        Params[1] {const WideString},
                                        Params[2] {const WideString},
                                        Params[3] {Integer},
                                        Params[4] {const WideString},
                                        Params[5] {const WideString},
                                        Params[6] {Integer});
            22: OnChatMessageSuccess(Params[0] {Integer});
            23: OnChatMessageFailure(Params[0] {Integer},
                                      Params[1] {Integer},
                                      Params[2] {const WideString});
            24: OnChatMessageTimeout(Params[0] {Integer});
            25: OnOutgoingDiagnosticLog(Params[0] {const WideString},
                                          Params[1] {const WideString},
                                          Params[2] {Integer});
            26: OnIncomingDiagnosticLog(Params[0] {const WideString},
                                          Params[1] {const WideString},
                                          Params[2] {Integer});
            27: OnDigitDetectDTMF(Params[0] {Integer},
                                    Params[1] {const WideString});
            28: OnVaxTeleTick(Params[0] {Integer});
            29: OnSendTimeoutVM(Params[0] {Integer});
            30: OnSendSuccessVM(Params[0] {Integer});
            31: OnCallSessionDialToneStart(Params[0] {Integer},
                                             Params[1] {Integer});
            32: OnCallSessionDialToneStop(Params[0] {Integer},
                                            Params[1] {Integer});
            33: OnCallSessionPlayWaveDone(Params[0] {Integer},
                                            Params[1] {Integer});
            34: OnConferenceRoomPlayWaveDone(Params[0] {const WideString},
                                               Params[1] {Integer});
            35: OnCallSessionConnecting(Params[0] {Integer},
                                          Params[1] {Integer},
                                          Params[2] {Integer},
                                          Params[3] {const WideString});
            36: OnCallSessionLost(Params[0] {Integer},
                                    Params[1] {Integer});
            37: OnCallSessionHangup(Params[0] {Integer},
                                      Params[1] {Integer});
            38: OnCallSessionTimeout(Params[0] {Integer},
                                       Params[1] {Integer});
            39: OnCallSessionCancelled(Params[0] {Integer});
            40: OnCallSessionTransfering(Params[0] {Integer},
                                      Params[1]  {Integer},
                                      Params[2] {Integer},
                                      Params[3] {Integer},
                                      Params[4] {const WideString});
            41: OnCallSessionTransferFailed(Params[0] {Integer},
                                      Params[1]  {Integer},
                                      Params[2] {Integer},
                                      Params[3] {Integer},
                                      Params[4] {const WideString});
            42: OnCallSessionTransferTimeout(Params[0] {Integer},
                                      Params[1]  {Integer},
                                      Params[2] {Integer});
            43: OnCallSessionTransfered(Params[0] {Integer},
                                      Params[1]  {Integer});
            44: OnCallSessionCreated(Params[0] {Integer},
                               Params[1] {Integer},
                               Params[2] {Integer});
            45: OnCallSessionOpenCall(Params[0] {Integer},
                                Params[1] {Integer},
                                Params[2] {Integer},
                                Params[3] {const WideString});
            46: OnCallSessionCloseCall(Params[0] {Integer},
                                 Params[1] {Integer},
                                 Params[2] {Integer},
                                 Params[3] {const WideString});
            47: OnCallSessionDetectedAMD(Params[0] {Integer},
                                   Params[1] {Integer},
                                   Params[2] {WordBool});
          end; {case DispID}

        end;

        procedure TVaxServerCOM.SetLicenseKey(sLicenseKey : string);
        begin
            Assert(m_pVaxServerLibCOM <> Nil);    //m_pVaxServerLibCOM is not NULL
            inherited SetLicenseKey(sLicenseKey);
        end;

        function TVaxServerCOM.Initialize(sDomainRealm : string;  sSIPListenIP : string; nSIPListenPort : integer ;  sRTPListenIP : string; nRTPListenPort : integer ) : Boolean;
        begin
            Assert(m_pVaxServerLibCOM <> Nil);    //m_pVaxServerLibCOM is not NULL
            Result := Boolean(inherited Initialize(sDomainRealm, sSIPListenIP, nSIPListenPort, sRTPListenIP, nRTPListenPort));
        end;

        procedure TVaxServerCOM.UnInitialize();
        begin
            Assert(m_pVaxServerLibCOM <> Nil);    //m_pVaxServerLibCOM is not NULL
            m_pVaxServerLibCOM.UnInitialize();
        end;

        function TVaxServerCOM.AddUser( sUserName : string;  sPassword : string;  sCodecList : string) : boolean;
        begin
            Result := Boolean(inherited AddUser(sUserName, sPassword, sCodecList));
        end;

        procedure TVaxServerCOM.RemoveUser( sUserName : string);
        begin
            inherited RemoveUser(sUserName);
        end;

        function TVaxServerCOM.AcceptRegister( sUserName : string) : boolean;
        begin
            Result := Boolean(inherited AcceptRegister(sUserName));
        end;

        function TVaxServerCOM.RejectRegister( sUserName : string; lStatusCode : integer;  sReasonPhrase : string) : boolean;
        begin
            Result := Boolean(inherited RejectRegister(sUserName, lStatusCode, sReasonPhrase));
        end;

        function TVaxServerCOM.AuthRegister( sUserName : string) : boolean;
        begin
            Result := Boolean(inherited AuthRegister(sUserName));
        end;

        function TVaxServerCOM.AddLine( sLineName : string;  sDisplayName : string;  sUserName : string;  sAuthUser : string;  sAuthPwd : string;  sDomainRealm : string;  sProxySIP : string;  sOutboundProxySIP : string;  sCodecList : string) : boolean;
        begin
            Result := Boolean(inherited AddLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sOutboundProxySIP, sCodecList));
        end;

        procedure TVaxServerCOM.RemoveLine( sLineName : string);
        begin
            inherited RemoveLine(sLineName);
        end;

        function TVaxServerCOM.RegisterLine( sLineName : string) : boolean;
        begin
            Result := Boolean(inherited RegisterLine(sLineName, 1800));
        end;

        function TVaxServerCOM.UnRegisterLine( sLineName : string) : boolean;
        begin
            Result := Boolean(inherited UnRegisterLine(sLineName));
        end;

        function TVaxServerCOM.AddDirectProxySIP( sProxyName : string;  sAuthLogin : string;  sAuthPwd : string;  sDomainRealm : string;  sProxyIP : string; lProxyPort : integer ;  sCodecList : string) : boolean;
        begin
            Result := Boolean(inherited AddDirectProxySIP(sProxyName, sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP, lProxyPort, sCodecList));
        end;

        procedure TVaxServerCOM.RemoveDirectProxySIP( sProxyName : string);
        begin
            inherited RemoveDirectProxySIP(sProxyName);
        end;

        function TVaxServerCOM.AcceptCallSession(lSessionId : integer ;  sCallerName : string;  sCallerId : string;  sDialNo : string;  nToPeerType : integer ;  sToPeerName : string; lTimeOut : integer ) : boolean;
        begin
            Result := Boolean(inherited AcceptCallSession(lSessionId, sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, lTimeOut));
        end;

        procedure TVaxServerCOM.RejectCallSession(lSessionId : integer ; lStatusCode : integer ;  sReasonPhrase : string);
        begin
            inherited RejectCallSession(lSessionId, lStatusCode, sReasonPhrase);
        end;

        procedure TVaxServerCOM.CloseCallSession(lSessionId : integer );
        begin
            inherited CloseCallSession(lSessionId);
        end;

        function TVaxServerCOM.CreateCallSession( sCallerName, sCallerId, sDialNo : string;  nToPeerType : integer ;  sToPeerName : string; lTimeOut : integer ) : integer;
        begin
            Result := inherited CreateCallSession(sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, lTimeOut);
        end;

        function TVaxServerCOM.OpenCallSession( sCallerName, sCallerId, sDialNo : string;  nToPeerType : integer ;  sToPeerName : string; lTimeOut : integer ) : integer;
        begin
            Result := inherited OpenCallSession(sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, lTimeOut);
        end;

        function TVaxServerCOM.AcceptTransferBlind(lTransfererSessionId : integer ;  sCallerName : string;  sCallerId : string;  sTransferTo : string;  nToPeerType : integer ;  sToPeerName : string; lTimeOut : integer) : Integer;
        begin
            Result := inherited AcceptTransferBlind(lTransfererSessionId, sCallerName, sCallerId, sTransferTo, nToPeerType, sToPeerName, lTimeOut);
        end;

        function TVaxServerCOM.AcceptTransferConsult(lTransfererSessionId : integer ; lTransferToSessionId : integer ) : Integer;
        begin
            Result := inherited AcceptTransferConsult(lTransfererSessionId, lTransferToSessionId);
        end;

        procedure TVaxServerCOM.RejectTransfer(lSessionId : integer );
        begin
            inherited RejectTransfer(lSessionId);
        end;

        function TVaxServerCOM.PlayWaveStartToCallSession(lSessionId : integer ; lWaveId : integer ; bLoop : boolean) : Boolean;
        begin
            Result := Boolean(inherited PlayWaveStartToCallSession(lSessionId, lWaveId, bLoop));
        end;

        function TVaxServerCOM.PlayWaveStopToCallSession(lSessionId : integer ) : boolean;
        begin
            Result := Boolean(inherited PlayWaveStopToCallSession(lSessionId));
        end;

        function TVaxServerCOM.RecordWaveStartToCallSession(lSessionId : integer ;  sFileName : string) : boolean;
        begin
            Result := Boolean(inherited RecordWaveStartToCallSession(lSessionId, sFileName));
        end;

        function TVaxServerCOM.RecordWaveStopToCallSession(lSessionId : integer ) : boolean;
        begin
            Result := Boolean(inherited RecordWaveStopToCallSession(lSessionId));
        end;

        function TVaxServerCOM.RecordWavePauseToCallSession(lSessionId : integer ; bEnable : boolean) : boolean;
        begin
            Result := Boolean(inherited RecordWavePauseToCallSession(lSessionId, bEnable));
        end;

        function TVaxServerCOM.LoadWaveFile(sFileName : string) : integer;
        begin
            Result := Int32(inherited LoadWaveFile(sFileName));
        end;

        procedure TVaxServerCOM.UnLoadWaveFile(lWaveId : integer);
        begin
            inherited UnLoadWaveFile(lWaveId);
        end;

        function TVaxServerCOM.LoadMusicHold( sFileName : string) : boolean;
        begin
            Result := Boolean(inherited LoadMusicHold(sFileName));
        end;

        procedure TVaxServerCOM.UnLoadMusicHold();
        begin
            inherited UnLoadMusicHold();
        end;

        function TVaxServerCOM.AcceptOnHoldRequest(lSessionId  : integer ) : boolean;
        begin
            Result := Boolean(inherited AcceptOnHoldRequest(lSessionId));
        end;

        function TVaxServerCOM.AcceptOffHoldRequest(lSessionId : integer ) : boolean;
        begin
            Result := Boolean(inherited AcceptOffHoldRequest(lSessionId));
        end;

        function TVaxServerCOM.AcceptChatMessage(lChatMsgId : integer ;  nToPeerType : integer ;  sToPeerName : string) : boolean;
        begin
            Result := Boolean(inherited AcceptChatMessage(lChatMsgId, nToPeerType, sToPeerName));
        end;

        procedure TVaxServerCOM.RejectChatMessage(lChatMsgId : integer ; lStatusCode : integer ;  sReasonPhrase : string);
        begin
            inherited RejectChatMessage(lChatMsgId, lStatusCode, sReasonPhrase);
        end;

        function TVaxServerCOM.AcceptChatStatusSubscribe(lStatusSubscribe : integer ;  sMsgFrom : string;  sMsgTo : string;  nToPeerType : integer ;  sToPeerName : string) : boolean;
        begin
            Result := Boolean(inherited AcceptChatStatusSubscribe(lStatusSubscribe, sMsgFrom, sMsgTo, nToPeerType, sToPeerName));
        end;

        procedure TVaxServerCOM.RejectChatStatusSubscribe(lStatusSubscribe : integer ;  sMsgFrom : string;  sMsgTo : string);
        begin
            inherited RejectChatStatusSubscribe(lStatusSubscribe, sMsgFrom, sMsgTo);
        end;

        function TVaxServerCOM.OpenConferenceRoom( sRoomName : string) : boolean;
        begin
            Result := Boolean(inherited OpenConferenceRoom(sRoomName));
        end;

        procedure TVaxServerCOM.CloseConferenceRoom( sRoomName : string);
        begin
            inherited CloseConferenceRoom(sRoomName);
        end;

        function TVaxServerCOM.AddCallSessionToConferenceRoom( sRoomName : string;  lSessionId : integer ;  nType : integer ) : boolean;
        begin
            Result := Boolean(inherited AddCallSessionToConferenceRoom(sRoomName, lSessionId, nType));
        end;

        function TVaxServerCOM.RemoveCallSessionFromConferenceRoom( lSessionId : integer ) : boolean;
        begin
            Result := Boolean(inherited RemoveCallSessionFromConferenceRoom(lSessionId));
        end;

        function TVaxServerCOM.PlayWaveStartToConferenceRoom( sRoomName : string;  lWaveId : integer ;  bLoop : boolean) : boolean;
        begin
            Result := Boolean(inherited PlayWaveStartToConferenceRoom(sRoomName, lWaveId, bLoop));
        end;

        function TVaxServerCOM.PlayWaveStopToConferenceRoom( sRoomName : string) : boolean;
        begin
            Result := Boolean(inherited PlayWaveStopToConferenceRoom(sRoomName));
        end;

        function TVaxServerCOM.RecordWaveStartToConferenceRoom( sRoomName : string;  sFileName : string) : boolean;
        begin
            Result := Boolean(inherited RecordWaveStartToConferenceRoom(sRoomName, sFileName));
        end;

        function TVaxServerCOM.RecordWaveStopToConferenceRoom( sRoomName : string) : boolean;
        begin
            Result := Boolean(inherited RecordWaveStopToConferenceRoom(sRoomName));
        end;

        function TVaxServerCOM.RecordWavePauseToConferenceRoom( sRoomName : string; bEnable : boolean) : boolean;
        begin
            Result := Boolean(inherited RecordWavePauseToConferenceRoom(sRoomName, bEnable));
        end;

        function TVaxServerCOM.VoiceSessionLost(bEnable : boolean; lTimeOut : integer ) : boolean;
        begin
            Result := Boolean(inherited VoiceSessionLost(bEnable, lTimeOut));
        end;

        function TVaxServerCOM.SendInfoVM( sUserLogin : string;  nNewMsgCount : integer ;  nOldMsgCount : integer ; bMsgWaiting : Boolean ) : integer;
        begin
            Result := Integer(inherited SendInfoVM(sUserLogin, nNewMsgCount, nOldMsgCount, bMsgWaiting));
        end;

        function TVaxServerCOM.StartVaxTeleTick(lTickId : integer ; lElapse : integer ) : boolean;
        begin
            Result := Boolean(inherited StartVaxTeleTick(lTickId, lElapse));
        end;

        function TVaxServerCOM.StopVaxTeleTick(lTickId : integer ) : boolean;
        begin
            Result := Boolean(inherited StopVaxTeleTick(lTickId));
        end;

        function TVaxServerCOM.SetUserAgentName( sName : string) : boolean;
        begin
            Result := Boolean(inherited SetUserAgentName(sName));
        end;

        function TVaxServerCOM.GetUserAgentName() : string;
        begin
            Result := inherited GetUserAgentName();
        end;

        function TVaxServerCOM.SetSessionNameSDP( sName : string) : boolean;
        begin
            Result := Boolean(inherited SetSessionNameSDP(sName));
        end;

        function TVaxServerCOM.GetSessionNameSDP() : string;
        begin
            Result := inherited GetSessionNameSDP();
        end;

        function TVaxServerCOM.SendDTMFCallSession( lSessionId : integer ;  nTypeDTMF : integer ;  nDigit : integer ) : boolean;
        begin
            Result := Boolean(inherited SendDTMFCallSession(lSessionId, nDigit, nTypeDTMF));
        end;

        function TVaxServerCOM.DetectDTMFCallSession( lSessionId : integer ;  nTypeDTMF : integer ; bEnable : boolean;  nTimeout : integer ) : boolean;
        begin
            Result := Boolean(inherited DetectDTMFCallSession(lSessionId, nTypeDTMF, bEnable, nTimeout));
        end;

        function TVaxServerCOM.GetVaxObjectError() : integer;
        begin
            Result := Integer(inherited GetVaxObjectError());
        end;

        function TVaxServerCOM.DialToneToCallSession( bEnable : boolean;  lSessionId : integer ;  lWaveId : integer ) : boolean;
        begin
            Result := Boolean(inherited DialToneToCallSession(bEnable, lSessionId, lWaveId));
        end;

        function TVaxServerCOM.DiagnosticLogSIP( bInbound : boolean;  bOutbound : boolean) : boolean;
        begin
            Result := Boolean(inherited DiagnosticLogSIP(bInbound, bOutbound));
        end;

end.
