unit VaxServerRoot;

interface

//uses
//    VaxTeleServerCOMLib_TLB;

type TVaxServerRoot = class

    public

        constructor Create();

        procedure OnLineRegisterTrying( sLineName : string); virtual;
        procedure OnLineRegisterFail( sLineName : string; nStatusCode : integer;  sReasonPhrase : string); virtual;
        procedure OnLineRegisterSuccess( sLineName : string); virtual;
        procedure OnLineUnRegisterTrying( sLineName : string); virtual;
        procedure OnLineUnRegisterFail( sLineName : string; nStatusCode : integer;  sReasonPhrase : string); virtual;
        procedure OnLineUnRegisterSuccess( sLineName : string); virtual;

        procedure OnUnRegisterUser( sUserLogin : string); virtual;
        procedure OnRegisterUser( sUserLogin : string;  sDomain : string;  sFromIP : string; nFromPort : integer); virtual;
        procedure OnRegisterUserSuccess( sUserLogin : string); virtual;
        procedure OnRegisterUserFail( sUserLogin : string); virtual;

        procedure OnChatMessageText( nChatMsgId : integer;  sMsgFrom : string;  sMsgTo : string;  sMsgText : string;  nFromPeerType : integer;  sFromPeerName : string;  sFromIP : string;  nFromPort : integer); virtual;
        procedure OnChatMessageTyping( nChatMsgId : integer;  sMsgFrom : string;  sMsgTo : string;  IsTypingStart : integer;  nFromPeerType : integer;  sFromPeerName : string;  sFromIP : string;  nFromPort : integer); virtual;
        procedure OnChatStatusSubscribe( nSubscrbId : integer;  sMsgFrom : string;  sMsgTo : string;  nFromPeerType : integer;  sFromPeerName : string;  sFromIP : string;  nFromPort : integer); virtual;

        procedure OnChatMessageSuccess( nChatMsgId : integer); virtual;
        procedure OnChatMessageFailure(ChatMsgId: Integer; StatusCode: Integer; const ReasonPhrase: WideString); virtual;
        procedure OnChatMessageTimeout( nChatMsgId : integer); virtual;

        procedure OnCallSessionOpen( nSessionId : integer;  sCallerName : string;  sCallerId : string;  sDialNo : string;  nFromPeerType : integer;  sFromPeerName : string;  sFromIP : string;  nFromPort : integer); virtual;
        procedure OnCallSessionFailed(nSessionId : integer; nCallType: Integer; nStatusCode: Integer; const sReasonPhrase: string); virtual;
        procedure OnCallSessionConnected( nSessionId : integer); virtual;
        procedure OnCallSessionClosed( nSessionId : integer; nCallType: Integer; nReasonCode: Integer); virtual;

        procedure OnCallSessionOnHold( nSessionId : integer; nCallType: Integer); virtual;
        procedure OnCallSessionOffHold( nSessionId : integer; nCallType: Integer); virtual;

        procedure OnCallSessionTransferBlind( TransfererSessionId: Integer; lTransfererCallType: Integer; const Transferer: string;
                                            const Transferee: string; const TransferTo: string); virtual;
        procedure OnCallSessionTransferConsult( TransfererSessionId: Integer; TransfereeSessionId: Integer; TransferToSessionId: Integer;
                                                lTransfererCallType: Integer; lTransfereeCallType: Integer;lTransferToCallType: Integer;
                                                const Transferer: string; const Transferee: string; const TransferTo: string); virtual;

        procedure OnCallSessionTransfering( nSessionId : integer; TransferType: Integer; CallType: Integer; StatusCode: Integer; const ReasonPhrase: WideString); virtual;
        procedure OnCallSessionTransferFailed( nSessionId : integer; TransferType: Integer; CallType: Integer; StatusCode: Integer; const ReasonPhrase: WideString); virtual;
        procedure OnCallSessionTransferTimeout( nSessionId : integer; TransferType: Integer; CallType: Integer); virtual;
        procedure OnCallSessionTransfered( nSessionId : integer; TransferType: Integer); virtual;

        procedure OnCallSessionConnecting(nSessionId: Integer; nCallType: Integer; nStatusCode: Integer; const sReasonPhrase: string); virtual;
        procedure OnCallSessionLost(nSessionId: Integer; nCallType: Integer); virtual;
        procedure OnCallSessionHangup(nSessionId: Integer; nCallType: Integer); virtual;
        procedure OnCallSessionTimeout(nSessionId: Integer; nCallType: Integer); virtual;
        procedure OnCallSessionCancelled(nSessionId: Integer);  virtual;

        procedure OnDigitDetectDTMF( nSessionId : integer;  sDigitDTMF : string); virtual;

        procedure OnOutgoingDiagnosticLog( sMsgSIP : string;  sToIP : string;  nToPort : integer); virtual;
        procedure OnIncomingDiagnosticLog( sMsgSIP : string;  sFromIP : string;  nFromPort : integer); virtual;

        procedure OnVaxTeleTick( nTickId : integer); virtual;

        procedure OnVaxTeleError(nErrorCode : Integer); virtual;

        procedure OnSendTimeOutVM( nMsgIdVM : integer); virtual;
        procedure OnSendSuccessVM( nMsgIdVM : integer); virtual;

        procedure OnCallSessionDialToneStart( nSessionId : integer;  nWaveId : integer); virtual;
        procedure OnCallSessionDialToneStop( nSessionId : integer;  nWaveId : integer); virtual;

        procedure OnCallSessionCreated(nSessionId : Integer;  nCallType : integer;  nReasonCode : integer);  virtual;
        procedure OnCallSessionOpenCall(nSessionId : Integer;  nCallType : integer;  nPeerType : integer;  sPeerName : string); virtual;
        procedure OnCallSessionCloseCall(nSessionId : Integer;  nCallType : integer;  nPeerType : integer;  sPeerName : string); virtual;
        procedure OnCallSessionDetectedAMD(nSessionId : Integer;  nCallType : integer;  bIsHuman : Boolean);  virtual;

        {///////////////////////////////////////////////////////////////////////////////
        ///////////////////     Functions
        ///////////////////////////////////////////////////////////////////////////////}

        public

        procedure SetLicenseKey(sLicenseKey : string);

        function Initialize(sDomainRealm : string;  sSIPListenIP : string; nSIPListenPort : integer ;  sRTPListenIP : string; nRTPListenPort : integer ) : boolean;
        procedure UnInitialize();

        function AddUser( sUserName : string;  sPassword : string;  sCodecList : string) : boolean;
        procedure RemoveUser( sUserName : string);

        function AcceptRegister( sUserName : string) : boolean;
        function RejectRegister( sUserName : string; lStatusCode : integer;  sReasonPhrase : string) : boolean;
        function AuthRegister( sUserName : string) : boolean;

        function AddLine( sLineName : string;  sDisplayName : string;  sUserName : string;  sAuthUser : string;  sAuthPwd : string;  sDomainRealm : string;  sProxySIP : string;  sOutboundProxySIP : string;  sCodecList : string) : boolean;
        procedure RemoveLine( sLineName : string);

        function RegisterLine( sLineName : string) : boolean;
        function UnRegisterLine( sLineName : string) : boolean;

        function AddDirectProxySIP( sProxyName : string;  sAuthLogin : string;  sAuthPwd : string;  sDomainRealm : string;  sProxyIP : string; lProxyPort : integer ;  sCodecList : string) : boolean;
        procedure RemoveDirectProxySIP( sProxyName : string);

        function AcceptCallSession(lSessionId : integer ;  sCallerName : string;  sCallerId : string;  sDialNo : string;  nToPeerType : integer ;  sToPeerName : string; lTimeOut : integer ) : boolean;
        procedure RejectCallSession(lSessionId : integer ; lStatusCode : integer ;  sReasonPhrase : string);
        procedure CloseCallSession(lSessionId : integer );

        function CreateCallSession( sCallerName : string;  sCallerId : string;  sDialNo : string;  nToPeerType : integer ;  sToPeerName : string; lTimeOut : integer ) : integer;
        function OpenCallSession( sCallerName : string;  sCallerId : string;  sDialNo : string;  nToPeerType : integer ;  sToPeerName : string; lTimeOut : integer ) : integer;

        function AcceptTransferBlind(lTransfererSessionId : integer ;  sCallerName : string;  sCallerId : string;  sTransferTo : string;  nToPeerType : integer ;  sToPeerName : string; lTimeOut : integer) : Integer;
        function AcceptTransferConsult(lTransfererSessionId : integer ; lTransferToSessionId : integer ) : Integer;
        procedure RejectTransfer(lSessionId : integer );

        function PlayWaveStartToCallSession(lSessionId : integer ; lWaveId : integer ; bLoop : boolean) : boolean;
        function PlayWaveStopToCallSession(lSessionId : integer ) : boolean;

        function RecordWaveStartToCallSession(lSessionId : integer ;  sFileName : string) : boolean;
        function RecordWaveStopToCallSession(lSessionId : integer ) : boolean;
        function RecordWavePauseToCallSession(lSessionId : integer ; bEnable : boolean) : boolean;

        function LoadWaveFile( sFileName : string) : integer;
        procedure UnLoadWaveFile(lWaveId : integer);

        function LoadMusicHold( sFileName : string) : boolean;
        procedure UnLoadMusicHold();

        function AcceptOnHoldRequest(lSessionId  : integer ) : boolean;
        function AcceptOffHoldRequest(lSessionId : integer ) : boolean;

        function AcceptChatMessage(lChatMsgId : integer ;  nToPeerType : integer ;  sToPeerName : string) : boolean;
        procedure RejectChatMessage(lChatMsgId : integer ; lStatusCode : integer ;  sReasonPhrase : string);

        function AcceptChatStatusSubscribe(lStatusSubscribe : integer ;  sMsgFrom : string;  sMsgTo : string;  nToPeerType : integer ;  sToPeerName : string) : boolean;
        procedure RejectChatStatusSubscribe(lStatusSubscribe : integer ;  sMsgFrom : string;  sMsgTo : string);

        function OpenConferenceRoom( sRoomName : string) : boolean;
        procedure CloseConferenceRoom( sRoomName : string);

        function AddCallSessionToConferenceRoom( sRoomName : string;  lSessionId : integer ;  nType : integer ) : boolean;
        function RemoveCallSessionFromConferenceRoom( lSessionId : integer ) : boolean;

        function PlayWaveStartToConferenceRoom( sRoomName : string;  lWaveId : integer ;  bLoop : boolean) : boolean;
        function PlayWaveStopToConferenceRoom( sRoomName : string) : boolean;

        function RecordWaveStartToConferenceRoom( sRoomName : string;  sFileName : string) : boolean;
        function RecordWaveStopToConferenceRoom( sRoomName : string) : boolean;
        function RecordWavePauseToConferenceRoom( sRoomName : string; bEnable : boolean) : boolean;

        function VoiceSessionLost(bEnable : boolean; lTimeOut : integer ) : boolean;

        function SendInfoVM( sUserLogin : string;  nNewMsgCount : integer ;  nOldMsgCount : integer ; bMsgWaiting : Boolean ) : integer;

        function StartVaxTeleTick(lTickId : integer ; lElapse : integer ) : boolean;
        function StopVaxTeleTick(lTickId : integer ) : boolean;

        function SetUserAgentName( sName : string) : boolean;
        function GetUserAgentName() : string;

        function SetSessionNameSDP( sName : string) : boolean;
        function GetSessionNameSDP() : string;

        function SendDTMFCallSession( lSessionId : integer ;  nTypeDTMF : integer ;  nDigit : integer ) : boolean;
        function DetectDTMFCallSession( lSessionId : integer ;  nTypeDTMF : integer ; bEnable : boolean;  nTimeout : integer ) : boolean;

        function GetVaxObjectError() : integer;

        function DialToneToCallSession( bEnable : boolean;  lSessionId : integer ;  lWaveId : integer ) : boolean;
        function DiagnosticLogSIP( bInbound : boolean;  bOutbound : boolean) : boolean;

        procedure AddRef(nClassId : integer);
end;

implementation

uses
    VaxServerExCOM;

var
    m_pVaxServerExCOM : TVaxServerExCOM;
        /////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////        Events
        /////////////////////////////////////////////////////////////////////////////////////////////

        // Line events

        procedure TVaxServerRoot.OnLineRegisterTrying( sLineName : string);
        begin
        end;

        procedure TVaxServerRoot.OnLineRegisterFail( sLineName : string; nStatusCode : integer;  sReasonPhrase : string);
        begin
        end;

        procedure TVaxServerRoot.OnLineRegisterSuccess( sLineName : string);
        begin
        end;

        procedure TVaxServerRoot.OnLineUnRegisterTrying( sLineName : string);
        begin
        end;

        procedure TVaxServerRoot.OnLineUnRegisterFail( sLineName : string; nStatusCode : integer;  sReasonPhrase : string);
        begin
        end;

        procedure TVaxServerRoot.OnLineUnRegisterSuccess( sLineName : string);
        begin
        end;

        // User Events

        procedure TVaxServerRoot.OnUnRegisterUser( sUserLogin : string);
        begin
        end;

        procedure TVaxServerRoot.OnRegisterUser( sUserLogin : string;  sDomain : string;  sFromIP : string; nFromPort : integer);
        begin
        end;

        procedure TVaxServerRoot.OnRegisterUserSuccess( sUserLogin : string);
        begin
        end;

        procedure TVaxServerRoot.OnRegisterUserFail( sUserLogin : string);
        begin
        end;

        // Chat Message Events

        procedure TVaxServerRoot.OnChatMessageText( nChatMsgId : integer;  sMsgFrom : string;  sMsgTo : string;  sMsgText : string;  nFromPeerType : integer;  sFromPeerName : string;  sFromIP : string;  nFromPort : integer);
        begin
        end;

        procedure TVaxServerRoot.OnChatMessageTyping( nChatMsgId : integer;  sMsgFrom : string;  sMsgTo : string;  IsTypingStart : integer;  nFromPeerType : integer;  sFromPeerName : string;  sFromIP : string;  nFromPort : integer);
        begin
        end;
        procedure TVaxServerRoot.OnChatStatusSubscribe( nSubscrbId : integer;  sMsgFrom : string;  sMsgTo : string;  nFromPeerType : integer;  sFromPeerName : string;  sFromIP : string;  nFromPort : integer);
        begin
        end;

        procedure TVaxServerRoot.OnChatMessageSuccess( nChatMsgId : integer);
        begin
        end;

        procedure TVaxServerRoot.OnChatMessageFailure(ChatMsgId: Integer; StatusCode: Integer; const ReasonPhrase: WideString);
        begin
        end;

        procedure TVaxServerRoot.OnChatMessageTimeout( nChatMsgId : integer);
        begin
        end;

        // Call Session Events

        procedure TVaxServerRoot.OnCallSessionOpen( nSessionId : integer;  sCallerName : string;  sCallerId : string;  sDialNo : string;  nFromPeerType : integer;  sFromPeerName : string;  sFromIP : string;  nFromPort : integer);
        begin
        end;

        procedure TVaxServerRoot.OnCallSessionFailed(nSessionId : integer; nCallType: Integer; nStatusCode: Integer; const sReasonPhrase: string);
        begin
        end;

        procedure TVaxServerRoot.OnCallSessionConnected( nSessionId : integer);
        begin
        end;

        procedure TVaxServerRoot.OnCallSessionClosed( nSessionId : integer; nCallType: Integer; nReasonCode: Integer);
        begin
        end;

        procedure TVaxServerRoot.OnCallSessionOnHold( nSessionId : integer; nCallType: Integer);
        begin
        end;

        procedure TVaxServerRoot.OnCallSessionOffHold( nSessionId : integer; nCallType: Integer);
        begin
        end;

        // Transfer Events

        procedure TVaxServerRoot.OnCallSessionTransferBlind(TransfererSessionId: Integer; lTransfererCallType: Integer; const Transferer: string;
                                            const Transferee: string; const TransferTo: string);
        begin
        end;

        procedure TVaxServerRoot.OnCallSessionTransferConsult(TransfererSessionId: Integer; TransfereeSessionId: Integer; TransferToSessionId: Integer;
                                                lTransfererCallType: Integer; lTransfereeCallType: Integer;lTransferToCallType: Integer;
                                                const Transferer: string; const Transferee: string; const TransferTo: string);
        begin
        end;

        procedure TVaxServerRoot.OnCallSessionTransfering( nSessionId : integer; TransferType: Integer; CallType: Integer; StatusCode: Integer; const ReasonPhrase: WideString);
        begin
        end;

        procedure TVaxServerRoot.OnCallSessionTransferFailed( nSessionId : integer; TransferType: Integer; CallType: Integer; StatusCode: Integer; const ReasonPhrase: WideString);
        begin
        end;

        procedure TVaxServerRoot.OnCallSessionTransferTimeout( nSessionId : integer; TransferType: Integer; CallType: Integer);
        begin
        end;

        procedure TVaxServerRoot.OnCallSessionTransfered( nSessionId : integer; TransferType: Integer);
        begin
        end;

        procedure TVaxServerRoot.OnCallSessionConnecting(nSessionId: Integer; nCallType: Integer; nStatusCode: Integer; const sReasonPhrase: string);
        begin
        end;
        procedure TVaxServerRoot.OnCallSessionLost(nSessionId: Integer; nCallType: Integer);
        begin
        end;
        procedure TVaxServerRoot.OnCallSessionHangup(nSessionId: Integer; nCallType: Integer);
        begin
        end;
        procedure TVaxServerRoot.OnCallSessionTimeout(nSessionId: Integer; nCallType: Integer);
        begin
        end;
        procedure TVaxServerRoot.OnCallSessionCancelled(nSessionId: Integer);
        begin
        end;


        // Misc Events

        procedure TVaxServerRoot.OnDigitDetectDTMF( nSessionId : integer;  sDigitDTMF : string);
        begin
        end;

        procedure TVaxServerRoot.OnOutgoingDiagnosticLog( sMsgSIP : string;  sToIP : string;  nToPort : integer);
        begin
        end;

        procedure TVaxServerRoot.OnIncomingDiagnosticLog( sMsgSIP : string;  sFromIP : string;  nFromPort : integer);
        begin
        end;

        procedure TVaxServerRoot.OnVaxTeleTick( nTickId : integer);
        begin
        end;

        procedure TVaxServerRoot.OnVaxTeleError(nErrorCode : Integer);
        begin

        end;

        procedure TVaxServerRoot.OnSendTimeOutVM( nMsgIdVM : integer);
        begin
        end;

        procedure TVaxServerRoot.OnSendSuccessVM( nMsgIdVM : integer);
        begin
        end;

        // Dial Tone Events

        procedure TVaxServerRoot.OnCallSessionDialToneStart( nSessionId : integer;  nWaveId : integer);
        begin
        end;

        procedure TVaxServerRoot.OnCallSessionDialToneStop( nSessionId : integer;  nWaveId : integer);
        begin
        end;

        procedure TVaxServerRoot.OnCallSessionCreated(nSessionId : Integer;  nCallType : integer;  nReasonCode : integer);
        begin
        end;

        procedure TVaxServerRoot.OnCallSessionOpenCall(nSessionId : Integer;  nCallType : integer;  nPeerType : integer;  sPeerName : string);
        begin
        end;

        procedure TVaxServerRoot.OnCallSessionCloseCall(nSessionId : Integer;  nCallType : integer;  nPeerType : integer;  sPeerName : string);
        begin
        end;

        procedure TVaxServerRoot.OnCallSessionDetectedAMD(nSessionId : Integer;  nCallType : integer;  bIsHuman : Boolean);
        begin
        end;

        {///////////////////////////////////////////////////////////////////////////////
        ///////////////////     Functions
        ///////////////////////////////////////////////////////////////////////////////}

        constructor TVaxServerRoot.Create();

        begin

            if(m_pVaxServerExCOM = nil) then
                m_pVaxServerExCOM := TVaxServerExCOM.Create();
        end;

        procedure TVaxServerRoot.AddRef(nClassId : integer);
        begin
            m_pVaxServerExCOM.AddRef(self, nClassId);
        end;

        procedure TVaxServerRoot.SetLicenseKey(sLicenseKey : string);
        begin
            m_pVaxServerExCOM.SetLicenseKey(sLicenseKey);
        end;

        function TVaxServerRoot.Initialize(sDomainRealm : string;  sSIPListenIP : string; nSIPListenPort : integer ;  sRTPListenIP : string; nRTPListenPort : integer ) : boolean;
        begin
            Result := m_pVaxServerExCOM.Initialize(sDomainRealm, sSIPListenIP, nSIPListenPort, sRTPListenIP, nRTPListenPort);
        end;

        procedure TVaxServerRoot.UnInitialize();
        begin
            m_pVaxServerExCOM.UnInitialize();
        end;

        function TVaxServerRoot.AddUser( sUserName : string;  sPassword : string;  sCodecList : string) : boolean;
        begin
            Result := m_pVaxServerExCOM.AddUser(sUserName, sPassword, sCodecList);
        end;

        procedure TVaxServerRoot.RemoveUser( sUserName : string);
        begin
            m_pVaxServerExCOM.RemoveUser(sUserName);
        end;

        function TVaxServerRoot.AcceptRegister( sUserName : string) : boolean;
        begin
            Result := m_pVaxServerExCOM.AcceptRegister(sUserName);
        end;

        function TVaxServerRoot.RejectRegister( sUserName : string; lStatusCode : integer;  sReasonPhrase : string) : boolean;
        begin
            Result := m_pVaxServerExCOM.RejectRegister(sUserName, lStatusCode, sReasonPhrase);
        end;

        function TVaxServerRoot.AuthRegister( sUserName : string) : boolean;
        begin
            Result := m_pVaxServerExCOM.AuthRegister(sUserName);
        end;

        function TVaxServerRoot.AddLine( sLineName : string;  sDisplayName : string;  sUserName : string;  sAuthUser : string;  sAuthPwd : string;  sDomainRealm : string;  sProxySIP : string;  sOutboundProxySIP : string;  sCodecList : string) : boolean;
        begin
            Result := m_pVaxServerExCOM.AddLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sOutboundProxySIP, sCodecList);
        end;

        procedure TVaxServerRoot.RemoveLine( sLineName : string);
        begin
            m_pVaxServerExCOM.RemoveLine(sLineName);
        end;

        function TVaxServerRoot.RegisterLine( sLineName : string) : boolean;
        begin
            Result := m_pVaxServerExCOM.RegisterLine(sLineName);
        end;

        function TVaxServerRoot.UnRegisterLine( sLineName : string) : boolean;
        begin
            Result := m_pVaxServerExCOM.UnRegisterLine(sLineName);
        end;

        function TVaxServerRoot.AddDirectProxySIP( sProxyName : string;  sAuthLogin : string;  sAuthPwd : string;  sDomainRealm : string;  sProxyIP : string; lProxyPort : integer ;  sCodecList : string) : boolean;
        begin
            Result := m_pVaxServerExCOM.AddDirectProxySIP(sProxyName, sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP, lProxyPort, sCodecList);
        end;

        procedure TVaxServerRoot.RemoveDirectProxySIP( sProxyName : string);
        begin
            m_pVaxServerExCOM.RemoveDirectProxySIP(sProxyName);
        end;

        function TVaxServerRoot.AcceptCallSession(lSessionId : integer ;  sCallerName : string;  sCallerId : string;  sDialNo : string;  nToPeerType : integer ;  sToPeerName : string; lTimeOut : integer ) : boolean;
        begin
            Result := m_pVaxServerExCOM.AcceptCallSession(lSessionId, sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, lTimeOut);
        end;

        procedure TVaxServerRoot.RejectCallSession(lSessionId : integer ; lStatusCode : integer ;  sReasonPhrase : string);
        begin
            m_pVaxServerExCOM.RejectCallSession(lSessionId, lStatusCode, sReasonPhrase);
        end;

        procedure TVaxServerRoot.CloseCallSession(lSessionId : integer );
        begin
            m_pVaxServerExCOM.CloseCallSession(lSessionId);
        end;

        function TVaxServerRoot.CreateCallSession( sCallerName : string;  sCallerId : string;  sDialNo : string;  nToPeerType : integer ;  sToPeerName : string; lTimeOut : integer ) : integer;
        begin
            Result := m_pVaxServerExCOM.CreateCallSession(sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, lTimeOut);
        end;

        function TVaxServerRoot.OpenCallSession( sCallerName : string;  sCallerId : string;  sDialNo : string;  nToPeerType : integer ;  sToPeerName : string; lTimeOut : integer ) : integer;
        begin
            Result := m_pVaxServerExCOM.OpenCallSession(sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, lTimeOut);
        end;

        function TVaxServerRoot.AcceptTransferBlind(lTransfererSessionId : integer ;  sCallerName : string;  sCallerId : string;  sTransferTo : string;  nToPeerType : integer ;  sToPeerName : string; lTimeOut : integer) : Integer;
        begin
            Result := m_pVaxServerExCOM.AcceptTransferBlind(lTransfererSessionId, sCallerName, sCallerId, sTransferTo, nToPeerType, sToPeerName, lTimeOut);
        end;

        function TVaxServerRoot.AcceptTransferConsult(lTransfererSessionId : integer ; lTransferToSessionId : integer ) : Integer;
        begin
            Result := m_pVaxServerExCOM.AcceptTransferConsult(lTransfererSessionId, lTransferToSessionId);
        end;

        procedure TVaxServerRoot.RejectTransfer(lSessionId : integer );
        begin
            m_pVaxServerExCOM.RejectTransfer(lSessionId);
        end;

        function TVaxServerRoot.PlayWaveStartToCallSession(lSessionId : integer ; lWaveId : integer ; bLoop : boolean) : boolean;
        begin
            Result := m_pVaxServerExCOM.PlayWaveStartToCallSession(lSessionId, lWaveId, bLoop);
        end;

        function TVaxServerRoot.PlayWaveStopToCallSession(lSessionId : integer ) : boolean;
        begin
            Result := m_pVaxServerExCOM.PlayWaveStopToCallSession(lSessionId);
        end;

        function TVaxServerRoot.RecordWaveStartToCallSession(lSessionId : integer ;  sFileName : string) : boolean;
        begin
            Result := m_pVaxServerExCOM.RecordWaveStartToCallSession(lSessionId, sFileName);
        end;

        function TVaxServerRoot.RecordWaveStopToCallSession(lSessionId : integer ) : boolean;
        begin
            Result := m_pVaxServerExCOM.RecordWaveStopToCallSession(lSessionId);
        end;

        function TVaxServerRoot.RecordWavePauseToCallSession(lSessionId : integer ; bEnable : boolean) : boolean;
        begin
            Result := m_pVaxServerExCOM.RecordWavePauseToCallSession(lSessionId, bEnable);
        end;

        function TVaxServerRoot.LoadWaveFile( sFileName : string) : integer;
        begin
            Result := m_pVaxServerExCOM.LoadWaveFile(sFileName);
        end;

        procedure TVaxServerRoot.UnLoadWaveFile(lWaveId : integer);
        begin
            m_pVaxServerExCOM.UnLoadWaveFile(lWaveId);
        end;

        function TVaxServerRoot.LoadMusicHold( sFileName : string) : boolean;
        begin
            Result := m_pVaxServerExCOM.LoadMusicHold(sFileName);
        end;

        procedure TVaxServerRoot.UnLoadMusicHold();
        begin
            m_pVaxServerExCOM.UnLoadMusicHold();
        end;

        function TVaxServerRoot.AcceptOnHoldRequest(lSessionId  : integer ) : boolean;
        begin
            Result := m_pVaxServerExCOM.AcceptOnHoldRequest(lSessionId);
        end;

        function TVaxServerRoot.AcceptOffHoldRequest(lSessionId : integer ) : boolean;
        begin
            Result := m_pVaxServerExCOM.AcceptOffHoldRequest(lSessionId);
        end;

        function TVaxServerRoot.AcceptChatMessage(lChatMsgId : integer ;  nToPeerType : integer ;  sToPeerName : string) : boolean;
        begin
            Result := m_pVaxServerExCOM.AcceptChatMessage(lChatMsgId, nToPeerType, sToPeerName);
        end;

        procedure TVaxServerRoot.RejectChatMessage(lChatMsgId : integer ; lStatusCode : integer ;  sReasonPhrase : string);
        begin
            m_pVaxServerExCOM.RejectChatMessage(lChatMsgId, lStatusCode, sReasonPhrase);
        end;

        function TVaxServerRoot.AcceptChatStatusSubscribe(lStatusSubscribe : integer ;  sMsgFrom : string;  sMsgTo : string;  nToPeerType : integer ;  sToPeerName : string) : boolean;
        begin
            Result := m_pVaxServerExCOM.AcceptChatStatusSubscribe(lStatusSubscribe, sMsgFrom, sMsgTo, nToPeerType, sToPeerName);
        end;

        procedure TVaxServerRoot.RejectChatStatusSubscribe(lStatusSubscribe : integer ;  sMsgFrom : string;  sMsgTo : string);
        begin
            m_pVaxServerExCOM.RejectChatStatusSubscribe(lStatusSubscribe, sMsgFrom, sMsgTo);
        end;

        function TVaxServerRoot.OpenConferenceRoom( sRoomName : string) : boolean;
        begin
            Result := m_pVaxServerExCOM.OpenConferenceRoom(sRoomName);
        end;

        procedure TVaxServerRoot.CloseConferenceRoom( sRoomName : string);
        begin
            m_pVaxServerExCOM.CloseConferenceRoom(sRoomName);
        end;

        function TVaxServerRoot.AddCallSessionToConferenceRoom( sRoomName : string;  lSessionId : integer ;  nType : integer ) : boolean;
        begin
            Result := m_pVaxServerExCOM.AddCallSessionToConferenceRoom(sRoomName, lSessionId, nType);
        end;

        function TVaxServerRoot.RemoveCallSessionFromConferenceRoom( lSessionId : integer ) : boolean;
        begin
            Result := m_pVaxServerExCOM.RemoveCallSessionFromConferenceRoom(lSessionId);
        end;

        function TVaxServerRoot.PlayWaveStartToConferenceRoom( sRoomName : string;  lWaveId : integer ;  bLoop : boolean) : boolean;
        begin
            Result := m_pVaxServerExCOM.PlayWaveStartToConferenceRoom(sRoomName, lWaveId, bLoop);
        end;

        function TVaxServerRoot.PlayWaveStopToConferenceRoom( sRoomName : string) : boolean;
        begin
            Result := m_pVaxServerExCOM.PlayWaveStopToConferenceRoom(sRoomName);
        end;

        function TVaxServerRoot.RecordWaveStartToConferenceRoom( sRoomName : string;  sFileName : string) : boolean;
        begin
            Result := m_pVaxServerExCOM.RecordWaveStartToConferenceRoom(sRoomName, sFileName);
        end;

        function TVaxServerRoot.RecordWaveStopToConferenceRoom( sRoomName : string) : boolean;
        begin
            Result := m_pVaxServerExCOM.RecordWaveStopToConferenceRoom(sRoomName);
        end;

        function TVaxServerRoot.RecordWavePauseToConferenceRoom( sRoomName : string; bEnable : boolean) : boolean;
        begin
            Result := m_pVaxServerExCOM.RecordWavePauseToConferenceRoom(sRoomName, bEnable);
        end;

        function TVaxServerRoot.VoiceSessionLost(bEnable : boolean; lTimeOut : integer ) : boolean;
        begin
            Result := m_pVaxServerExCOM.VoiceSessionLost(bEnable, lTimeOut);
        end;

        function TVaxServerRoot.SendInfoVM( sUserLogin : string;  nNewMsgCount : integer ;  nOldMsgCount : integer ; bMsgWaiting : Boolean ) : integer;
        begin
            Result := m_pVaxServerExCOM.SendInfoVM(sUserLogin, nNewMsgCount, nOldMsgCount, bMsgWaiting);
        end;

        function TVaxServerRoot.StartVaxTeleTick(lTickId : integer ; lElapse : integer ) : boolean;
        begin
            Result := m_pVaxServerExCOM.StartVaxTeleTick(lTickId, lElapse);
        end;

        function TVaxServerRoot.StopVaxTeleTick(lTickId : integer ) : boolean;
        begin
            Result := m_pVaxServerExCOM.StopVaxTeleTick(lTickId);
        end;

        function TVaxServerRoot.SetUserAgentName( sName : string) : boolean;
        begin
            Result := m_pVaxServerExCOM.SetUserAgentName(sName);
        end;

        function TVaxServerRoot.GetUserAgentName() : string;
        begin
            Result := m_pVaxServerExCOM.GetUserAgentName();
        end;

        function TVaxServerRoot.SetSessionNameSDP( sName : string) : boolean;
        begin
            Result := m_pVaxServerExCOM.SetSessionNameSDP(sName);
        end;

        function TVaxServerRoot.GetSessionNameSDP() : string;
        begin
            Result := m_pVaxServerExCOM.GetSessionNameSDP();
        end;

        function TVaxServerRoot.SendDTMFCallSession( lSessionId : integer ;  nTypeDTMF : integer ;  nDigit : integer ) : boolean;
        begin
            Result := m_pVaxServerExCOM.SendDTMFCallSession(lSessionId, nTypeDTMF, nDigit);
        end;

        function TVaxServerRoot.DetectDTMFCallSession( lSessionId : integer ;  nTypeDTMF : integer ; bEnable : boolean;  nTimeout : integer ) : boolean;
        begin
            Result := m_pVaxServerExCOM.DetectDTMFCallSession(lSessionId, nTypeDTMF, bEnable, nTimeOut);
        end;

        function TVaxServerRoot.GetVaxObjectError() : integer;
        begin
            Result := m_pVaxServerExCOM.GetVaxObjectError();
        end;

        function TVaxServerRoot.DialToneToCallSession( bEnable : boolean;  lSessionId : integer ;  lWaveId : integer ) : boolean;
        begin
            Result := m_pVaxServerExCOM.DialToneToCallSession(bEnable, lSessionId, lWaveId);
        end;

        function TVaxServerRoot.DiagnosticLogSIP( bInbound : boolean;  bOutbound : boolean) : boolean;
        begin
            Result := m_pVaxServerExCOM.DiagnosticLogSIP(bInbound, bOutbound);
        end;
end.
