unit VaxChat;

interface

uses
    VaxServerConstants,
    VaxServerRoot;


type TVaxChat = class(TVaxServerRoot)

    public

      procedure OnChatMessageText(nChatMsgId : integer;  sMsgFrom : string;  sMsgTo : string;  sMsgText : string;  nFromPeerType : integer;  sFromPeerName : string;  sFromIP : string;  nFromPort : integer); override;
      procedure OnChatMessageTyping( nChatMsgId : integer;  sMsgFrom : string;  sMsgTo : string;  IsTypingStart : integer;  nFromPeerType : integer;  sFromPeerName : string;  sFromIP : string;  nFromPort : integer); override;
      procedure OnChatStatusSubscribe( nSubscrbId : integer;  sMsgFrom : string;  sMsgTo : string;  nFromPeerType : integer;  sFromPeerName : string;  sFromIP : string;  nFromPort : integer); override;

      procedure OnChatMessageSuccess( nChatMsgId : integer); override;
      procedure OnChatMessageFailure( ChatMsgId: Integer; StatusCode: Integer; const ReasonPhrase: WideString); override;
      procedure OnChatMessageTimeout( nChatMsgId : integer); override;

    public
      constructor Create();


end;

implementation

var bResult : Boolean;

      procedure TVaxChat.OnChatMessageText( nChatMsgId : integer;  sMsgFrom : string;  sMsgTo : string;  sMsgText : string;  nFromPeerType : integer;  sFromPeerName : string;  sFromIP : string;  nFromPort : integer);
      begin
            bResult := inherited AcceptChatMessage(nChatMsgId, TVaxServerConstants.VAX_PEER_TYPE_USER, sMsgTo);
      end;

      procedure TVaxChat.OnChatMessageTyping( nChatMsgId : integer;  sMsgFrom : string;  sMsgTo : string;  IsTypingStart : integer;  nFromPeerType : integer;  sFromPeerName : string;  sFromIP : string;  nFromPort : integer);
      begin
            bResult := inherited AcceptChatMessage(nChatMsgId, TVaxServerConstants.VAX_PEER_TYPE_USER, sMsgTo);
      end;

      procedure TVaxChat.OnChatStatusSubscribe( nSubscrbId : integer;  sMsgFrom : string;  sMsgTo : string;  nFromPeerType : integer;  sFromPeerName : string;  sFromIP : string;  nFromPort : integer);
      begin
            bResult := inherited AcceptChatStatusSubscribe(nSubscrbId, sMsgFrom, sMsgTo, TVaxServerConstants.VAX_PEER_TYPE_USER, sMsgTo);
      end;

      procedure TVaxChat.OnChatMessageSuccess( nChatMsgId : integer);
      begin
        //
      end;

      procedure TVaxChat.OnChatMessageFailure( ChatMsgId: Integer; StatusCode: Integer; const ReasonPhrase: WideString);
      begin
        //
      end;

      procedure TVaxChat.OnChatMessageTimeout( nChatMsgId : integer);
      begin
        //
      end;

      constructor TVaxChat.Create();
      begin
        inherited;
        inherited AddRef(TVaxServerConstants.ID_CLASS_CHAT_SIP); //ID_CLASS_CHAT_SIP = 3
      end;


end.
