unit VaxDirectProxy;

interface

uses
    System.Classes,
    VaxDirectProxyList,
    VaxServerConstants,
    VaxServerRoot;


type TVaxDirectProxy = class(TVaxServerRoot)

    private

        m_objVaxDirectProxyList : TVaxDirectProxyList;

    private

        function IsDirectProxyExist(sProxyName : string) : boolean;

    public

        constructor Create();

        procedure ResetOBJ();

        function AddDirectProxySIP(sProxyName, sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP : string; lProxyPort : Integer; sCodecList : string; nToPeerType : Integer; sToPeerName : string; bBlock, bAddToConf : boolean; sRoomName : string) : boolean;
        procedure RemoveDirectProxySIP(sProxyName : string);

        function GetDirectProxyAll(var pProxyList : TStringList) : boolean;
        function GetDirectProxyDetails(sProxyName : string; var sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP : string; var lProxyPort : Integer; var sCodecList : string; var nToPeerType : Integer; sToPeerName : string; var bBlock, bAddToConf : boolean; var sRoomName : string) : boolean;


end;

implementation

        constructor TVaxDirectProxy.Create();
        begin
            inherited;
            inherited AddRef(TVaxServerConstants.ID_CLASS_DIRECT_PROXY_SIP); // ID_CLASS_DIRECT_PROXY_SIP = 5

            m_objVaxDirectProxyList := TVaxDirectProxyList.Create();
        end;

        function TVaxDirectProxy.IsDirectProxyExist(sProxyName : string) : boolean;
        begin
            Result := m_objVaxDirectProxyList.IsDirectProxyExist(sProxyName);
        end;

        procedure TVaxDirectProxy.ResetOBJ();
        begin
            m_objVaxDirectProxyList.ResetOBJ();
        end;

        function TVaxDirectProxy.AddDirectProxySIP(sProxyName, sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP : string; lProxyPort : Integer; sCodecList : string; nToPeerType : Integer; sToPeerName : string; bBlock, bAddToConf : boolean; sRoomName : string) : boolean;
        begin

            if(inherited AddDirectProxySIP(sProxyName, sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP, lProxyPort, sCodecList) = false) then
            begin
                Result := False;
                Exit;
            end;

            Result := m_objVaxDirectProxyList.AddDirectProxySIP(sProxyName, sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP, lProxyPort, sCodecList, nToPeerType, sToPeerName, bBlock, bAddToConf, sRoomName);

        end;

        procedure TVaxDirectProxy.RemoveDirectProxySIP(sProxyName : string);
        begin
            inherited RemoveDirectProxySIP(sProxyName);
            m_objVaxDirectProxyList.RemoveDirectProxySIP(sProxyName);
        end;

        function TVaxDirectProxy.GetDirectProxyAll(var pProxyList : TStringList) : boolean;
        begin
            Result := m_objVaxDirectProxyList.GetDirectProxyAll(pProxyList);
        end;

        function TVaxDirectProxy.GetDirectProxyDetails(sProxyName : string; var sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP : string; var lProxyPort : Integer; var sCodecList : string; var nToPeerType : Integer; sToPeerName : string; var bBlock, bAddToConf : boolean; var sRoomName : string) : boolean;
        begin
            Result := m_objVaxDirectProxyList.GetDirectProxyDetails(sProxyName, sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP, lProxyPort, sCodecList, nToPeerType, sToPeerName, bBlock, bAddToConf, sRoomName);
        end;


end.
