unit VaxMain;

interface

uses
    VaxServerRoot;


type TVaxMain = class(TVaxServerRoot)

    public

        constructor Create();

        procedure SetLicenseKey(sLicenseKey : string);

        function Initialize(sDomainRealm : string;  sSIPListenIP : string; nSIPListenPort : integer ;  sRTPListenIP : string; nRTPListenPort : integer ) : boolean;
        procedure UnInitialize();

        function PlayWaveStartToCallSession(lSessionId : integer ; lWaveId : integer ; bLoop : boolean) : boolean;
        function PlayWaveStopToCallSession(lSessionId : integer ) : boolean;

        function RecordWaveStartToCallSession(lSessionId : integer ;  sFileName : string) : boolean;
        function RecordWaveStopToCallSession(lSessionId : integer ) : boolean;
        function RecordWavePauseToCallSession(lSessionId : integer ; bEnable : boolean) : boolean;

        function LoadWaveFile( sFileName : string) : integer;
        procedure UnLoadWaveFile(lWaveId : integer);

        function LoadMusicHold( sFileName : string) : boolean;
        procedure UnLoadMusicHold();

        function OpenConferenceRoom( sRoomName : string) : boolean;
        procedure CloseConferenceRoom( sRoomName : string);

        function VoiceSessionLost(bEnable : boolean; lTimeOut : integer ) : boolean;

        function SendInfoVM( sUserLogin : string;  nNewMsgCount : integer ;  nOldMsgCount : integer ; bMsgWaiting : Boolean ) : integer;

        function StartVaxTeleTick(lTickId : integer ; lElapse : integer ) : boolean;
        function StopVaxTeleTick(lTickId : integer ) : boolean;

        function SetUserAgentName( sName : string) : boolean;
        function GetUserAgentName() : string;

        function SetSessionNameSDP( sName : string) : boolean;
        function GetSessionNameSDP() : string;

        function SendDTMFCallSession( lSessionId : integer ;  nTypeDTMF : integer ;  nDigit : integer ) : boolean;
        function DetectDTMFCallSession( lSessionId : integer ;  nTypeDTMF : integer ; bEnable : boolean;  nTimeout : integer ) : boolean;

        function GetVaxObjectError() : integer;

        function DialToneToCallSession( bEnable : boolean;  lSessionId : integer ;  lWaveId : integer ) : boolean;
        function DiagnosticLogSIP( bInbound : boolean;  bOutbound : boolean) : boolean;

end;

implementation
uses VaxServerConstants;

        constructor TVaxMain.Create();
        begin
            inherited Create();
            inherited AddRef(TVaxServerConstants.ID_CLASS_MAIN_SIP);
        end;

        procedure TVaxMain.SetLicenseKey(sLicenseKey : string);
        begin
            inherited SetLicenseKey(sLicenseKey);
        end;

        function TVaxMain.Initialize(sDomainRealm : string;  sSIPListenIP : string; nSIPListenPort : integer ;  sRTPListenIP : string; nRTPListenPort : integer ) : boolean;
        begin
            Result := inherited Initialize(sDomainRealm, sSIPListenIP, nSIPListenPort, sRTPListenIP, nRTPListenPort);
        end;

        procedure TVaxMain.UnInitialize();
        begin
            inherited;
        end;

        function TVaxMain.PlayWaveStartToCallSession(lSessionId : integer ; lWaveId : integer ; bLoop : boolean) : boolean;
        begin
            Result := inherited;
        end;

        function TVaxMain.PlayWaveStopToCallSession(lSessionId : integer ) : boolean;
        begin
            Result := inherited;
        end;

        function TVaxMain.RecordWaveStartToCallSession(lSessionId : integer ;  sFileName : string) : boolean;
        begin
            Result := inherited;
        end;

        function TVaxMain.RecordWaveStopToCallSession(lSessionId : integer ) : boolean;
        begin
            Result := inherited;
        end;

        function TVaxMain.RecordWavePauseToCallSession(lSessionId : integer ; bEnable : boolean) : boolean;
        begin
            Result := inherited;
        end;

        function TVaxMain.LoadWaveFile( sFileName : string) : integer;
        begin
            Result := inherited;
        end;

        procedure TVaxMain.UnLoadWaveFile(lWaveId : integer);
        begin
            inherited;
        end;

        function TVaxMain.LoadMusicHold( sFileName : string) : boolean;
        begin
            Result := inherited;
        end;

        procedure TVaxMain.UnLoadMusicHold();
        begin
            inherited;
        end;

        function TVaxMain.OpenConferenceRoom( sRoomName : string) : boolean;
        begin
            Result := inherited OpenConferenceRoom(sRoomName);
        end;

        procedure TVaxMain.CloseConferenceRoom( sRoomName : string);
        begin
            inherited;
        end;

        function TVaxMain.VoiceSessionLost(bEnable : boolean; lTimeOut : integer ) : boolean;
        begin
            Result := inherited;
        end;

        function TVaxMain.SendInfoVM( sUserLogin : string;  nNewMsgCount : integer ;  nOldMsgCount : integer ; bMsgWaiting : Boolean ) : integer;
        begin
            Result := inherited;
        end;

        function TVaxMain.StartVaxTeleTick(lTickId : integer ; lElapse : integer ) : boolean;
        begin
            Result := inherited;
        end;

        function TVaxMain.StopVaxTeleTick(lTickId : integer ) : boolean;
        begin
            Result := inherited;
        end;

        function TVaxMain.SetUserAgentName( sName : string) : boolean;
        begin
            Result := inherited;
        end;

        function TVaxMain.GetUserAgentName() : string;
        begin
            Result := inherited;
        end;

        function TVaxMain.SetSessionNameSDP( sName : string) : boolean;
        begin
            Result := inherited;
        end;

        function TVaxMain.GetSessionNameSDP() : string;
        begin
            Result := inherited;
        end;

        function TVaxMain.SendDTMFCallSession( lSessionId : integer ;  nTypeDTMF : integer ;  nDigit : integer ) : boolean;
        begin
            Result := inherited;
        end;

        function TVaxMain.DetectDTMFCallSession( lSessionId : integer ;  nTypeDTMF : integer ; bEnable : boolean;  nTimeout : integer ) : boolean;
        begin
            Result := inherited;
        end;

        function TVaxMain.GetVaxObjectError() : integer;
        begin
            Result := inherited;
        end;

        function TVaxMain.DialToneToCallSession( bEnable : boolean;  lSessionId : integer ;  lWaveId : integer ) : boolean;
        begin
            Result := inherited;
        end;

        function TVaxMain.DiagnosticLogSIP( bInbound : boolean;  bOutbound : boolean) : boolean;
        begin
            Result := inherited;
        end;
end.
