﻿Public Class AddConfRoomForm

    Private m_objVaxTeleSIP As CVaxServerSIP

    Public Sub New(ByRef objVaxTeleSIP As CVaxServerSIP)

        InitializeComponent()
        m_objVaxTeleSIP = objVaxTeleSIP

    End Sub

    Private Sub btnAddRoom_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddRoom.Click

        If AddRoomChecks() = False Then
            Exit Sub
        End If

        If (m_objVaxTeleSIP.AddRoom(ComboRoomName.Text.Trim(), EditRoomNo.Text.Trim()) = False) Then
            MessageBox.Show("Room could not be created or Please start the server first.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        ComboRoomName.Items.Add(ComboRoomName.Text)
        MessageBox.Show("Room created successfully", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

    End Sub

    Private Sub btnRemoveRoom_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRemoveRoom.Click
        If ComboRoomName.Text.Length = 0 Then
            MessageBox.Show("Please enter room name.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Sub
        End If

        Dim nIndex As Integer = ComboRoomName.FindStringExact(ComboRoomName.Text)
        If (nIndex = -1) Then Return

        m_objVaxTeleSIP.RemoveRoom(ComboRoomName.Text)
        ComboRoomName.Items.RemoveAt(nIndex)

        MessageBox.Show("Room removed successfully!", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

        ClearDlgContent()

    End Sub

    Private Sub ClearDlgContent()
        EditRoomNo.Text = ""
    End Sub

    Private Sub ComboRoomName_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboRoomName.SelectedIndexChanged
        ShowRoomDetails(ComboRoomName.Text)
    End Sub

    Private Function AddRoomChecks() As Boolean

        If (ComboRoomName.Text.Equals("")) Then
            MessageBox.Show("Room Name cann't be empty", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return False
        End If

        If (EditRoomNo.Text.Equals("")) Then
            MessageBox.Show("Room No cann't be empty", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return False
        End If

        Dim nCount As Integer
        Dim sDigit As String = "0123456789"

        For nCount = 0 To EditRoomNo.Text.Length - 1
            If sDigit.IndexOf(EditRoomNo.Text.Chars(nCount)) = -1 Then
                MessageBox.Show("Room no should contain only numerals 0 through 9. For example: 12, 324323, 800122, 2109756 etc.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Return False
            End If
        Next

        Return True

    End Function

    Private Sub ShowRoomDetails(ByVal sRoomName As String)

        Dim sRoomNo As String = ""

        If m_objVaxTeleSIP.GetRoomDetails(sRoomName, sRoomNo) = False Then
            Return
        End If

        EditRoomNo.Text = sRoomNo

    End Sub

End Class