
Imports VBNetSipServer.VBNetSIPServerSample


Public Class AddLineForm

    Private m_objVaxTeleSIP As CVaxServerSIP

    Public Sub New(ByRef objVaxTeleSIP As CVaxServerSIP)

        InitializeComponent()
        m_objVaxTeleSIP = objVaxTeleSIP

        RadioRejectCall.Checked = True

    End Sub

    Private Sub AddLineForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        LoadCodecs()
    End Sub

    Private Sub BtnAddLine_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAddLine.Click

        If AddLineChecks() = False Then
            Exit Sub
        End If

        If ComboLine.FindStringExact(ComboLine.Text) <> -1 Then
            MessageBox.Show("Line already exist", "VaxTeleSIP", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation)
            Exit Sub
        End If

        Dim objCodec As New cCodec
        Dim sCodec As String = ""

        Dim nCount As Integer

        For nCount = 0 To ListBoxEnableCodec.Items.Count - 1
            sCodec += objCodec.GetCodecNo(ListBoxEnableCodec.Items.Item(nCount))
        Next

        'Check which radio button is selected.

        Dim nToPeerType As Integer = -1
        Dim sToPeerName As String = "", sRoomName As String = ""
        Dim bRejected As Boolean = False

        bRejected = RadioRejectCall.Checked

        If (RadioConnectToUser.Checked) Then
            nToPeerType = CVaxServerCOM.VAX_PEER_TYPE_USER
            sToPeerName = ComboConnectToUser.Text.Trim().ToString()
        End If

        If (RadioPutInConf.Checked) Then
            sRoomName = ComboPutInConf.Text.Trim().ToString()
        End If

        If (m_objVaxTeleSIP.AddLine(ComboLine.Text, EditDisplayName.Text, EditUserName.Text, EditAuthUser.Text, EditPassword.Text, EditDomainRealm.Text, EditProxySIP.Text, sCodec, CheckBoxRegLine.Checked, nToPeerType, sToPeerName, bRejected, sRoomName) = False) Then
            MessageBox.Show("Line could not be created or Please start the server first.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        ComboLine.Items.Add(ComboLine.Text)
        MessageBox.Show("Line created successfully", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)


    End Sub

    Private Sub BtnDisableCodec_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDisableCodec.Click
        If ListBoxEnableCodec.SelectedItems.Count = 0 Then
            Exit Sub
        End If

        ListBoxDisableCodec.Items.Add(ListBoxEnableCodec.SelectedItem.ToString())
        ListBoxEnableCodec.Items.Remove(ListBoxEnableCodec.SelectedItem)
    End Sub

    Private Sub BtnEnableCodec_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnEnableCodec.Click
        If ListBoxDisableCodec.SelectedItems.Count = 0 Then
            Exit Sub
        End If

        ListBoxEnableCodec.Items.Add(ListBoxDisableCodec.SelectedItem.ToString())
        ListBoxDisableCodec.Items.Remove(ListBoxDisableCodec.SelectedItem)
    End Sub

    Private Sub ComboLine_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboLine.SelectedIndexChanged
        ShowLineDetails(ComboLine.Text)
    End Sub

    Private Sub BtnRemoveLine_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnRemoveLine.Click

        If ComboLine.Text.Length = 0 Then
            MessageBox.Show("Please enter line name.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Sub
        End If

        Dim nIndex As Integer = ComboLine.FindStringExact(ComboLine.Text)
        If (nIndex = -1) Then Return

        m_objVaxTeleSIP.RemoveLine(ComboLine.Text)
        ComboLine.Items.RemoveAt(nIndex)

        MessageBox.Show("Line removed successfully!", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        ClearDlgContent()
    End Sub

    Private Sub BtnClearLineDlg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnClearLineDlg.Click
        ClearDlgContent()
    End Sub

    Public Sub LoadCodecs()

        Dim objCodec As cCodec = New cCodec()
        Dim nCount = 0

        For nCount = 0 To cCodec.TOTAL_SIZE_CODEC
            ListBoxEnableCodec.Items.Add(objCodec.GetCodecName(Convert.ToString(nCount)))
        Next

    End Sub

    Private Sub ShowLines()
        ComboLine.Items.Clear()

        Dim objListLines As ArrayList = New ArrayList()
        m_objVaxTeleSIP.GetLineAll(objListLines)

        If (objListLines.Count <= 0) Then
            Return
        End If

        Dim nCount As Integer = 0
        For nCount = 0 To objListLines.Count - 1
            ComboLine.Items.Add(objListLines(nCount))
        Next

        If (ComboLine.Items.Count > 0) Then
            ComboLine.SelectedIndex = 0
        End If

        ShowLineDetails(ComboLine.Text)

    End Sub

    Private Sub ShowUsers()
        ComboConnectToUser.Items.Clear()

        Dim objUserList As ArrayList = New ArrayList()
        m_objVaxTeleSIP.GetUserAll(objUserList)

        If (objUserList.Count <= 0) Then Return

        Dim nIndex = 0
        For nIndex = 0 To objUserList.Count - 1
            ComboConnectToUser.Items.Add(objUserList.Item(nIndex))
        Next

        ComboConnectToUser.SelectedIndex = 0
    End Sub

    Private Sub ShowRooms()
        ComboPutInConf.Items.Clear()

        Dim objRoomList As ArrayList = New ArrayList()
        m_objVaxTeleSIP.GetRoomAll(objRoomList)

        If (objRoomList.Count <= 0) Then Return

        Dim nIndex = 0
        For nIndex = 0 To objRoomList.Count - 1
            ComboPutInConf.Items.Add(objRoomList.Item(nIndex))
        Next

        ComboPutInConf.SelectedIndex = 0
    End Sub

    Public Sub OnSetActive()

        ShowUsers()
        ShowRooms()
        ShowLines()

    End Sub

    Private Function AddLineChecks() As Boolean

        If ComboLine.Text.Length = 0 Then
            MessageBox.Show("Please enter Line Name.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return False
        End If

        If ListBoxEnableCodec.Items.Count = 0 Then
            MessageBox.Show("Please select a codec.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return False
        End If

        Return True

    End Function

    Private Sub ShowLineDetails(ByVal sLineName As String)

        Dim sDisplayName As String = "", sUserName As String = "", sAuthUser As String = ""
        Dim sAuthPwd As String = "", sDomainRealm As String = "", sProxySIP As String = ""
        Dim sCodecList As String = "", sToPeerName As String = "", sRoomName As String = ""

        Dim nToPeerType As Integer = -1
        Dim bRegister As Boolean = False, bBlock As Boolean = False

        m_objVaxTeleSIP.GetLineDetails(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sCodecList, bRegister, nToPeerType, sToPeerName, bBlock, sRoomName)
        UpdateDlgContent(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sCodecList, bRegister, nToPeerType, sToPeerName, bBlock, sRoomName)

    End Sub

    Private Sub UpdateDlgContent(ByVal sLineName As String, ByVal sDisplayName As String, ByVal sUserName As String, ByVal sAuthUser As String, ByVal sAuthPwd As String, ByVal sRealm As String, ByVal sProxy As String, ByVal sCodecList As String, ByVal bRegister As Boolean, ByVal lToPeerType As Long, ByVal sToPeerName As String, ByVal bBlock As Boolean, ByVal sRoomName As String)

        If sLineName.Length = 0 Then
            Exit Sub
        End If

        EditDisplayName.Text = sDisplayName
        EditUserName.Text = sUserName

        EditAuthUser.Text = sAuthUser
        EditPassword.Text = sAuthPwd
        EditDomainRealm.Text = sRealm

        EditProxySIP.Text = sProxy
        CheckBoxRegLine.Checked = bRegister

        UpdateIncomingCallSection(Convert.ToInt32(lToPeerType), sToPeerName, bBlock, sRoomName)

        ListBoxEnableCodec.Items.Clear()
        ListBoxDisableCodec.Items.Clear()

        Dim nCount As Integer
        Dim objCodec As New cCodec

        For nCount = 0 To cCodec.TOTAL_SIZE_CODEC
            ListBoxDisableCodec.Items.Add(objCodec.GetCodecName(Convert.ToString(nCount)))
        Next

        Dim sCodecName As String

        For nCount = 0 To sCodecList.Length - 1
            sCodecName = objCodec.GetCodecName(sCodecList(nCount))
            ListBoxEnableCodec.Items.Add(sCodecName)
            ListBoxDisableCodec.Items.Remove(sCodecName)
        Next

    End Sub

    Private Sub UpdateIncomingCallSection(ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal bRejected As Boolean, ByVal sRoomName As String)

        Dim nIndex As Integer

        If bRejected = True Then
            RadioRejectCall.Checked = True
            Exit Sub
        End If

        If nToPeerType = CVaxServerCOM.VAX_PEER_TYPE_USER Then

            nIndex = ComboConnectToUser.FindStringExact(sToPeerName)

            If nIndex = -1 Then
                RadioRejectCall.Checked = True
                Exit Sub
            End If

            If ComboConnectToUser.Items.Count > 0 Then
                ComboConnectToUser.SelectedIndex = nIndex
            End If

            RadioConnectToUser.Checked = True
            Exit Sub
        End If

        If sRoomName.Length <> 0 Then

            nIndex = ComboPutInConf.FindStringExact(sRoomName)

            If nIndex = -1 Then
                RadioRejectCall.Checked = True
                Exit Sub
            End If

            If ComboPutInConf.Items.Count > 0 Then
                ComboPutInConf.SelectedIndex = nIndex
            End If

            RadioPutInConf.Checked = True
            Exit Sub
        End If

    End Sub

    Private Sub ClearDlgContent()

        ComboLine.Text = ""

        EditUserName.Text = ""
        EditAuthUser.Text = ""
        EditPassword.Text = ""
        EditDisplayName.Text = ""
        EditDomainRealm.Text = ""
        EditProxySIP.Text = ""

        If ComboConnectToUser.Items.Count > 0 Then
            ComboConnectToUser.SelectedIndex = 0
        End If

        If ComboPutInConf.Items.Count > 0 Then
            ComboPutInConf.SelectedIndex = 0
        End If

        CheckBoxRegLine.Checked = False
        RadioRejectCall.Checked = True

        ListBoxEnableCodec.Items.Clear()
        ListBoxDisableCodec.Items.Clear()

        ListBoxEnableCodec.Items.Add(cCodec.G711U_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.G711A_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.ILBC_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.G610_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.G729_TEXT)

    End Sub

End Class