

Imports VBNetSipServer.VBNetSIPServerSample

Public Class AddLoginForm

    Private m_objVaxTeleSIP As CVaxServerSIP

    Public Class ComboBoxRouteItem

        Public Property m_sToPeerName As String
        Public Property m_nToPeerType As Object

        Public Overrides Function ToString() As String
            Return m_sToPeerName
        End Function

    End Class

    Dim m_arrComboBoxRouteItem As ArrayList

    Public Sub New(ByRef objVaxTeleSIP As CVaxServerSIP)

        InitializeComponent()
        m_objVaxTeleSIP = objVaxTeleSIP
        m_arrComboBoxRouteItem = New ArrayList()

    End Sub

    Private Sub BtnRemoveLogin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnRemoveLogin.Click

        If ComboLogin.Text.Length = 0 Then
            MessageBox.Show("Please enter login.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Sub
        End If

        Dim nIndex As Integer = ComboLogin.FindStringExact(ComboLogin.Text)

        If nIndex = -1 Then
            Exit Sub
        End If

        m_objVaxTeleSIP.RemoveUser(ComboLogin.Text)
        ComboLogin.Items.RemoveAt(nIndex)

        MessageBox.Show("Login removed successfully!", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        ClearDlgContent()

    End Sub

    Private Sub BtnAddLogin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAddLogin.Click

        If AddLoginChecks() = False Then
            Exit Sub
        End If

        If ComboLogin.FindStringExact(ComboLogin.Text) <> -1 Then
            MessageBox.Show("Login already exist", "VaxTeleSIP", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation)
            Exit Sub
        End If

        Dim objCodec As New cCodec
        Dim sCodec As String = ""

        Dim nCount As Integer

        For nCount = 0 To ListBoxEnableCodec.Items.Count - 1
            sCodec += objCodec.GetCodecNo(ListBoxEnableCodec.Items.Item(nCount))
        Next

        Dim nToPeerType As Integer = -1
        Dim sToPeerName As String = ""

        Dim nSelectedIndex As Integer = ComboLoginRoute.SelectedIndex

        If nSelectedIndex <> -1 Then
            Dim comboLineItem As ComboBoxRouteItem = m_arrComboBoxRouteItem(nSelectedIndex)
            nToPeerType = comboLineItem.m_nToPeerType
            sToPeerName = comboLineItem.m_sToPeerName
        End If

        If (m_objVaxTeleSIP.AddUser(ComboLogin.Text, EditPassword.Text, sCodec, CheckBoxBlockAccount.Checked, EditCallPrefix.Text, EditDialPrefix.Text, nToPeerType, sToPeerName) = False) Then

            MessageBox.Show("Login could not be created or Please start the server first.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        ComboLogin.Items.Add(ComboLogin.Text)
        MessageBox.Show("Login created successfully", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

    End Sub

    Private Sub BtnDisableCodec_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDisableCodec.Click

        If ListBoxEnableCodec.SelectedItems.Count = 0 Then
            Exit Sub
        End If

        ListBoxDisableCodec.Items.Add(ListBoxEnableCodec.SelectedItem.ToString)
        ListBoxEnableCodec.Items.Remove(ListBoxEnableCodec.SelectedItem)

    End Sub

    Private Sub BtnEnableCodec_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnEnableCodec.Click
        If ListBoxDisableCodec.SelectedItems.Count = 0 Then
            Exit Sub
        End If

        ListBoxEnableCodec.Items.Add(ListBoxDisableCodec.SelectedItem.ToString)
        ListBoxDisableCodec.Items.Remove(ListBoxDisableCodec.SelectedItem)
    End Sub

    Private Sub ComboLogin_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboLogin.SelectedIndexChanged
        ShowLoginDetails(ComboLogin.Text)
    End Sub

    Private Sub ClearDlgContent()

        ComboLogin.Text = ""
        EditPassword.Text = ""

        ListBoxEnableCodec.Items.Clear()
        ListBoxDisableCodec.Items.Clear()

        CheckBoxBlockAccount.Checked = False

        ListBoxEnableCodec.Items.Add(cCodec.G711U_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.G711A_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.ILBC_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.G610_TEXT)
        ListBoxEnableCodec.Items.Add(cCodec.G729_TEXT)

    End Sub

    Private Sub BtnClearLoginDlg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnClearLoginDlg.Click
        ClearDlgContent()
    End Sub

    Private Sub AddLoginForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        LoadCodecs()

    End Sub

    Public Sub LoadCodecs()
        Dim objCodec As cCodec = New cCodec()
        Dim nCount = 0

        For nCount = 0 To cCodec.TOTAL_SIZE_CODEC - 1
            ListBoxEnableCodec.Items.Add(objCodec.GetCodecName(Convert.ToString(nCount)))
        Next
    End Sub

    Public Sub ShowUsers()
        ComboLogin.Items.Clear()

        Dim objUserList As ArrayList = New ArrayList()
        m_objVaxTeleSIP.GetUserAll(objUserList)

        If (objUserList.Count <= 0) Then Return

        Dim nIndex = 0
        For nIndex = 0 To objUserList.Count - 1
            ComboLogin.Items.Add(objUserList.Item(nIndex))
        Next

        If (ComboLogin.SelectedIndex = -1) Then
            If (ComboLogin.Items.Count > 0) Then
                ComboLogin.SelectedIndex = 0
            End If
        End If

        ShowLoginDetails(ComboLogin.Text)

    End Sub

    Public Sub ShowLines()

        Dim objListLines As ArrayList = New ArrayList()
        m_objVaxTeleSIP.GetLineAll(objListLines)

        If (objListLines.Count <= 0) Then Return

        Dim nIndex = 0
        For nIndex = 0 To objListLines.Count - 1

            Dim m_sToPeerName As String = objListLines(nIndex).ToString()
            ComboLoginRoute.Items.Add(m_sToPeerName)

            Dim comboRouteItem As ComboBoxRouteItem = New ComboBoxRouteItem()
            comboRouteItem.m_sToPeerName = objListLines(nIndex).ToString()
            comboRouteItem.m_nToPeerType = CVaxServerCOM.VAX_PEER_TYPE_LINE

            m_arrComboBoxRouteItem.Add(comboRouteItem)
        Next

        ComboLoginRoute.SelectedIndex = 0

    End Sub

    Public Sub ShowDirectProxies()

        Dim objProxyList As ArrayList = New ArrayList()
        m_objVaxTeleSIP.GetDirectProxyAll(objProxyList)

        If (objProxyList.Count <= 0) Then Return

        Dim nIndex = 0
        For nIndex = 0 To objProxyList.Count - 1

            Dim m_sToPeerName As String = objProxyList(nIndex).ToString()
            ComboLoginRoute.Items.Add(m_sToPeerName)

            Dim comboRouteItem As ComboBoxRouteItem = New ComboBoxRouteItem()
            comboRouteItem.m_sToPeerName = objProxyList(nIndex).ToString()
            comboRouteItem.m_nToPeerType = CVaxServerCOM.VAX_PEER_TYPE_DIRECT_PROXY

            m_arrComboBoxRouteItem.Add(comboRouteItem)
        Next

        ComboLoginRoute.SelectedIndex = 0

    End Sub

    Public Sub OnSetActive()

        ComboLoginRoute.Items.Clear()

        ShowLines()
        ShowDirectProxies()
        ShowUsers()

    End Sub

    Public Sub ShowLoginDetails(ByVal sLogin As String)

        Dim sLoginSIP As String = ComboLogin.SelectedItem.ToString()
        Dim sPassword As String = "", sCodecList As String = ""
        Dim sDialPrefix As String = "", sCallPrefix As String = "", sToPeerName As String = ""
        Dim bBlock = False
        Dim nToPeerType = -1

        Dim bResult As Boolean = m_objVaxTeleSIP.GetUserDetails(sLogin, sPassword, sCodecList, bBlock, sCallPrefix, sDialPrefix, nToPeerType, sToPeerName)

        If (bResult = False) Then
            Return
        End If

        UpdateDlgContent(sLogin, sPassword, sCodecList, sDialPrefix, sCallPrefix, sToPeerName, bBlock)

    End Sub

    Private Sub UpdateDlgContent(ByVal sLogin As String, ByVal sPassword As String, ByVal sCodecList As String, ByVal sDialPrefix As String, ByVal sCallPrefix As String, ByVal sConnectName As String, ByVal bBlock As Boolean)

        If sLogin.Length = 0 Then
            Return
        End If

        EditPassword.Text = sPassword
        EditDialPrefix.Text = sDialPrefix
        EditCallPrefix.Text = sCallPrefix

        CheckBoxBlockAccount.Checked = bBlock

        ComboLoginRoute.SelectedIndex = ComboLoginRoute.FindStringExact(sConnectName)

        ListBoxEnableCodec.Items.Clear()
        ListBoxDisableCodec.Items.Clear()

        Dim nCount As Integer
        Dim objCodec As New cCodec

        For nCount = 0 To cCodec.TOTAL_SIZE_CODEC
            ListBoxDisableCodec.Items.Add(objCodec.GetCodecName(Convert.ToString(nCount)))
        Next

        Dim sCodecName As String

        For nCount = 0 To sCodecList.Length - 1
            sCodecName = objCodec.GetCodecName(sCodecList(nCount))
            ListBoxEnableCodec.Items.Add(sCodecName)
            ListBoxDisableCodec.Items.Remove(sCodecName)
        Next

    End Sub

    Function AddLoginChecks() As Boolean

        AddLoginChecks = False

        If ComboLogin.Text.Length = 0 Then
            MessageBox.Show("Please enter login.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Function
        End If

        Dim nCount As Integer
        Dim sDigit As String = "0123456789"

        For nCount = 0 To ComboLogin.Text.Length - 1
            If sDigit.IndexOf(ComboLogin.Text.Chars(nCount)) = -1 Then
                MessageBox.Show("Login should contain only numerals 0 through 9. For example: 12, 324323, 800122, 2109756 etc.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Exit Function
            End If
        Next

        If EditPassword.Text.Length = 0 Then
            MessageBox.Show("Please enter login password.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Function
        End If

        If ComboLogin.Text.Length > 20 Or EditPassword.Text.Length > 20 Then
            MessageBox.Show("Login and password size should not be more 20.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Function
        End If

        If ComboLogin.Text.Substring(0, 2) = "00" Then
            MessageBox.Show("Please donot enter 00 as login prefix. 00 prefix is use to prepare dial plan.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Function
        End If

        If ListBoxEnableCodec.Items.Count = 0 Then
            MessageBox.Show("Please select a codec.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Function
        End If

        AddLoginChecks = True

    End Function

End Class