﻿
Imports VaxTeleServerCOMLib
Imports System.Runtime.InteropServices

Public Class CVaxServerCOM

    Public Const VAX_PEER_TYPE_USER As Integer = 3001
    Public Const VAX_PEER_TYPE_LINE As Integer = 3002
    Public Const VAX_PEER_TYPE_DIRECT_PROXY As Integer = 3003

    Public Const CONF_ROOM_NORMAL_LISTENER As Integer = 100
    Public Const CONF_ROOM_STEALTH_LISTENER As Integer = 101
    Public Const CONF_ROOM_STEALTH_SPEAKER As Integer = 102

    Public Const DTMF_TYPE_RFC2833 As Integer = 0
    Public Const DTMF_TYPE_INBAND As Integer = 1
    Public Const DTMF_TYPE_INFO As Integer = 2

    Public Const VAX_CLOSED_REASON_CODE_HANGUP As Integer = 2001
    Public Const VAX_CLOSED_REASON_CODE_SESSION_LOST As Integer = 2002
    Public Const VAX_CLOSED_REASON_CODE_MERGED As Integer = 2003
    Public Const VAX_CLOSED_REASON_CODE_TRANSFERED As Integer = 2004
    Public Const VAX_CLOSED_REASON_CODE_REJECTED As Integer = 2005
    Public Const VAX_CLOSED_REASON_CODE_FAILED As Integer = 2006
    Public Const VAX_CLOSED_REASON_CODE_CANCELLED As Integer = 2007
    Public Const VAX_CLOSED_REASON_CODE_TIMEOUT As Integer = 2008
    Public Const VAX_CLOSED_REASON_CODE_CLOSED As Integer = 2009

    Public Const VAX_CALL_TYPE_FROM As Integer = 201
    Public Const VAX_CALL_TYPE_TO As Integer = 202

    Public Const VAX_CUSTOM_HEADER_REQ_ID_INVITE As Integer = 0

    Public Const VAX_TRANSFER_TYPE_BLIND As Integer = 401
    Public Const VAX_TRANSFER_TYPE_CONSULT As Integer = 402

    Public Const VAX_CODEC_GSM610 As Integer = 0
    Public Const VAX_CODEC_ILBC As Integer = 1
    Public Const VAX_CODEC_G711A As Integer = 2
    Public Const VAX_CODEC_G711U As Integer = 3
    Public Const VAX_CODEC_G729 As Integer = 4

    Private m_objVaxServerSIP As VaxServerSIP = New VaxServerSIP

    Public Sub New()

        AddHandler m_objVaxServerSIP.OnLineRegisterTrying, AddressOf OnLineRegisterTrying
        AddHandler m_objVaxServerSIP.OnLineRegisterFailed, AddressOf OnLineRegisterFailed
        AddHandler m_objVaxServerSIP.OnLineRegisterSuccess, AddressOf OnLineRegisterSuccess

        AddHandler m_objVaxServerSIP.OnLineUnRegisterTrying, AddressOf OnLineUnRegisterTrying
        AddHandler m_objVaxServerSIP.OnLineUnRegisterFailed, AddressOf OnLineUnRegisterFailed
        AddHandler m_objVaxServerSIP.OnLineUnRegisterSuccess, AddressOf OnLineUnRegisterSuccess

        AddHandler m_objVaxServerSIP.OnUnRegisterUser, AddressOf OnUnRegisterUser
        AddHandler m_objVaxServerSIP.OnRegisterUser, AddressOf OnRegisterUser
        AddHandler m_objVaxServerSIP.OnRegisterUserSuccess, AddressOf OnRegisterUserSuccess
        AddHandler m_objVaxServerSIP.OnRegisterUserFailed, AddressOf OnRegisterUserFailed

        AddHandler m_objVaxServerSIP.OnCallSessionOpen, AddressOf OnCallSessionOpen
        AddHandler m_objVaxServerSIP.OnCallSessionConnecting, AddressOf OnCallSessionConnecting
        AddHandler m_objVaxServerSIP.OnCallSessionFailed, AddressOf OnCallSessionFailed
        AddHandler m_objVaxServerSIP.OnCallSessionConnected, AddressOf OnCallSessionConnected
        AddHandler m_objVaxServerSIP.OnCallSessionClosed, AddressOf OnCallSessionClosed

        AddHandler m_objVaxServerSIP.OnCallSessionLost, AddressOf OnCallSessionLost
        AddHandler m_objVaxServerSIP.OnCallSessionHangup, AddressOf OnCallSessionHangup
        AddHandler m_objVaxServerSIP.OnCallSessionTimeout, AddressOf OnCallSessionTimeout
        AddHandler m_objVaxServerSIP.OnCallSessionCancelled, AddressOf OnCallSessionCancelled

        AddHandler m_objVaxServerSIP.OnCallSessionOnHold, AddressOf OnCallSessionOnHold
        AddHandler m_objVaxServerSIP.OnCallSessionOffHold, AddressOf OnCallSessionOffHold

        AddHandler m_objVaxServerSIP.OnCallSessionTransferBlind, AddressOf OnCallSessionTransferBlind
        AddHandler m_objVaxServerSIP.OnCallSessionTransferConsult, AddressOf OnCallSessionTransferConsult

        AddHandler m_objVaxServerSIP.OnCallSessionTransfering, AddressOf OnCallSessionTransfering
        AddHandler m_objVaxServerSIP.OnCallSessionTransferFailed, AddressOf OnCallSessionTransferFailed
        AddHandler m_objVaxServerSIP.OnCallSessionTransferTimeout, AddressOf OnCallSessionTransferTimeout
        AddHandler m_objVaxServerSIP.OnCallSessionTransfered, AddressOf OnCallSessionTransfered

        AddHandler m_objVaxServerSIP.OnChatMessageText, AddressOf OnChatMessageText
        AddHandler m_objVaxServerSIP.OnChatMessageTyping, AddressOf OnChatMessageTyping
        AddHandler m_objVaxServerSIP.OnChatStatusSubscribe, AddressOf OnChatStatusSubscribe

        AddHandler m_objVaxServerSIP.OnChatMessageSuccess, AddressOf OnChatMessageSuccess
        AddHandler m_objVaxServerSIP.OnChatMessageFailed, AddressOf OnChatMessageFailed
        AddHandler m_objVaxServerSIP.OnChatMessageTimeout, AddressOf OnChatMessageTimeout

        AddHandler m_objVaxServerSIP.OnDetectedDigitDTMF, AddressOf OnDetectedDigitDTMF

        AddHandler m_objVaxServerSIP.OnOutgoingDiagnosticLog, AddressOf OnOutgoingDiagnosticLog
        AddHandler m_objVaxServerSIP.OnIncomingDiagnosticLog, AddressOf OnIncomingDiagnosticLog

        AddHandler m_objVaxServerSIP.OnVaxTeleTick, AddressOf OnVaxTeleTick

        AddHandler m_objVaxServerSIP.OnSendTimeoutVM, AddressOf OnSendTimeoutVM
        AddHandler m_objVaxServerSIP.OnSendSuccessVM, AddressOf OnSendSuccessVM

        AddHandler m_objVaxServerSIP.OnCallSessionDialToneStart, AddressOf OnCallSessionDialToneStart
        AddHandler m_objVaxServerSIP.OnCallSessionDialToneStop, AddressOf OnCallSessionDialToneStop

        AddHandler m_objVaxServerSIP.OnCallSessionPlayWaveDone, AddressOf OnCallSessionPlayWaveDone
        AddHandler m_objVaxServerSIP.OnConferenceRoomPlayWaveDone, AddressOf OnConferenceRoomPlayWaveDone

        AddHandler m_objVaxServerSIP.OnCallSessionCreated, AddressOf OnCallSessionCreated

        AddHandler m_objVaxServerSIP.OnCallSessionOpenCall, AddressOf OnCallSessionOpenCall
        AddHandler m_objVaxServerSIP.OnCallSessionCloseCall, AddressOf OnCallSessionCloseCall

        AddHandler m_objVaxServerSIP.OnCallSessionDetectedAMD, AddressOf OnCallSessionDetectedAMD

        AddHandler m_objVaxServerSIP.OnCallSessionRecordedPCM, AddressOf OnCallSessionRecordedPCM
        AddHandler m_objVaxServerSIP.OnConferenceRoomRecordedPCM, AddressOf OnConferenceRoomRecordedPCM

        AddHandler m_objVaxServerSIP.OnBusyLampSubscribe, AddressOf OnBusyLampSubscribe
        AddHandler m_objVaxServerSIP.OnBusyLampUnSubscribe, AddressOf OnBusyLampUnSubscribe
        AddHandler m_objVaxServerSIP.OnBusyLampSubscribeSuccess, AddressOf OnBusyLampSubscribeSuccess
        AddHandler m_objVaxServerSIP.OnBusyLampSubscribeFailed, AddressOf OnBusyLampSubscribeFailed

        AddHandler m_objVaxServerSIP.OnVaxErrorLog, AddressOf OnVaxErrorLog

    End Sub

#Region "Functions"

    Public Sub SetLicenseKey(ByVal sLicenseKey As String)
        m_objVaxServerSIP.SetLicenseKey(sLicenseKey)
    End Sub

    Public Function AddListenIP(ByVal sSIPListenIP As String, ByVal sRTPListenIP As String) As Boolean
        Return m_objVaxServerSIP.AddListenIP(sSIPListenIP, sRTPListenIP)
    End Function

    Public Function Initialize(ByVal sDomainRealm As String, ByVal sSIPListenIP As String, ByVal nSIPListenPort As Integer, ByVal sRTPListenIP As String, ByVal nRTPListenPort As Integer) As Boolean
        Return m_objVaxServerSIP.Initialize(sDomainRealm, sSIPListenIP, nSIPListenPort, sRTPListenIP, nRTPListenPort)
    End Function

    Public Sub UnInitialize()
        m_objVaxServerSIP.UnInitialize()
    End Sub

    Public Function SetListenPortRangeRTP(ByVal nListenStartPort As Integer, ByVal nListenEndPort As Integer) As Boolean
        Return m_objVaxServerSIP.SetListenPortRangeRTP(nListenStartPort, nListenEndPort)
    End Function
     
    Public Function AddUser(ByVal sUserName As String, ByVal sPassword As String, ByVal sCodecList As String) As Boolean
        Return m_objVaxServerSIP.AddUser(sUserName, sPassword, sCodecList)
    End Function

    Public Sub RemoveUser(ByVal sUserName As String)
        m_objVaxServerSIP.RemoveUser(sUserName)
    End Sub

    Public Function RegisterUserExpiry(ByVal nExpiry As Integer) As Boolean
        Return m_objVaxServerSIP.RegisterUserExpiry(nExpiry)
    End Function

    Public Function AcceptRegister(ByVal sUserName As String) As Boolean
        Return m_objVaxServerSIP.AcceptRegister(sUserName)
    End Function

    Public Function RejectRegister(ByVal sUserName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String) As Boolean
        Return m_objVaxServerSIP.RejectRegister(sUserName, nStatusCode, sReasonPhrase)
    End Function

    Public Function AuthRegister(ByVal sUserName As String) As Boolean
        Return m_objVaxServerSIP.AuthRegister(sUserName)
    End Function

    Public Function AddLine(ByVal sLineName As String, ByVal sDisplayName As String, ByVal sUserName As String, ByVal sAuthUser As String, ByVal sAuthPwd As String, ByVal sDomainRealm As String, ByVal sProxySIP As String, ByVal sOutboundProxySIP As String, ByVal sCodecList As String) As Boolean
        Return m_objVaxServerSIP.AddLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sOutboundProxySIP, sCodecList)
    End Function

    Public Sub RemoveLine(ByVal sLineName As String)
        m_objVaxServerSIP.RemoveLine(sLineName)
    End Sub

    Public Function RegisterLine(ByVal sLineName As String, ByVal nExpire As Integer) As Boolean
        Return m_objVaxServerSIP.RegisterLine(sLineName, nExpire)
    End Function

    Public Function UnRegisterLine(ByVal sLineName As String) As Boolean
        Return m_objVaxServerSIP.UnRegisterLine(sLineName)
    End Function

    Public Function AddDirectProxySIP(ByVal sProxyName As String, ByVal sAuthLogin As String, ByVal sAuthPwd As String, ByVal sDomainRealm As String, ByVal sProxyIP As String, ByVal nProxyPort As Integer, ByVal sCodecList As String) As Boolean
        Return m_objVaxServerSIP.AddDirectProxySIP(sProxyName, sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP, nProxyPort, sCodecList)
    End Function

    Public Sub RemoveDirectProxySIP(ByVal sProxyName As String)
        m_objVaxServerSIP.RemoveDirectProxySIP(sProxyName)
    End Sub

    Public Function AcceptCallSession(ByVal nSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal nTimeout As Integer) As Boolean
        Return m_objVaxServerSIP.AcceptCallSession(nSessionId, sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, nTimeout)
    End Function

    Public Sub RejectCallSession(ByVal nSessionId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        m_objVaxServerSIP.RejectCallSession(nSessionId, nStatusCode, sReasonPhrase)
    End Sub

    Public Sub CloseCallSession(ByVal nSessionId As Integer)
        m_objVaxServerSIP.CloseCallSession(nSessionId)
    End Sub

    Public Function CreateCallSession(ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal nTimeout As Integer) As Integer
        Return m_objVaxServerSIP.CreateCallSession(sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, nTimeout)
    End Function

    Public Function OpenCallSession(ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal nTimeout As Integer) As Integer
        Return m_objVaxServerSIP.OpenCallSession(sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, nTimeout)
    End Function

    Public Function AcceptTransferBlind(ByVal nTransfererSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sTransferTo As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal nTimeout As Integer) As Integer
        Return m_objVaxServerSIP.AcceptTransferBlind(nTransfererSessionId, sCallerName, sCallerId, sTransferTo, nToPeerType, sToPeerName, nTimeout)
    End Function

    Public Function AcceptTransferConsult(ByVal nTransfererSessionId As Integer, ByVal nTransferToSessionId As Integer) As Integer
        Return m_objVaxServerSIP.AcceptTransferConsult(nTransfererSessionId, nTransferToSessionId)
    End Function

    Public Sub RejectTransfer(ByVal nSessionId As Integer)
        m_objVaxServerSIP.RejectTransfer(nSessionId)
    End Sub

    Public Function PlayWaveStartToCallSession(ByVal nSessionId As Integer, ByVal nWaveId As Integer, ByVal bLoop As Boolean) As Boolean
        Return m_objVaxServerSIP.PlayWaveStartToCallSession(nSessionId, nWaveId, bLoop)
    End Function

    Public Function PlayWaveStopToCallSession(ByVal nSessionId As Integer) As Boolean
        Return m_objVaxServerSIP.PlayWaveStopToCallSession(nSessionId)
    End Function

    Public Function RecordWaveStartToCallSession(ByVal nSessionId As Integer, ByVal sFileName As String) As Boolean
        Return m_objVaxServerSIP.RecordWaveStartToCallSession(nSessionId, sFileName)
    End Function

    Public Function RecordWaveStopToCallSession(ByVal nSessionId As Integer) As Boolean
        Return m_objVaxServerSIP.RecordWaveStopToCallSession(nSessionId)
    End Function

    Public Function RecordWavePauseToCallSession(ByVal nSessionId As Integer, ByVal bEnable As Boolean) As Boolean
        Return m_objVaxServerSIP.RecordWavePauseToCallSession(nSessionId, bEnable)
    End Function

    Public Function LoadWaveFile(ByVal sFileName As String) As Integer
        Return m_objVaxServerSIP.LoadWaveFile(sFileName)
    End Function

    Public Function LoadWavePCM(ByVal aDataPCM As Byte(), ByVal nSizePCM As Integer) As Integer

        Dim hHandleGC As GCHandle = GCHandle.Alloc(aDataPCM, GCHandleType.Pinned)
        Dim AddrDataPCM As IntPtr = hHandleGC.AddrOfPinnedObject()
        Dim lDataPCM As Long = AddrDataPCM.ToInt64()

        Dim nWaveId As Integer = m_objVaxServerSIP.LoadWavePCM(lDataPCM, nSizePCM, 0)

        hHandleGC.Free()
        Return nWaveId

    End Function

    Public Sub UnLoadWaveFile(ByVal nWaveId As Integer)
        m_objVaxServerSIP.UnLoadWaveFile(nWaveId)
    End Sub

    Public Function LoadMusicHold(ByVal sFileName As String) As Boolean
        Return m_objVaxServerSIP.LoadMusicHold(sFileName)
    End Function

    Public Sub UnLoadMusicHold()
        m_objVaxServerSIP.UnLoadMusicHold()
    End Sub

    Public Function AcceptOnHoldRequest(ByVal nSessionId As Integer) As Boolean
        Return m_objVaxServerSIP.AcceptOnHoldRequest(nSessionId)
    End Function

    Public Function AcceptOffHoldRequest(ByVal nSessionId As Integer) As Boolean
        Return m_objVaxServerSIP.AcceptOffHoldRequest(nSessionId)
    End Function

    Public Function AcceptChatMessage(ByVal nChatMsgId As Integer, ByVal nToPeerType As Integer, ByVal sToPeerName As String) As Boolean
        Return m_objVaxServerSIP.AcceptChatMessage(nChatMsgId, nToPeerType, sToPeerName)
    End Function

    Public Sub RejectChatMessage(ByVal nChatMsgId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        m_objVaxServerSIP.RejectChatMessage(nChatMsgId, nStatusCode, sReasonPhrase)
    End Sub

    Public Function AcceptChatStatusSubscribe(ByVal nStatusSubscribe As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String) As Boolean
        Return m_objVaxServerSIP.AcceptChatStatusSubscribe(nStatusSubscribe, sMsgFrom, sMsgTo, nToPeerType, sToPeerName)
    End Function

    Public Sub RejectChatStatusSubscribe(ByVal nStatusSubscribe As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String)
        m_objVaxServerSIP.RejectChatStatusSubscribe(nStatusSubscribe, sMsgFrom, sMsgTo)
    End Sub

    Public Function OpenConferenceRoom(ByVal sRoomName As String) As Boolean
        Return m_objVaxServerSIP.OpenConferenceRoom(sRoomName)
    End Function

    Public Sub CloseConferenceRoom(ByVal sRoomName As String)
        m_objVaxServerSIP.CloseConferenceRoom(sRoomName)
    End Sub

    Public Function AddCallSessionToConferenceRoom(ByVal sRoomName As String, ByVal nSessionId As Integer, ByVal nType As Integer) As Boolean
        Return m_objVaxServerSIP.AddCallSessionToConferenceRoom(sRoomName, nSessionId, nType)
    End Function

    Public Function RemoveCallSessionFromConferenceRoom(ByVal nSessionId As Integer) As Boolean
        Return m_objVaxServerSIP.RemoveCallSessionFromConferenceRoom(nSessionId)
    End Function

    Public Function PlayWaveStartToConferenceRoom(ByVal sRoomName As String, ByVal nWaveId As Integer, ByVal bLoop As Boolean) As Boolean
        Return m_objVaxServerSIP.PlayWaveStartToConferenceRoom(sRoomName, nWaveId, bLoop)
    End Function

    Public Function PlayWaveStopToConferenceRoom(ByVal sRoomName As String) As Boolean
        Return m_objVaxServerSIP.PlayWaveStopToConferenceRoom(sRoomName)
    End Function

    Public Function RecordWaveStartToConferenceRoom(ByVal sRoomName As String, ByVal sFileName As String) As Boolean
        Return m_objVaxServerSIP.RecordWaveStartToConferenceRoom(sRoomName, sFileName)
    End Function

    Public Function RecordWaveStopToConferenceRoom(ByVal sRoomName As String) As Boolean
        Return m_objVaxServerSIP.RecordWaveStopToConferenceRoom(sRoomName)
    End Function

    Public Function RecordWavePauseToConferenceRoom(ByVal sRoomName As String, ByVal bEnable As Boolean) As Boolean
        Return m_objVaxServerSIP.RecordWavePauseToConferenceRoom(sRoomName, bEnable)
    End Function

    Public Function VoiceSessionLost(ByVal bEnable As Boolean, ByVal nTimeout As Integer) As Boolean
        Return m_objVaxServerSIP.VoiceSessionLost(bEnable, nTimeout)
    End Function

    Public Function SendInfoVM(ByVal sUserLogin As String, ByVal nNewMsgCount As Integer, ByVal nOldMsgCount As Integer, ByVal bMsgWaiting As Boolean) As Integer
        Return m_objVaxServerSIP.SendInfoVM(sUserLogin, nNewMsgCount, nOldMsgCount, bMsgWaiting)
    End Function

    Public Function StartVaxTeleTick(ByVal nTickId As Integer, ByVal nElapse As Integer) As Boolean
        Return m_objVaxServerSIP.StartVaxTeleTick(nTickId, nElapse)
    End Function

    Public Function StopVaxTeleTick(ByVal nTickId As Integer) As Boolean
        Return m_objVaxServerSIP.StopVaxTeleTick(nTickId)
    End Function

    Public Function SetUserAgentName(ByVal sName As String) As Boolean
        Return m_objVaxServerSIP.SetUserAgentName(sName)
    End Function

    Public Function GetUserAgentName() As String
        Return m_objVaxServerSIP.GetUserAgentName().ToString()
    End Function

    Public Function SetSessionNameSDP(ByVal sName As String) As Boolean
        Return m_objVaxServerSIP.SetSessionNameSDP(sName)
    End Function

    Public Function GetSessionNameSDP() As String
        Return m_objVaxServerSIP.GetSessionNameSDP().ToString()
    End Function

    Public Function SendDTMFCallSession(ByVal nSessionId As Integer, ByVal nTypeDTMF As Integer, ByVal nDigit As Integer) As Boolean
        Return m_objVaxServerSIP.SendDTMFCallSession(nSessionId, nDigit, nTypeDTMF)
    End Function

    Public Function DetectDigitDTMF(ByVal nSessionId As Integer, ByVal nCallType As Integer, ByVal nTypeDTMF As Integer, ByVal bEnable As Boolean, ByVal nMilliSecondTimeout As Integer) As Boolean
        Return m_objVaxServerSIP.DetectDigitDTMF(nSessionId, nCallType, nTypeDTMF, bEnable, nMilliSecondTimeout)
    End Function

    Public Function GetVaxObjectError() As Integer
        Return m_objVaxServerSIP.GetVaxObjectError()
    End Function

    Public Function DialToneToCallSession(ByVal bEnable As Boolean, ByVal nSessionId As Integer, ByVal nWaveId As Integer) As Boolean
        Return m_objVaxServerSIP.DialToneToCallSession(bEnable, nSessionId, nWaveId)
    End Function

    Public Function DiagnosticLogSIP(ByVal bInbound As Boolean, ByVal bOutbound As Boolean) As Boolean
        Return m_objVaxServerSIP.DiagnosticLogSIP(bInbound, bOutbound)
    End Function

    Public Function CallSessionSwapCalls(ByVal nSessionId As Integer) As Boolean
        Return m_objVaxServerSIP.CallSessionSwapCalls(nSessionId)
    End Function

    Public Function MergeCallSession(ByVal nFromSessionId As Integer, ByVal nToSessionId As Integer) As Integer
        Return m_objVaxServerSIP.MergeCallSession(nFromSessionId, nToSessionId)
    End Function

    Public Function CallSessionSendStatusResponse(ByVal nSessionId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        Return m_objVaxServerSIP.CallSessionSendStatusResponse(nSessionId, nStatusCode, sReasonPhrase)
    End Function

    Public Function CallSessionDetectAMD(ByVal nSessionId As Integer, ByVal nCallType As Integer, ByVal bEnable As Boolean, ByVal nAnalysisTime As Integer, ByVal nSilenceTime As Integer, ByVal nSilenceCount As Integer) As Boolean
        Return m_objVaxServerSIP.CallSessionDetectAMD(nSessionId, nCallType, bEnable, nAnalysisTime, nSilenceTime, nSilenceCount)
    End Function

    Public Function AddCustomHeader(ByVal nReqId As Integer, ByVal sName As String, ByVal sValue As String) As Boolean
        Return m_objVaxServerSIP.AddCustomHeader(nReqId, sName, sValue)
    End Function

    Public Function RemoveCustomHeader(ByVal nReqId As Integer, ByVal sName As String) As Boolean
        Return m_objVaxServerSIP.RemoveCustomHeader(nReqId, sName)
    End Function

    Public Function RemoveCustomHeaderAll(ByVal nReqId As Integer) As Boolean
        Return m_objVaxServerSIP.RemoveCustomHeaderAll(nReqId)
    End Function

    '/////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////

    Public Function GetCallSessionTxCodec(ByVal nSessionId As Integer, ByVal nCallType As Integer)
        Return m_objVaxServerSIP.GetCallSessionTxCodec(nSessionId, nCallType)
    End Function

    Public Function GetCallSessionRxCodec(ByVal nSessionId As Integer, ByVal nCallType As Integer) As Integer
        Return m_objVaxServerSIP.GetCallSessionRxCodec(nSessionId, nCallType)
    End Function

    '/////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////

    Public Function BusyLampSubscribeAccept(ByVal nSubScrbId As Integer, ByVal bAuthenticate As Boolean, ByVal nExpires As Integer) As Boolean
        Return m_objVaxServerSIP.BusyLampSubscribeAccept(nSubScrbId, bAuthenticate, nExpires)
    End Function

    Public Function BusyLampSubscribeReject(ByVal nSubScrbId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String) As Boolean
        Return m_objVaxServerSIP.BusyLampSubscribeReject(nSubScrbId, nStatusCode, sReasonPhrase)
    End Function

    '/////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////

    Public Function SetCallSessionData(ByVal nSessionId As Integer, ByVal objCustomData As Object) As Boolean

        Dim hGC As GCHandle = GCHandle.Alloc(objCustomData)

        If (Not m_objVaxServerSIP.SetCallSessionData(nSessionId, CType(CType(hGC, IntPtr), Long))) Then
            hGC.Free()
            Return False
        End If

        Return True

    End Function

    Public Function GetCallSessionData(ByVal nSessionId As Integer) As Object

        Dim lData As Long = m_objVaxServerSIP.GetCallSessionData(nSessionId)

        If (lData = 0) Then
            Return Nothing
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        Return CType(hGC.Target, Object)

    End Function

    Public Sub FreeCallSessionData(ByVal nSessionId As Integer)

        Dim lData As Long = m_objVaxServerSIP.GetCallSessionData(nSessionId)

        If (lData = 0) Then
            Return
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        hGC.Free()

    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////

    Public Function SetUserData(ByVal sUserName As String, ByVal objCustomData As Object)

        Dim hGC As GCHandle = GCHandle.Alloc(objCustomData)

        If (Not m_objVaxServerSIP.SetUserData(sUserName, CType(CType(hGC, IntPtr), Long))) Then
            hGC.Free()
            Return False
        End If

        Return True

    End Function

    Public Function GetUserData(ByVal sUserName As String) As Object

        Dim lData As Long = m_objVaxServerSIP.GetUserData(sUserName)

        If (lData = 0) Then
            Return Nothing
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        Return CType(hGC.Target, Object)

    End Function

    Public Sub FreeUserData(ByVal sUserName As String)

        Dim lData As Long = m_objVaxServerSIP.GetUserData(sUserName)

        If (lData = 0) Then
            Return
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        hGC.Free()

    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////

    Public Function SetLineData(ByVal sLineName As String, ByVal objCustomData As Object)

        Dim hGC As GCHandle = GCHandle.Alloc(objCustomData)

        If (Not m_objVaxServerSIP.SetLineData(sLineName, CType(CType(hGC, IntPtr), Long))) Then
            hGC.Free()
            Return False
        End If

        Return True

    End Function

    Public Function GetLineData(ByVal sLineName As String) As Object

        Dim lData As Long = m_objVaxServerSIP.GetLineData(sLineName)

        If (lData = 0) Then
            Return Nothing
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        Return CType(hGC.Target, Object)

    End Function

    Public Sub FreeLineData(ByVal sLineName As String)

        Dim lData As Long = m_objVaxServerSIP.GetLineData(sLineName)

        If (lData = 0) Then
            Return
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        hGC.Free()

    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////

    Public Function SetDirectProxyData(ByVal sProxyName As String, ByVal objCustomData As Object) As Boolean

        Dim hGC As GCHandle = GCHandle.Alloc(objCustomData)

        If (Not m_objVaxServerSIP.SetDirectProxyData(sProxyName, CType(CType(hGC, IntPtr), Long))) Then
            hGC.Free()
            Return False
        End If

        Return True

    End Function

    Public Function GetDirectProxyData(ByVal sProxyName As String) As Object

        Dim lData As Long = m_objVaxServerSIP.GetDirectProxyData(sProxyName)

        If (lData = 0) Then
            Return Nothing
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        Return CType(hGC.Target, Object)

    End Function

    Public Sub FreeDirectProxyData(ByVal sProxyName As String)

        Dim lData As Long = m_objVaxServerSIP.GetDirectProxyData(sProxyName)

        If (lData = 0) Then
            Return
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        hGC.Free()

    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////

    Public Function SetConferenceRoomData(ByVal sRoomName As String, ByVal objCustomData As Object) As Boolean

        Dim hGC As GCHandle = GCHandle.Alloc(objCustomData)

        If (Not m_objVaxServerSIP.SetConferenceRoomData(sRoomName, CType(CType(hGC, IntPtr), Long))) Then
            hGC.Free()
            Return False
        End If

        Return True

    End Function

    Public Function GetConferenceRoomData(ByVal sRoomName As String) As Object

        Dim lData As Long = m_objVaxServerSIP.GetDirectProxyData(sRoomName)

        If (lData = 0) Then
            Return Nothing
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        Return CType(hGC.Target, Object)

    End Function

    Public Sub FreeConferenceRoomData(ByVal sRoomName As String)

        Dim lData As Long = m_objVaxServerSIP.GetConferenceRoomData(sRoomName)

        If (lData = 0) Then
            Return
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        hGC.Free()

    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////

    Public Function TrvsUserStart() As Boolean
        Return m_objVaxServerSIP.TrvsUserStart()
    End Function

    Public Function TrvsUserNext() As String
        Return m_objVaxServerSIP.TrvsUserNext()
    End Function

    Public Function TrvsLineStart() As Boolean
        Return m_objVaxServerSIP.TrvsLineStart()
    End Function

    Public Function TrvsLineNext() As String
        Return m_objVaxServerSIP.TrvsLineNext()
    End Function

    Public Function TrvsDirectProxyStart() As Boolean
        Return m_objVaxServerSIP.TrvsDirectProxyStart()
    End Function

    Public Function TrvsDirectProxyNext() As String
        Return m_objVaxServerSIP.TrvsDirectProxyNext()
    End Function

    Public Function TrvsCallSessionStart() As Boolean
        Return m_objVaxServerSIP.TrvsCallSessionStart()
    End Function

    Public Function TrvsCallSessionNext() As Integer
        Return m_objVaxServerSIP.TrvsCallSessionNext()
    End Function

    Public Function TrvsConferenceRoomStart()
        Return m_objVaxServerSIP.TrvsConferenceRoomStart()
    End Function

    Public Function TrvsConferenceRoomNext() As String
        Return m_objVaxServerSIP.TrvsConferenceRoomNext()
    End Function

    '/////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////

    Public Function GetUserCount() As Integer
        Return m_objVaxServerSIP.GetUserCount()
    End Function

    Public Function GetLineCount() As Integer
        Return m_objVaxServerSIP.GetLineCount()
    End Function

    Public Function GetDirectProxyCount() As Integer
        Return m_objVaxServerSIP.GetDirectProxyCount()
    End Function

    Public Function GetCallSessionCount() As Integer
        Return m_objVaxServerSIP.GetCallSessionCount()
    End Function

    Public Function GetConferenceRoomCount() As Integer
        Return m_objVaxServerSIP.GetConferenceRoomCount()
    End Function

    '/////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////

    Public Function CustomListOpen(ByVal nTableSize As Integer) As Integer
        Return m_objVaxServerSIP.CustomListOpen(nTableSize)
    End Function

    Public Function CustomListClose(ByVal nListId As Integer) As Boolean
        Return m_objVaxServerSIP.CustomListClose(nListId)
    End Function

    Public Function CustomListAddData(ByVal nListId As Integer, ByVal sKey As String, ByVal objCustomData As Object) As Boolean

        Dim hGC As GCHandle = GCHandle.Alloc(objCustomData)

        If (Not m_objVaxServerSIP.CustomListAddData(nListId, sKey, CType(CType(hGC, IntPtr), Long))) Then
            hGC.Free()
            Return False
        End If

        Return True

    End Function

    Public Function CustomListRemoveData(ByVal nListId As Integer, ByVal sKey As String) As Boolean

        Dim lData As Long = m_objVaxServerSIP.CustomListFindData(nListId, sKey)

        If (lData = 0) Then
            Return False
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        hGC.Free()

        Return m_objVaxServerSIP.CustomListRemoveData(nListId, sKey)

    End Function

    Public Function CustomListFindData(ByVal nListId As Integer, ByVal sKey As String) As Object

        Dim lData As Long = m_objVaxServerSIP.CustomListFindData(nListId, sKey)

        If (lData = 0) Then
            Return Nothing
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        Return CType(hGC.Target, Object)

    End Function

    Public Function CustomListCount(ByVal nListId As Integer) As Integer
        Return m_objVaxServerSIP.CustomListCount(nListId)
    End Function

    Public Function CustomListReset(ByVal nListId As Integer) As Boolean
        Return m_objVaxServerSIP.CustomListReset(nListId)
    End Function

    Public Function CustomListTrvsStart(ByVal nListId As Integer) As Boolean
        Return m_objVaxServerSIP.CustomListTrvsStart(nListId)
    End Function

    Public Function CustomListTrvsNext(ByVal nListId As Integer) As Object

        Dim lData As Long = m_objVaxServerSIP.CustomListTrvsNext(nListId)

        If (lData = 0) Then
            Return Nothing
        End If

        Dim hGC As GCHandle = CType(CType(lData, IntPtr), GCHandle)
        Return CType(hGC.Target, Object)

    End Function

    Public Function GetCallSessionHeaderCallId(ByVal nSessionId As Integer, ByVal nCallType As Integer) As String
        Return m_objVaxServerSIP.GetCallSessionHeaderCallId(nSessionId, nCallType)
    End Function

    Public Function CallSessionMuteVoice(ByVal nSessionId As Integer, ByVal nCallType As Integer, ByVal bListen As Boolean, ByVal bSpeak As Boolean) As Boolean
        Return m_objVaxServerSIP.CallSessionMuteVoice(nSessionId, nCallType, bListen, bSpeak)
    End Function

    Public Function VideoCOMM(ByVal bEnable As Boolean) As Boolean
        Return m_objVaxServerSIP.VideoCOMM(bEnable)
    End Function

#End Region


#Region "Events"

    Public Overridable Sub OnLineRegisterTrying(ByVal sLineName As String)
    End Sub

    Public Overridable Sub OnLineRegisterFailed(ByVal sLineName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnLineRegisterSuccess(ByVal sLineName As String)
    End Sub

    Public Overridable Sub OnLineUnRegisterTrying(ByVal sLineName As String)
    End Sub

    Public Overridable Sub OnLineUnRegisterFailed(ByVal sLineName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnLineUnRegisterSuccess(ByVal sLineName As String)
    End Sub

    Public Overridable Sub OnUnRegisterUser(ByVal sUserLogin As String)
    End Sub

    Public Overridable Sub OnRegisterUser(ByVal sUserLogin As String, ByVal sDomain As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Public Overridable Sub OnRegisterUserSuccess(ByVal sUserLogin As String)
    End Sub

    Public Overridable Sub OnRegisterUserFailed(ByVal sUserLogin As String)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnCallSessionCreated(ByVal nSessionId As Integer, ByVal nReasonCode As Integer)
    End Sub

    Public Overridable Sub OnCallSessionClosed(ByVal nSessionId As Integer, ByVal nCallType As Integer, ByVal nReasonCode As Integer)
    End Sub

    Public Overridable Sub OnCallSessionOpen(ByVal nSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Public Overridable Sub OnCallSessionConnecting(ByVal nSessionId As Integer, ByVal nCallType As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnCallSessionFailed(ByVal nSessionId As Integer, ByVal nCallType As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnCallSessionConnected(ByVal nSessionId As Integer)
    End Sub

    Public Overridable Sub OnCallSessionLost(ByVal nSessionId As Integer, ByVal nCallType As Integer)
    End Sub

    Public Overridable Sub OnCallSessionHangup(ByVal nSessionId As Integer, ByVal nCallType As Integer)
    End Sub

    Public Overridable Sub OnCallSessionTimeout(ByVal nSessionId As Integer, ByVal nCallType As Integer)
    End Sub

    Public Overridable Sub OnCallSessionCancelled(ByVal nSessionId As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnCallSessionOnHold(ByVal nSessionId As Integer, ByVal nCallType As Integer)
    End Sub

    Public Overridable Sub OnCallSessionOffHold(ByVal nSessionId As Integer, ByVal nCallType As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnCallSessionTransferBlind(ByVal nTransfererSessionId As Integer, ByVal nTransfererCallType As Integer, ByVal sTransferer As String, ByVal sTransferee As String, ByVal sTransferTo As String)
    End Sub

    Public Overridable Sub OnCallSessionTransferConsult(ByVal nTransfererSessionId As Integer, ByVal nTransfereeSessionId As Integer, ByVal nTransferToSessionId As Integer, ByVal nTransfererCallType As Integer, ByVal nTransfereeCallType As Integer, ByVal nTransferToCallType As Integer, ByVal sTransferer As String, ByVal sTransferee As String, ByVal sTransferTo As String)
    End Sub

    Public Overridable Sub OnCallSessionTransfering(ByVal nSessionId As Integer, ByVal nTransferType As Integer, ByVal nCallType As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnCallSessionTransferFailed(ByVal nSessionId As Integer, ByVal nTransferType As Integer, ByVal nCallType As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnCallSessionTransferTimeout(ByVal nSessionId As Integer, ByVal nTransferType As Integer, ByVal nCallType As Integer)
    End Sub

    Public Overridable Sub OnCallSessionTransfered(ByVal nSessionId As Integer, ByVal nTransferType As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnChatMessageText(ByVal nChatMsgId As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal sMsgText As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Public Overridable Sub OnChatMessageTyping(ByVal nChatMsgId As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal bIsTypingStart As Boolean, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Public Overridable Sub OnChatStatusSubscribe(ByVal nSubscrbId As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Public Overridable Sub OnChatMessageSuccess(ByVal nChatMsgId As Integer)
    End Sub

    Public Overridable Sub OnChatMessageFailed(ByVal nChatMsgId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
    End Sub

    Public Overridable Sub OnChatMessageTimeout(ByVal nChatMsgId As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnDetectedDigitDTMF(ByVal nSessionId As Integer, ByVal nCallType As Integer, ByVal sDigitDTMF As String)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnOutgoingDiagnosticLog(ByVal sMsgSIP As String, ByVal sToIP As String, ByVal nToPort As Integer)
    End Sub

    Public Overridable Sub OnIncomingDiagnosticLog(ByVal sMsgSIP As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnVaxTeleTick(ByVal nTickId As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnSendTimeoutVM(ByVal nMsgIdVM As Integer)
    End Sub

    Public Overridable Sub OnSendSuccessVM(ByVal nMsgIdVM As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnCallSessionDialToneStart(ByVal nSessionId As Integer, ByVal nWaveId As Integer)
    End Sub

    Public Overridable Sub OnCallSessionDialToneStop(ByVal nSessionId As Integer, ByVal nWaveId As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnCallSessionPlayWaveDone(ByVal nSessionId As Integer, ByVal nWaveId As Integer)
    End Sub

    Public Overridable Sub OnConferenceRoomPlayWaveDone(ByVal sRoomName As String, ByVal nWaveId As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnCallSessionOpenCall(ByVal nSessionId As Integer, ByVal nCallType As Integer, ByVal nPeerType As Integer, ByVal sPeerName As String)
    End Sub

    Public Overridable Sub OnCallSessionCloseCall(ByVal nSessionId As Integer, ByVal nCallType As Integer, ByVal nPeerType As Integer, ByVal sPeerName As String)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnCallSessionDetectedAMD(ByVal nSessionId As Integer, ByVal nCallType As Integer, ByVal bIsHuman As Boolean)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub OnCallSessionRecordedPCM(ByVal nSessionId As Integer, ByVal lDataPCM As Long, ByVal nSizePCM As Integer, ByVal nTypePCM As Integer)

        Dim aDataPCM() As Byte = New Byte(nSizePCM) {}
        Marshal.Copy(New IntPtr(lDataPCM), aDataPCM, 0, nSizePCM)

        OnCallSessionRecordedPCM(nSessionId, aDataPCM, nSizePCM)

    End Sub

    Public Overridable Sub OnCallSessionRecordedPCM(ByVal nSessionId As Integer, ByVal aDataPCM As Byte(), ByVal nSizePCM As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub OnConferenceRoomRecordedPCM(ByVal sRoomName As String, ByVal lDataPCM As Long, ByVal nSizePCM As Integer, ByVal nTypePCM As Integer)

        Dim aDataPCM() As Byte = New Byte(nSizePCM) {}
        Marshal.Copy(New IntPtr(lDataPCM), aDataPCM, 0, nSizePCM)

        OnConferenceRoomRecordedPCM(sRoomName, aDataPCM, nSizePCM)

    End Sub

    Public Overridable Sub OnConferenceRoomRecordedPCM(ByVal sRoomName As String, ByVal aDataPCM As Byte(), ByVal nSizePCM As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnBusyLampSubscribe(ByVal nSubScrbId As Integer, ByVal sUserName As String, ByVal sToUserName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Public Overridable Sub OnBusyLampUnSubscribe(ByVal nSubScrbId As Integer, ByVal sUserName As String, ByVal sToUserName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Public Overridable Sub OnBusyLampSubscribeSuccess(ByVal nSubScrbId As Integer, ByVal sUserName As String)
    End Sub

    Public Overridable Sub OnBusyLampSubscribeFailed(ByVal nSubScrbId As Integer, ByVal sUserName As String)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overridable Sub OnVaxErrorLog(ByVal sFuncName As String, ByVal nErrorCode As Integer, ByVal sErrorMsg As String)
    End Sub

#End Region


End Class
