﻿
Public Class CVaxServerExCOM : Inherits CVaxServerCOM

    Dim m_nTotalCallCount As Integer = 0
    Dim m_nDialToneId As Integer = -1
    Dim m_nRegisterUserCount As Integer = 0

    Dim m_objRouteCallSIP As CVaxCallSessionRoute = Nothing
    Dim m_objConfRoom As CConfRoom = Nothing
    Dim m_objChat As CVaxChat = Nothing
    
#Region "Functions"

    Sub New()

        m_objRouteCallSIP = New CVaxCallSessionRoute
        m_objConfRoom = New CConfRoom(Me)
        m_objChat = New CVaxChat(Me)

    End Sub

    Public Overloads Sub SetLicenseKey(ByVal sLicenseKey As String)
        MyBase.SetLicenseKey(sLicenseKey)
    End Sub

    Public Overloads Function Initialize(ByVal sDomainRealm As String, ByVal sSIPListenIP As String, ByVal nSIPListenPort As Integer, ByVal sRTPListenIP As String, ByVal nRTPListenPort As Integer) As Boolean
        Return MyBase.Initialize(sDomainRealm, sSIPListenIP, nSIPListenPort, sRTPListenIP, nRTPListenPort)
    End Function

    Public Overloads Sub UnInitialize()
        m_nTotalCallCount = 0
        m_nRegisterUserCount = 0

        m_objConfRoom.DeleteRoomAll()

        DeleteUserDataAll()
        DeleteCallSessionDataAll()

        MyBase.UnInitialize()
    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overloads Function AddUser(ByVal sUserName As String, ByVal sPassword As String, ByVal sCodecList As String, ByVal bBlocked As Boolean, ByVal sUserPrefix As String, ByVal sDialPrefix As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String) As Boolean

        If (Not MyBase.AddUser(sUserName, sPassword, sCodecList)) Then
            Return False
        End If

        Dim objUser As CVaxUser = New CVaxUser(Me)
        MyBase.SetUserData(sUserName, objUser)

        objUser.SetData(sPassword, sCodecList, bBlocked, sUserPrefix, sDialPrefix, nToPeerType, sToPeerName)

        Return True

    End Function

    Public Overloads Sub RemoveUser(ByVal sUserName As String)
        MyBase.RemoveUser(sUserName)
        MyBase.FreeUserData(sUserName)
    End Sub

    Public Sub GetUserAll(ByRef objList As ArrayList)

        MyBase.TrvsUserStart()

        While (True)
            Dim sUserName As String = MyBase.TrvsUserNext()

            If (sUserName.Length = 0) Then
                Return
            End If

            objList.Add(sUserName)
        End While

    End Sub

    Public Function GetUserDetails(ByVal sUserName As String, ByRef sPassword As String, ByRef sCodecList As String, ByRef bBlocked As Boolean, ByRef sUserPrefix As String, ByRef sDialPrefix As String, ByRef nToPeerType As Integer, ByRef sToPeerName As String) As Boolean

        Dim objUser As CVaxUser = CType(MyBase.GetUserData(sUserName), CVaxUser)

        If (objUser Is Nothing) Then
            Return False
        End If

        objUser.GetData(sPassword, sCodecList, bBlocked, sUserPrefix, sDialPrefix, nToPeerType, sToPeerName)
        Return True

    End Function


    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overloads Function AddLine(ByVal sLineName As String, ByVal sDisplayName As String, ByVal sUserName As String, ByVal sAuthUser As String, ByVal sAuthPwd As String, ByVal sDomainRealm As String, ByVal sProxySIP As String, ByVal sCodecList As String, ByVal bRegister As Boolean, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal bBlocked As Boolean, ByVal sRoomName As String) As Boolean

        If (Not MyBase.AddLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, "", sCodecList)) Then
            Return False
        End If

        Dim objLine As CVaxLine = New CVaxLine(Me)
        MyBase.SetLineData(sLineName, objLine)

        objLine.SetData(sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sCodecList, bRegister, nToPeerType, sToPeerName, bBlocked, sRoomName)

        If (bRegister) Then
            MyBase.RegisterLine(sLineName, 1800)
        End If

        Return True

    End Function

    Public Overloads Sub RemoveLine(ByVal sLineName As String)
        MyBase.RemoveLine(sLineName)
        MyBase.FreeLineData(sLineName)
    End Sub

    Public Sub GetLineAll(ByRef objList As ArrayList)

        MyBase.TrvsLineStart()

        While (True)
            Dim sLineName As String = MyBase.TrvsLineNext()

            If (sLineName.Length = 0) Then
                Return
            End If

            objList.Add(sLineName)
        End While

    End Sub

    Public Function GetLineDetails(ByVal sLineName As String, ByRef sDisplayName As String, ByRef sUserName As String, ByRef sAuthUser As String, ByRef sAuthPwd As String, ByRef sDomainRealm As String, ByRef sProxySIP As String, ByRef sCodecList As String, ByRef bRegister As Boolean, ByRef nToPeerType As Integer, ByRef sToPeerName As String, ByRef bBlocked As Boolean, ByRef sRoomName As String) As Boolean

        Dim objLine As CVaxLine = CType(MyBase.GetLineData(sLineName), CVaxLine)

        If (objLine Is Nothing) Then
            Return False
        End If

        objLine.GetData(sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sCodecList, bRegister, nToPeerType, sToPeerName, bBlocked, sRoomName)
        Return True

    End Function

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overloads Function AddDirectProxySIP(ByVal sProxyName As String, ByVal sAuthLogin As String, ByVal sAuthPwd As String, ByVal sDomainRealm As String, ByVal sProxyIP As String, ByVal nProxyPort As Integer, ByVal sCodecList As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal bBlocked As Boolean, ByVal sRoomName As String) As Boolean

        If (Not MyBase.AddDirectProxySIP(sProxyName, sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP, nProxyPort, sCodecList)) Then
            Return False
        End If

        Dim objProxy As CVaxDirectProxy = New CVaxDirectProxy(Me)
        MyBase.SetDirectProxyData(sProxyName, objProxy)

        objProxy.SetData(sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP, nProxyPort, sCodecList, nToPeerType, sToPeerName, bBlocked, sRoomName)
        Return True

    End Function

    Public Overloads Sub RemoveDirectProxySIP(ByVal sProxyName As String)
        MyBase.RemoveDirectProxySIP(sProxyName)
        MyBase.FreeDirectProxyData(sProxyName)
    End Sub

    Public Sub GetDirectProxyAll(ByRef objList As ArrayList)

        MyBase.TrvsDirectProxyStart()

        While (True)
            Dim sProxyName As String = MyBase.TrvsDirectProxyNext()

            If (sProxyName.Length = 0) Then
                Return
            End If

            objList.Add(sProxyName)
        End While

    End Sub

    Public Function GetDirectProxyDetails(ByVal sProxyName As String, ByRef sAuthLogin As String, ByRef sAuthPwd As String, ByRef sDomainRealm As String, ByRef sProxyIP As String, ByRef nProxyPort As Integer, ByRef sCodecList As String, ByRef nToPeerType As Integer, ByRef sToPeerName As String, ByRef bBlocked As Boolean, ByRef sRoomName As String) As Boolean

        Dim objProxy As CVaxDirectProxy = CType(MyBase.GetDirectProxyData(sProxyName), CVaxDirectProxy)

        If (objProxy Is Nothing) Then
            Return False
        End If

        objProxy.GetData(sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP, nProxyPort, sCodecList, nToPeerType, sToPeerName, bBlocked, sRoomName)
        Return True

    End Function

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overloads Function GetVaxObjectError() As Integer
        Return MyBase.GetVaxObjectError()
    End Function

    Public Overloads Function DialToneToCallSession(ByVal bEnable As Boolean, ByVal nSessionId As Integer) As Boolean

        If (m_nDialToneId = -1) Then
            Return True
        End If

        Return MyBase.DialToneToCallSession(bEnable, nSessionId, m_nDialToneId)

    End Function

    Public Function GetCallCount() As Integer
        Return m_nTotalCallCount
    End Function

    Public Function GetRegisteredUserCount() As Integer
        Return m_nRegisterUserCount
    End Function

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Function AddRoom(ByVal sRoomName As String, ByVal sRoomNo As String) As Boolean
        Return m_objConfRoom.AddRoom(sRoomName, sRoomNo)
    End Function

    Public Sub RemoveRoom(ByVal sRoomName As String)
        m_objConfRoom.RemoveRoom(sRoomName)
    End Sub

    Public Function GetRoomDetails(ByVal sRoomName As String, ByRef sRoomNo As String) As Boolean
        Return m_objConfRoom.GetRoomDetails(sRoomName, sRoomNo)
    End Function

    Public Function IsRoomNoExists(ByVal sRoomNo As String) As Boolean
        Return m_objConfRoom.IsRoomNoExists(sRoomNo)
    End Function

    Public Function GetRoomAll(ByRef objRoomList As ArrayList) As Boolean
        Return m_objConfRoom.GetRoomAll(objRoomList)
    End Function

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overloads Function LoadMusicDialTone(ByVal sFileName As String) As Boolean

        UnLoadMusicDialTone()

        m_nDialToneId = MyBase.LoadWaveFile(sFileName)
        Return (m_nDialToneId <> -1)

    End Function

    Public Overloads Sub UnLoadMusicDialTone()

        If (m_nDialToneId <> -1) Then
            MyBase.UnLoadWaveFile(m_nDialToneId)
            m_nDialToneId = -1
        End If

    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Function AddUserRoute(ByVal sUserName As String, ByVal sUserPrefix As String, ByVal sDialPrefix As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String) As Boolean
        Return m_objRouteCallSIP.AddUserRoute(sUserName, sUserPrefix, sDialPrefix, nToPeerType, sToPeerName)
    End Function

    Public Sub RemoveUserRoute(ByVal sUserName As String)
        m_objRouteCallSIP.RemoveUserRoute(sUserName)
    End Sub

    Public Function AddLineRoute(ByVal sLineName As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal bRejected As Boolean, ByVal sRoomName As String) As Boolean
        Return m_objRouteCallSIP.AddLineRoute(sLineName, nToPeerType, sToPeerName, bRejected, sRoomName)
    End Function

    Public Sub RemoveLineRoute(ByVal sLineName As String)
        m_objRouteCallSIP.RemoveLineRoute(sLineName)
    End Sub

    Public Function AddDirectProxyRoute(ByVal sProxyName As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal bRejected As Boolean, ByVal sRoomName As String) As Boolean
        Return m_objRouteCallSIP.AddDirectProxyRoute(sProxyName, nToPeerType, sToPeerName, bRejected, sRoomName)
    End Function

    Public Sub RemoveDirectProxyRoute(ByVal sProxyName As String)
        m_objRouteCallSIP.RemoveDirectProxyRoute(sProxyName)
    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Sub DeleteCallSessionDataAll()

        MyBase.TrvsCallSessionStart()
        
        For nCount As Integer = 0 To (MyBase.GetCallSessionCount() - 1)
            Dim nSessionId As Integer = MyBase.TrvsCallSessionNext()
            MyBase.FreeCallSessionData(nSessionId)
        Next

    End Sub

    Public Sub DeleteUserDataAll()

        MyBase.TrvsUserStart()
        
        For nCount As Integer = 0 To (MyBase.GetUserCount() - 1)
            Dim sUserName As String = MyBase.TrvsUserNext()
            MyBase.FreeUserData(sUserName)
        Next

    End Sub


    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

#End Region

#Region "Events"

    Public Overrides Sub OnCallSessionCreated(ByVal nSessionId As Integer, ByVal nReasonCode As Integer)

        Dim objCallSession As CVaxCallSession = New CVaxCallSession(Me)
        MyBase.SetCallSessionData(nSessionId, objCallSession)

    End Sub

    Public Overrides Sub OnCallSessionClosed(ByVal nSessionId As Integer, ByVal nCallType As Integer, ByVal nReasonCode As Integer)
        MyBase.FreeCallSessionData(nSessionId)
    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnCallSessionOpen(ByVal nSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)

        Dim sToPeerName As String = "", sDialToNo As String = "", sRoomName As String = ""
        Dim nToPeerType As Integer = -1
        Dim bRejected As Boolean = False

        If (nFromPeerType = CVaxServerCOM.VAX_PEER_TYPE_USER) Then

            If (m_objConfRoom.IsRoomNoExists(sDialNo)) Then
                sRoomName = m_objConfRoom.GetRoomName(sDialNo)
            Else
                m_objRouteCallSIP.OnCallFromUser(sFromPeerName, sDialNo, sDialToNo, nToPeerType, sToPeerName)
            End If

        ElseIf (nFromPeerType = CVaxServerCOM.VAX_PEER_TYPE_LINE) Then

            m_objRouteCallSIP.OnCallFromLine(sFromPeerName, nToPeerType, sToPeerName, bRejected, sRoomName)
            sDialToNo = sToPeerName

        ElseIf (nFromPeerType = CVaxServerCOM.VAX_PEER_TYPE_DIRECT_PROXY) Then

            m_objRouteCallSIP.OnCallFromDirectProxySIP(sFromPeerName, nToPeerType, sToPeerName, bRejected, sRoomName)
            sDialToNo = sToPeerName

        End If

        '//////////////////////////////////////////////////////////////////////

        If (bRejected = True) Then
            MyBase.RejectCallSession(nSessionId, 404, "Not Found")
            Return
        End If

        Dim objCallSession As CVaxCallSession = CType(MyBase.GetCallSessionData(nSessionId), CVaxCallSession)
        objCallSession.OnCallSessionOpen(nSessionId, sCallerName, sCallerId, sDialNo, sRoomName, nFromPeerType, sFromPeerName, nToPeerType, sToPeerName, sFromIP, nFromPort)

    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnCallSessionConnected(ByVal nSessionId As Integer)
        Dim objCallSession As CVaxCallSession = CType(MyBase.GetCallSessionData(nSessionId), CVaxCallSession)
        objCallSession.OnCallSessionConnected(nSessionId)
    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnCallSessionOnHold(ByVal nSessionId As Integer, ByVal nCallType As Integer)
        Dim objCallSession As CVaxCallSession = CType(MyBase.GetCallSessionData(nSessionId), CVaxCallSession)
        objCallSession.OnCallSessionOnHold(nSessionId, nCallType)
    End Sub

    Public Overrides Sub OnCallSessionOffHold(ByVal nSessionId As Integer, ByVal nCallType As Integer)
        Dim objCallSession As CVaxCallSession = CType(MyBase.GetCallSessionData(nSessionId), CVaxCallSession)
        objCallSession.OnCallSessionOffHold(nSessionId, nCallType)
    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnCallSessionTransferBlind(ByVal nTransfererSessionId As Integer, ByVal nTransfererCallType As Integer, ByVal sTransferer As String, ByVal sTransferee As String, ByVal sTransferTo As String)
        Dim objCallSession As CVaxCallSession = CType(MyBase.GetCallSessionData(nTransfererSessionId), CVaxCallSession)
        objCallSession.OnCallSessionTransferBlind(nTransfererSessionId, nTransfererCallType, sTransferer, sTransferee, sTransferTo)
    End Sub

    Public Overrides Sub OnCallSessionTransferConsult(ByVal nTransfererSessionId As Integer, ByVal nTransfereeSessionId As Integer, ByVal nTransferToSessionId As Integer, ByVal nTransfererCallType As Integer, ByVal nTransfereeCallType As Integer, ByVal nTransferToCallType As Integer, ByVal sTransferer As String, ByVal sTransferee As String, ByVal sTransferTo As String)
        Dim objCallSession As CVaxCallSession = CType(MyBase.GetCallSessionData(nTransfererSessionId), CVaxCallSession)
        objCallSession.OnCallSessionTransferConsult(nTransfererSessionId, nTransfereeSessionId, nTransferToSessionId, nTransfererCallType, nTransfereeCallType, nTransferToCallType, sTransferer, sTransferee, sTransferTo)
    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnDetectedDigitDTMF(ByVal nSessionId As Integer, ByVal nCallType As Integer, ByVal sDigitDTMF As String)
        Dim objCallSession As CVaxCallSession = CType(MyBase.GetCallSessionData(nSessionId), CVaxCallSession)
        objCallSession.OnDetectedDigitDTMF(nSessionId, nCallType, sDigitDTMF)
    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnCallSessionOpenCall(ByVal nSessionId As Integer, ByVal nCallType As Integer, ByVal nPeerType As Integer, ByVal sPeerName As String)
        m_nTotalCallCount = m_nTotalCallCount + 1
    End Sub

    Public Overrides Sub OnCallSessionCloseCall(ByVal nSessionId As Integer, ByVal nCallType As Integer, ByVal nPeerType As Integer, ByVal sPeerName As String)
        m_nTotalCallCount = m_nTotalCallCount - 1
    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnLineRegisterTrying(ByVal sLineName As String)
        Dim objLine As CVaxLine = CType(MyBase.GetLineData(sLineName), CVaxLine)
        objLine.OnLineRegisterTrying(sLineName)
    End Sub

    Public Overrides Sub OnLineRegisterFailed(ByVal sLineName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        Dim objLine As CVaxLine = CType(MyBase.GetLineData(sLineName), CVaxLine)
        objLine.OnLineRegisterFailed(sLineName, nStatusCode, sReasonPhrase)
    End Sub

    Public Overrides Sub OnLineRegisterSuccess(ByVal sLineName As String)
        Dim objLine As CVaxLine = CType(MyBase.GetLineData(sLineName), CVaxLine)
        objLine.OnLineRegisterSuccess(sLineName)
    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnRegisterUser(ByVal sUserLogin As String, ByVal sDomain As String, ByVal sFromIP As String, ByVal nFromPort As Integer)

        Dim objUser As CVaxUser = CType(MyBase.GetUserData(sUserLogin), CVaxUser)

        If (objUser Is Nothing) Then
            RejectRegister(sUserLogin, 404, "Not Found")
            Return
        End If

        objUser.OnRegisterUser(sUserLogin, sDomain, sFromIP, nFromPort)
    End Sub

    Public Overrides Sub OnRegisterUserSuccess(ByVal sUserLogin As String)

        Dim objUser As CVaxUser = CType(MyBase.GetUserData(sUserLogin), CVaxUser)

        If (objUser.IsRegistered() = False) Then
            m_nRegisterUserCount = m_nRegisterUserCount + 1
        End If

        objUser.OnRegisterUserSuccess(sUserLogin)

    End Sub

    Public Overrides Sub OnRegisterUserFailed(ByVal sUserLogin As String)
        Dim objUser As CVaxUser = CType(MyBase.GetUserData(sUserLogin), CVaxUser)
        objUser.OnRegisterUserFailed(sUserLogin)
    End Sub

    Public Overrides Sub OnUnRegisterUser(ByVal sUserLogin As String)

        Dim objUser As CVaxUser = CType(MyBase.GetUserData(sUserLogin), CVaxUser)

        If (objUser.IsRegistered()) Then
            m_nRegisterUserCount = m_nRegisterUserCount - 1
        End If

        objUser.OnUnRegisterUser(sUserLogin)

    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnChatMessageText(ByVal nChatMsgId As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal sMsgText As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
        m_objChat.OnChatMessageText(nChatMsgId, sMsgFrom, sMsgTo, sMsgText, nFromPeerType, sFromPeerName, sFromIP, nFromPort)
    End Sub

    Public Overrides Sub OnChatMessageTyping(ByVal nChatMsgId As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal bIsTypingStart As Boolean, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
        m_objChat.OnChatMessageTyping(nChatMsgId, sMsgFrom, sMsgTo, bIsTypingStart, nFromPeerType, sFromPeerName, sFromIP, nFromPort)
    End Sub

    Public Overrides Sub OnChatStatusSubscribe(ByVal nSubscrbId As Integer, ByVal sMsgFrom As String, ByVal sMsgTo As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
        m_objChat.OnChatStatusSubscribe(nSubscrbId, sMsgFrom, sMsgTo, nFromPeerType, sFromPeerName, sFromIP, nFromPort)
    End Sub

    Public Overrides Sub OnChatMessageSuccess(ByVal nChatMsgId As Integer)
        m_objChat.OnChatMessageSuccess(nChatMsgId)
    End Sub

    Public Overrides Sub OnChatMessageFailed(ByVal nChatMsgId As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        m_objChat.OnChatMessageFailed(nChatMsgId, nStatusCode, sReasonPhrase)
    End Sub

    Public Overrides Sub OnChatMessageTimeout(ByVal nChatMsgId As Integer)
        m_objChat.OnChatMessageTimeout(nChatMsgId)
    End Sub

    '//////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////

    Public Sub GenStatusLog(ByVal sStatus As String)
        OnStatusLog(sStatus)
    End Sub

    Public Overrides Sub OnVaxErrorLog(ByVal sFuncName As String, ByVal nErrorCode As Integer, ByVal sErrorMsg As String)
        Dim sMsg As String = "[Method: " + sFuncName + "] [Error Msg: " + sErrorMsg + "] [Code: " + nErrorCode.ToString() + "]"
        OnErrorLog(sMsg)
    End Sub

    Public Overridable Sub OnStatusLog(ByVal sMsg As String)
    End Sub

    Public Overridable Sub OnErrorLog(ByVal sMsg As String)
    End Sub

#End Region


End Class
