﻿Public Class CConfRoom

    Dim m_objServerExCOM As CVaxServerExCOM
    Dim m_objConfRoomList As CConfRoomList = New CConfRoomList()

    Public Sub New(ByVal objServerExCOM As CVaxServerExCOM)
        m_objServerExCOM = objServerExCOM
    End Sub

    Public Function AddRoom(ByVal sRoomName As String, ByVal sRoomNo As String) As Boolean

        If (m_objConfRoomList.AddRoom(sRoomName, sRoomNo) = False) Then
            Return False
        End If

        If (m_objServerExCOM.OpenConferenceRoom(sRoomName) = False) Then
            m_objConfRoomList.RemoveRoom(sRoomName)
            Return False
        End If

        Return True

    End Function

    Public Sub RemoveRoom(ByVal sRoomName As String)
        m_objServerExCOM.CloseConferenceRoom(sRoomName)
        m_objConfRoomList.RemoveRoom(sRoomName)
    End Sub

    Public Function GetRoomName(ByVal sRoomNo As String) As String
        Return m_objConfRoomList.GetRoomName(sRoomNo)
    End Function

    Public Function GetRoomDetails(ByVal sRoomName As String, ByRef sRoomRo As String) As Boolean
        Return m_objConfRoomList.GetRoomDetails(sRoomName, sRoomRo)
    End Function

    Public Function IsRoomNoExists(ByVal sRoomNo As String) As Boolean
        Return m_objConfRoomList.IsRoomExist(sRoomNo)
    End Function

    Public Function GetRoomAll(ByRef objRoomList As ArrayList) As Boolean
        Return m_objConfRoomList.GetRoomAll(objRoomList)
    End Function

    Public Sub DeleteRoomAll()
        m_objConfRoomList.DeleteRoomAll()
    End Sub

End Class
