﻿
Class CConfRoomDetails

    Public m_sRoomName As String = "", m_sRoomNo As String = ""

End Class


Public Class CConfRoomList

    Private m_objMaobjConfRoomByName As Hashtable
    Private m_objMaobjConfRoomByNo As Hashtable

    Public Sub New()
        m_objMaobjConfRoomByName = New Hashtable(256)
        m_objMaobjConfRoomByNo = New Hashtable(256)
    End Sub

    Protected Overrides Sub Finalize()
        DeleteRoomAll()
    End Sub

    Public Sub DeleteRoomAll()

        m_objMaobjConfRoomByName.Clear()
        m_objMaobjConfRoomByNo.Clear()

    End Sub

    Private Function GenKey(ByVal sValue As String) As String
        Return sValue.ToLower()
    End Function

    Private Function FindRoomByName(ByVal sRoomName As String) As CConfRoomDetails
        Dim sKey As String = GenKey(sRoomName)
        Return CType(m_objMaobjConfRoomByName(sKey), CConfRoomDetails)
    End Function

    Private Function FindRoomByNo(ByVal sRoomNo As String) As CConfRoomDetails
        Dim sKey As String = GenKey(sRoomNo)
        Return CType(m_objMaobjConfRoomByNo(sKey), CConfRoomDetails)
    End Function

    Public Function AddRoom(ByVal sRoomName As String, ByVal sRoomNo As String) As Boolean
        Dim objConfRoom As CConfRoomDetails = FindRoomByName(sRoomName)
        If (Not objConfRoom Is Nothing) Then Return False

        objConfRoom = FindRoomByNo(sRoomNo)
        If (Not objConfRoom Is Nothing) Then Return False

        objConfRoom = New CConfRoomDetails()

        objConfRoom.m_sRoomName = sRoomName
        objConfRoom.m_sRoomNo = sRoomNo

        Dim sKey As String = GenKey(sRoomName)
        m_objMaobjConfRoomByName.Add(sKey, objConfRoom)

        sKey = GenKey(sRoomNo)
        m_objMaobjConfRoomByNo.Add(sKey, objConfRoom)

        Return True

    End Function

    Public Sub RemoveRoom(ByVal sRoomName As String)

        Dim objConfRoom As CConfRoomDetails = FindRoomByName(sRoomName)
        If (objConfRoom Is Nothing) Then Return

        Dim sKey As String = GenKey(objConfRoom.m_sRoomNo)
        m_objMaobjConfRoomByNo.Remove(sKey)

        sKey = GenKey(sRoomName)
        m_objMaobjConfRoomByName.Remove(sKey)

        objConfRoom = Nothing

    End Sub

    Public Function GetRoomName(ByVal sRoomNo As String) As String

        Dim objConfRoom As CConfRoomDetails = FindRoomByNo(sRoomNo)
        If (objConfRoom Is Nothing) Then Return ""

        Return objConfRoom.m_sRoomName

    End Function

    Public Function GetRoomDetails(ByVal sRoomName As String, ByRef sRoomRo As String) As Boolean

        Dim objConfRoom As CConfRoomDetails = FindRoomByName(sRoomName)
        If (objConfRoom Is Nothing) Then Return ""

        sRoomRo = objConfRoom.m_sRoomNo

        Return True

    End Function

    Public Function IsRoomExist(ByVal sRoomNo As String) As Boolean

        Dim objConfRoom As CConfRoomDetails = FindRoomByNo(sRoomNo)
        If (objConfRoom Is Nothing) Then Return False

        Return True

    End Function

    Public Function GetRoomAll(ByRef objRoomList As ArrayList) As Boolean

        For Each objValue In m_objMaobjConfRoomByName.Values
            Dim objRoom As CConfRoomDetails = CType(objValue, CConfRoomDetails)
            objRoomList.Add(objRoom.m_sRoomName)
        Next

        Return True

    End Function

End Class
