﻿Public Class CVaxUser

    Dim m_objServerExCOM As CVaxServerExCOM

    Public m_sLogin As String, m_sPassword As String, m_sCodecList As String
    Public m_sUserPrefix As String, m_sDialPrefix As String, m_sToPeerName As String

    Public m_bBlocked As Boolean = False, m_bRegistered = False
    Public m_nToPeerType As Integer = -1

    Public Sub New(ByVal objServerExCOM As CVaxServerExCOM)
        m_objServerExCOM = objServerExCOM
    End Sub

    '//////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////

    Public Sub OnRegisterUser(ByVal sUserLogin As String, ByVal sDomain As String, ByVal sFromIP As String, ByVal nFromPort As Integer)

        If (m_bBlocked = True) Then
            m_objServerExCOM.RejectRegister(sUserLogin, 404, "Not Found")
            Return
        End If

        m_objServerExCOM.AuthRegister(sUserLogin)

        Dim sStatus As String = sUserLogin + " " + CDefine.USER_REG_TRYING
        m_objServerExCOM.GenStatusLog(sStatus)

    End Sub

    Public Sub OnRegisterUserSuccess(ByVal sUserLogin As String)

        m_bRegistered = True

        Dim sStatus As String = sUserLogin + " " + CDefine.USER_REG_SUCCESS
        m_objServerExCOM.GenStatusLog(sStatus)

    End Sub

    Public Sub OnRegisterUserFailed(ByVal sUserLogin As String)

        Dim sStatus As String = sUserLogin + " " + CDefine.USER_REG_FAILED
        m_objServerExCOM.GenStatusLog(sStatus)

    End Sub

    Public Sub OnUnRegisterUser(ByVal sUserLogin As String)

        m_bRegistered = False

        Dim sStatus As String = sUserLogin + " " + CDefine.USER_UNREGISTER
        m_objServerExCOM.GenStatusLog(sStatus)

    End Sub

    '//////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////

    Public Sub SetData(ByVal sPassword As String, ByVal sCodecList As String, ByVal bBlocked As Boolean, ByVal sUserPrefix As String, ByVal sDialPrefix As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String)

        m_sPassword = sPassword
        m_sCodecList = sCodecList
        m_bBlocked = bBlocked

        m_sUserPrefix = sUserPrefix
        m_sDialPrefix = sDialPrefix

        m_nToPeerType = nToPeerType
        m_sToPeerName = sToPeerName

    End Sub

    Public Sub GetData(ByRef sPassword As String, ByRef sCodecList As String, ByRef bBlocked As Boolean, ByRef sUserPrefix As String, ByRef sDialPrefix As String, ByRef nToPeerType As Integer, ByRef sToPeerName As String)

        sPassword = m_sPassword
        sCodecList = m_sCodecList
        bBlocked = m_bBlocked

        sUserPrefix = m_sUserPrefix
        sDialPrefix = m_sDialPrefix

        nToPeerType = m_nToPeerType
        sToPeerName = m_sToPeerName

    End Sub

    '//////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////

    Public Function IsRegistered() As Boolean
        Return m_bRegistered
    End Function



End Class
