// AddConferenceDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VaxTeleServerApp.h"
#include "AddConferenceDlg.h"
#include "afxdialogex.h"

#include "VaxServerSIP.h"	


// CAddConferenceDlg dialog

IMPLEMENT_DYNAMIC(CAddConferenceDlg, CPropertyPage)

CAddConferenceDlg::CAddConferenceDlg(CVaxServerSIP* pVaxTeleSIP)
	: CPropertyPage(CAddConferenceDlg::IDD)
	, m_sRoomNo(_T(""))
	, m_sRoomName(_T(""))
{
	m_pVaxTeleSIP = pVaxTeleSIP;
}

CAddConferenceDlg::~CAddConferenceDlg()
{
}

void CAddConferenceDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_CONFERENCE_ROOM_NAME, m_ctrlComboRoomName);
	DDX_Text(pDX, IDC_EDIT_CONFERENCE_ROOM_NO, m_sRoomNo);
	DDX_CBString(pDX, IDC_COMBO_CONFERENCE_ROOM_NAME, m_sRoomName);
}


BEGIN_MESSAGE_MAP(CAddConferenceDlg, CPropertyPage)
	ON_BN_CLICKED(IDC_BUTTON_CONFERENCE_ADD_ROOM, &CAddConferenceDlg::OnButtonAddRoom)
	ON_BN_CLICKED(IDC_BUTTON_CONFERENCE_REMOVE_ROOM, &CAddConferenceDlg::OnButtonRemoveRoom)
END_MESSAGE_MAP()


// CAddConferenceDlg message handlers


void CAddConferenceDlg::OnButtonAddRoom()
{
	UpdateData();

	if(m_sRoomName.IsEmpty())
	{
		MessageBox("Room Name cann't be empty.", "Error", MB_OK);
		return;
	}

	if(m_sRoomNo.IsEmpty())
	{
		MessageBox("Room No cann't be empty.", "Error", MB_OK);
		return;
	}

	BOOL bResult = m_pVaxTeleSIP->AddRoom(m_sRoomName, m_sRoomNo);
	
	if(bResult)
	{
		int nIndex = m_ctrlComboRoomName.AddString(m_sRoomName);
		MessageBox("Room added successfuly.", "Success", MB_OK|MB_ICONINFORMATION);
	}

	CString sRoomNo;
	bResult = m_pVaxTeleSIP->GetRoomDetails(m_sRoomName, sRoomNo);
}


void CAddConferenceDlg::OnButtonRemoveRoom()
{
	UpdateData();

	m_pVaxTeleSIP->RemoveRoom(m_sRoomName);
}
