// AddDirectProxyDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VaxTeleServerApp.h"
#include "AddDirectProxyDlg.h"
#include "afxdialogex.h"

#include "Codec.h"

#include "VaxServerSIP.h"

// CAddDirectProxyDlg dialog

IMPLEMENT_DYNAMIC(CAddDirectProxyDlg, CPropertyPage)

CAddDirectProxyDlg::CAddDirectProxyDlg(CVaxServerSIP* pVaxTeleSIP) : CPropertyPage(CAddDirectProxyDlg::IDD)
, m_sProxyAuthUser(_T(""))
, m_sProxyPassword(_T(""))
, m_sProxyRealm(_T(""))
, m_sProxySIP(_T(""))
, m_nRadioCtrlInboundCall(0)
, m_sProxyName(_T(""))
, m_sConnectToLogin(_T(""))
, m_sRoomName(_T(""))
{
	m_pVaxTeleSIP = pVaxTeleSIP;
	m_nProxyPort = 5060;
}

CAddDirectProxyDlg::~CAddDirectProxyDlg()
{
}

void CAddDirectProxyDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_PROXY_DISABLE_CODEC, m_ctrlDisableCodecList);
	DDX_Control(pDX, IDC_LIST_PROXY_ENABLE_CODEC, m_ctrlEnableCodecList);
	DDX_Control(pDX, IDC_COMBO_PROXY_CONNECT_USER, m_ctrlComboConnectToLogin);
	DDX_Control(pDX, IDC_COMBO_PROXY, m_ctrlComboProxy);
	DDX_Text(pDX, IDC_EDIT_PROXY_AUTH_USER, m_sProxyAuthUser);
	DDX_Text(pDX, IDC_EDIT_PROXY_PASSWORD, m_sProxyPassword);
	DDX_Text(pDX, IDC_EDIT_PROXY_DOMAIN_REALM, m_sProxyRealm);
	DDX_Text(pDX, IDC_EDIT_PROXY_SIP_PROXY, m_sProxySIP);
	DDX_Radio(pDX, IDC_RADIO_PROXY_INBOUND_REJECT, m_nRadioCtrlInboundCall);
	DDX_Text(pDX, IDC_EDIT_PROXY_PORT, m_nProxyPort);
	DDX_CBString(pDX, IDC_COMBO_PROXY, m_sProxyName);
	DDX_Control(pDX, IDC_COMBO_PROXY_CONNECT_ROOM, m_ctrlComboConnectToRoom);
	DDX_CBString(pDX, IDC_COMBO_PROXY_CONNECT_USER, m_sConnectToLogin);
	DDX_CBString(pDX, IDC_COMBO_PROXY_CONNECT_ROOM, m_sRoomName);
}


BEGIN_MESSAGE_MAP(CAddDirectProxyDlg, CPropertyPage)
	ON_BN_CLICKED(IDC_BUTTON_PROXY_DISABLE_CODEC, &CAddDirectProxyDlg::OnButtonProxyDisableCodec)
	ON_BN_CLICKED(IDC_BUTTON_PROXY_ENABLE_CODEC, &CAddDirectProxyDlg::OnButtonProxyEnableCodec)
	ON_BN_CLICKED(IDC_BUTTON_PROXY_ADD, &CAddDirectProxyDlg::OnButtonProxyAdd)
	ON_BN_CLICKED(IDC_BUTTON_PROXY_REMOVE, &CAddDirectProxyDlg::OnButtonProxyRemove)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR_PROXY_DLG, &CAddDirectProxyDlg::OnButtonClearProxyDlg)
	ON_CBN_SELCHANGE(IDC_COMBO_PROXY, &CAddDirectProxyDlg::OnSelChangeComboProxy)
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// CAddDirectProxyDlg message handlers

BOOL CAddDirectProxyDlg::OnSetActive()
{
	ShowUsers();

	// Always get / show the QUEUEs first, because they are used in DIRECT_PROXY(s)
	ShowRooms();

	// Since we have got QUEUEs (if any), now we can show DIRECT_PROXY(s)
	ShowDirectProxies();

	return CPropertyPage::OnSetActive();
}

BOOL CAddDirectProxyDlg::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	m_ctrlComboConnectToLogin.SetWindowPos(NULL,0,0,120,150,SWP_NOMOVE|SWP_NOZORDER);
	m_ctrlComboConnectToRoom.SetWindowPos(NULL,0,0,120,150,SWP_NOMOVE|SWP_NOZORDER);

	LoadCodecs();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CAddDirectProxyDlg::OnButtonProxyDisableCodec()
{
	int nCurSel = m_ctrlEnableCodecList.GetCurSel();
	if(nCurSel == -1) return;

	CString sCurSelText;
	m_ctrlEnableCodecList.GetText(nCurSel, sCurSelText);
	m_ctrlEnableCodecList.DeleteString(nCurSel);
	
	m_ctrlDisableCodecList.AddString(sCurSelText);
}

void CAddDirectProxyDlg::OnButtonProxyEnableCodec()
{
	int nCurSel = m_ctrlDisableCodecList.GetCurSel();
	if(nCurSel == -1) return;

	CString sCurSelText;
	
	m_ctrlDisableCodecList.GetText(nCurSel, sCurSelText);
	m_ctrlDisableCodecList.DeleteString(nCurSel);
	
	m_ctrlEnableCodecList.AddString(sCurSelText);
}

void CAddDirectProxyDlg::OnButtonProxyAdd()
{
	UpdateData();
		
	int nToPeerType = -1;
	
	if(!AddProxyChecks())
		return;

	if(m_ctrlComboProxy.FindStringExact(0, m_sProxyName) != -1)
	{
		MessageBox("Proxy already exists.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return;
	}
	
	CCodec objCodec;
	CString sCodecList;
		
	for(int nCount = 0; nCount < m_ctrlEnableCodecList.GetCount(); nCount++)
	{
		CString sCodecText;
		m_ctrlEnableCodecList.GetText(nCount, sCodecText);

		sCodecList += objCodec.GetCodecNo(sCodecText);
	}

	// Check which radio button is chosen on AddLineDlg

	CString sToPeerName, sRoomName;
	BOOL bRejected = FALSE, bResult = FALSE;

	if(m_nRadioCtrlInboundCall == 0)
		bRejected = TRUE;

	else if(m_nRadioCtrlInboundCall == 1)
	{
		nToPeerType = VAX_PEER_TYPE_USER;
		sToPeerName = m_sConnectToLogin;
	}
	else if(m_nRadioCtrlInboundCall == 2)
	{
		nToPeerType = VAX_PEER_TYPE_USER;
		sRoomName = m_sRoomName;
	}

	if(!m_pVaxTeleSIP->AddDirectProxySIP(m_sProxyName, m_sProxyAuthUser, m_sProxyPassword, m_sProxyRealm, m_sProxySIP, m_nProxyPort, sCodecList, nToPeerType, sToPeerName, bRejected, sRoomName))
	{
		MessageBox("DirectProxy could't be added.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return;
	}
	
	int nItemIndex = m_ctrlComboProxy.AddString(m_sProxyName);
	m_ctrlComboProxy.SetCurSel(nItemIndex);

	MessageBox("DirectProxy created successfully.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
}

void CAddDirectProxyDlg::OnButtonProxyRemove()
{
	UpdateData();
	
	if(m_ctrlComboProxy.GetCount() <= 0)
	{
		MessageBox("No DirectProxy found to remove.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return;
	}

	m_pVaxTeleSIP->RemoveDirectProxySIP(m_sProxyName);

	int nIndex = m_ctrlComboProxy.FindStringExact(0, m_sProxyName);
		
	if(nIndex != -1)
		m_ctrlComboProxy.DeleteString(nIndex);
	
	MessageBox("DirectProxy removed successfully!", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);

	ClearDlgContent();
}

void CAddDirectProxyDlg::OnButtonClearProxyDlg()
{
	ClearDlgContent();
}

void CAddDirectProxyDlg::OnSelChangeComboProxy()
{
	CString sProxyName;

	int nCurIndex = m_ctrlComboProxy.GetCurSel();
	if(nCurIndex == -1) return;

	m_ctrlComboProxy.GetLBText(nCurIndex, sProxyName);
			
	CString sAuthUser, sAuthPwd; 
	CString sDomainRealm; CString sProxySIP; 
	CString sProxyPort; CString sCodecList;
	CString	sRoomName; CString sToPeerName;

	BOOL bBlock;

	long lProxyPort; int nToPeerType;

	m_pVaxTeleSIP->GetDirectProxyDetails(sProxyName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, lProxyPort, sCodecList, nToPeerType, sToPeerName, bBlock, sRoomName);
	UpdateDlgContent(sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sCodecList, lProxyPort, nToPeerType, sToPeerName, bBlock, sRoomName);
}

void CAddDirectProxyDlg::OnDestroy()
{
	CPropertyPage::OnDestroy();


}

void CAddDirectProxyDlg::ClearDlgContent()
{
	m_ctrlComboConnectToLogin.SetCurSel(0);
	
	m_ctrlEnableCodecList.ResetContent();
	m_ctrlDisableCodecList.ResetContent();

	m_ctrlEnableCodecList.AddString(G711U_TEXT);
	m_ctrlEnableCodecList.AddString(G711A_TEXT);
	m_ctrlEnableCodecList.AddString(ILBC_TEXT);
	m_ctrlEnableCodecList.AddString(G610_TEXT);
	m_ctrlEnableCodecList.AddString(G729_TEXT);

	m_sProxyName		= "";
	m_sProxyAuthUser	= "";
	m_sProxyPassword	= "";
	m_sProxyRealm		= "";
	m_sProxySIP			= "";
	m_nProxyPort		= 5060;
	
	m_nRadioCtrlInboundCall = 0;
	
	UpdateData(FALSE);

}

void CAddDirectProxyDlg::UpdateIncomingCallSection(int nToPeerType, LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName)
{
	if(bRejected)
		m_nRadioCtrlInboundCall = 0;

	if(nToPeerType == VAX_PEER_TYPE_USER)
	{
		m_nRadioCtrlInboundCall = 1;
		m_ctrlComboConnectToLogin.SelectString(0, sToPeerName);
	}

	if(!CString(sRoomName).IsEmpty())
	{
		m_nRadioCtrlInboundCall = 2;
		m_ctrlComboConnectToRoom.SelectString(0, sRoomName);
	}
}

void CAddDirectProxyDlg::UpdateDlgContent(LPCTSTR sAuthUser, LPCTSTR sAuthPwd, LPCTSTR sRealm, LPCTSTR sProxySIP, CString sCodecList, DWORD dwProxyPort, int nToPeerType, LPCTSTR sToPeerName, BOOL bBlock, LPCTSTR sRoomName)
{
	UpdateData();

	m_sProxyAuthUser = sAuthUser;
	m_sProxyPassword = sAuthPwd;
	m_sProxyRealm = sRealm;
	m_sProxySIP = sProxySIP;
	m_nProxyPort = dwProxyPort;

	UpdateIncomingCallSection(nToPeerType, sToPeerName, bBlock, sRoomName);
	
	CCodec objCodec;
	
	m_ctrlEnableCodecList.ResetContent();
	m_ctrlDisableCodecList.ResetContent();

	for(char cCodec = '0'; cCodec < TOTAL_NO_CODEC; cCodec++)	
		m_ctrlDisableCodecList.AddString(objCodec.GetCodecName(cCodec));
		
	for(int nCount = 0; nCount < sCodecList.GetLength(); nCount++)
	{
		CString sCodecName = objCodec.GetCodecName(sCodecList.GetAt(nCount));
		m_ctrlEnableCodecList.AddString(sCodecName);
		
		int nIndex = m_ctrlDisableCodecList.FindStringExact(0, sCodecName);
		if(nIndex == -1) continue;
		
		m_ctrlDisableCodecList.DeleteString(nIndex);
	}
			
	UpdateData(FALSE);
}

void CAddDirectProxyDlg::LoadCodecs()
{
	CCodec objCodec;
	
	m_ctrlEnableCodecList.ResetContent();
	m_ctrlDisableCodecList.ResetContent();

	for(char cCodec = '0'; cCodec < TOTAL_NO_CODEC; cCodec++)	
		m_ctrlEnableCodecList.AddString(objCodec.GetCodecName(cCodec));
}

void CAddDirectProxyDlg::ShowDirectProxies()
{
	m_ctrlComboProxy.ResetContent();

	CStringList objProxyList;
	m_pVaxTeleSIP->GetDirectProxyAll(&objProxyList);

	if(objProxyList.GetCount() <= 0) return;

	while(!objProxyList.IsEmpty())
		m_ctrlComboProxy.AddString(objProxyList.RemoveHead());

	m_ctrlComboProxy.SetCurSel(0);

	CString sProxyName;
	m_ctrlComboProxy.GetLBText(m_ctrlComboProxy.GetCurSel(), sProxyName);

	CString sAuthUser, sAuthPwd; 
	CString sDomainRealm; CString sProxySIP; 
	CString sProxyPort; CString sCodecList;
	CString	sRoomName; CString sToPeerName;

	BOOL bBlock;
	long lProxyPort = 5060; int nToPeerType;

	m_pVaxTeleSIP->GetDirectProxyDetails(sProxyName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, lProxyPort, sCodecList, nToPeerType, sToPeerName, bBlock, sRoomName);
	UpdateDlgContent(sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sCodecList, lProxyPort, nToPeerType, sToPeerName, bBlock, sRoomName);
}

void CAddDirectProxyDlg::ShowUsers()
{
	m_ctrlComboConnectToLogin.ResetContent();

	CStringList objListUsers;
	m_pVaxTeleSIP->GetUserAll(&objListUsers);

	if(objListUsers.GetCount() <= 0) return;

	for(int nCount = 0; nCount < objListUsers.GetCount(); nCount++)
	{
		CString objLogin = objListUsers.GetAt(objListUsers.FindIndex(nCount));
		m_ctrlComboConnectToLogin.AddString(objLogin);
	}

	m_ctrlComboConnectToLogin.SetCurSel(0);
}

void CAddDirectProxyDlg::ShowRooms()
{
	m_ctrlComboConnectToRoom.ResetContent();

	CStringList objRoomList;
	m_pVaxTeleSIP->GetRoomAll(&objRoomList);

	if(objRoomList.GetCount() <= 0) return;

	while(!objRoomList.IsEmpty())
		m_ctrlComboConnectToRoom.AddString(objRoomList.RemoveHead());

	m_ctrlComboConnectToRoom.SetCurSel(0);
}

BOOL CAddDirectProxyDlg::AddProxyChecks()
{
	if(m_ctrlEnableCodecList.GetCount() == 0)
	{
		MessageBox("Please select a codec.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return FALSE;
	}

	if(m_nRadioCtrlInboundCall == 1)
	{
		int nCurSel = m_ctrlComboConnectToLogin.GetCurSel();
		if(nCurSel == -1) 
		{
			MessageBox("Please select the user/login to forward the incoming call.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
			return FALSE;
		}

	}

	return TRUE;

}