#include "StdAfx.h"
#include "VaxServerCOM.h"
#include <afxctl.h>


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#ifdef __cplusplus
extern "C"{
#endif 

#ifndef __IID_DEFINED__
#define __IID_DEFINED__

typedef struct _IID
{
    unsigned long x;
    unsigned short s1;
    unsigned short s2;
    unsigned char  c[8];
} IID;

#endif // __IID_DEFINED__

#ifndef CLSID_DEFINED
#define CLSID_DEFINED
typedef IID CLSID;
#endif // CLSID_DEFINED

const IID LIBID_VAXTELESERVERCOMLib = {0xB2CC126E,0x07B3,0x4BC9,{0x9C,0xE8,0xF2,0xD3,0x5D,0xA8,0xDE,0xD3}};
const IID DIID__IVaxServerSIPEvents = {0xFAEF2B1B,0x13F0,0x41D3,{0x86,0x25,0x33,0xC3,0x9C,0xCC,0x8D,0xF5}};
const IID IID_IVaxServerSIP         = {0x13BF87FD,0xCEDE,0x40D2,{0x8D,0x8D,0x89,0x9B,0x9E,0x5C,0x31,0xE9}};
const CLSID CLSID_VaxServerSIP      = {0x543EA4DF,0x8676,0x4D94,{0xB6,0xCF,0x6A,0x97,0x82,0xAA,0x66,0x24}};

#ifdef __cplusplus
}
#endif

IMPLEMENT_DYNCREATE(CVaxServerCOM, CCmdTarget)

CVaxServerCOM::CVaxServerCOM()
{
	EnableAutomation();
	
	m_pVaxSIP = NULL;
	m_pVaxEvents = NULL;
}

CVaxServerCOM::~CVaxServerCOM()
{
	//UnInitialize();
	UnLoadObjectCOM();
}


void CVaxServerCOM::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}


BEGIN_MESSAGE_MAP(CVaxServerCOM, CCmdTarget)
	//{{AFX_MSG_MAP(CVaxServerCOM)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CVaxServerCOM, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CVaxServerCOM)

	DISP_FUNCTION(CVaxServerCOM, "OnRegisterUser", OnRegisterUser, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnRegisterUserSuccess", OnRegisterUserSuccess, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnRegisterUserFailed", OnRegisterUserFailed, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnUnRegisterUser", OnUnRegisterUser, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionOpen", OnCallSessionOpen, VT_EMPTY, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_BSTR VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionFailed", OnCallSessionFailed, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionConnected", OnCallSessionConnected, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionClosed", OnCallSessionClosed, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionOnHold", OnCallSessionOnHold, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionOffHold", OnCallSessionOffHold, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionTransferBlind", OnCallSessionTransferBlind, VT_EMPTY, VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionTransferConsult", OnCallSessionTransferConsult, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnLineRegisterTrying", OnLineRegisterTrying, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnLineRegisterFailed", OnLineRegisterFailed, VT_EMPTY, VTS_BSTR VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnLineRegisterSuccess", OnLineRegisterSuccess, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnLineUnRegisterTrying", OnLineUnRegisterTrying, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnLineUnRegisterFailed", OnLineUnRegisterFailed, VT_EMPTY, VTS_I4 VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnLineUnRegisterSuccess", OnLineUnRegisterSuccess, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnChatMessageText", OnChatMessageText, VT_EMPTY, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_BSTR VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnChatMessageTyping", OnChatMessageTyping, VT_EMPTY, VTS_I4 VTS_BSTR VTS_BSTR VTS_BOOL VTS_I4 VTS_BSTR VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnChatStatusSubscribe", OnChatStatusSubscribe, VT_EMPTY, VTS_I4 VTS_BSTR VTS_BSTR VTS_I4 VTS_BSTR VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnChatMessageSuccess", OnChatMessageSuccess, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnChatMessageFailed", OnChatMessageFailed, VT_EMPTY, VTS_I4 VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnChatMessageTimeout", OnChatMessageTimeout, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnOutgoingDiagnosticLog", OnOutgoingDiagnosticLog, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnIncomingDiagnosticLog", OnIncomingDiagnosticLog, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnDetectedDigitDTMF", OnDetectedDigitDTMF, VT_EMPTY, VTS_I4 VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnVaxTeleTick", OnVaxTeleTick, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnSendTimeoutVM", OnSendTimeoutVM, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnSendSuccessVM", OnSendSuccessVM, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionDialToneStart", OnCallSessionDialToneStart, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionDialToneStop", OnCallSessionDialToneStop, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionPlayWaveDone", OnCallSessionPlayWaveDone, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnConferenceRoomPlayWaveDone", OnConferenceRoomPlayWaveDone, VT_EMPTY, VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionConnecting", OnCallSessionConnecting, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionLost", OnCallSessionLost, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionHangup", OnCallSessionHangup, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionTimeout", OnCallSessionTimeout, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionCancelled", OnCallSessionCancelled, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionTransfering", OnCallSessionTransfering, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionTransferFailed", OnCallSessionTransferFailed, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionTransferTimeout", OnCallSessionTransferTimeout, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionTransfered", OnCallSessionTransfered, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionCreated", OnCallSessionCreated, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionOpenCall", OnCallSessionOpenCall, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionCloseCall", OnCallSessionCloseCall, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionDetectedAMD", OnCallSessionDetectedAMD, VT_EMPTY, VTS_I4 VTS_I4 VTS_BOOL)
	DISP_FUNCTION(CVaxServerCOM, "OnBusyLampSubscribe", OnBusyLampSubscribe, VT_EMPTY, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnBusyLampUnSubscribe", OnBusyLampUnSubscribe, VT_EMPTY, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnBusyLampSubscribeSuccess", OnBusyLampSubscribeSuccess, VT_EMPTY, VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnBusyLampSubscribeFailed", OnBusyLampSubscribeFailed, VT_EMPTY, VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionRecordedPCM", OnCallSessionRecordedPCM, VT_EMPTY, VTS_I4 VTS_I8 VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnConferenceRoomRecordedPCM", OnConferenceRoomRecordedPCM, VT_EMPTY, VTS_BSTR VTS_I8 VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnVaxErrorLog", OnVaxErrorLog, VT_EMPTY, VTS_BSTR VTS_I4 VTS_BSTR)
				
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IVaxServerSIP to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {3DB0F857-BB81-4371-A80C-C4CB971721D1}
//static const IID IID_IVaxServerSIP =
//{ 0x3db0f857, 0xbb81, 0x4371, { 0xa8, 0xc, 0xc4, 0xcb, 0x97, 0x17, 0x21, 0xd1 } };

BEGIN_INTERFACE_MAP(CVaxServerCOM, CCmdTarget)
	INTERFACE_PART(CVaxServerCOM, DIID__IVaxServerSIPEvents, Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVaxServerCOM message handlers

void CVaxServerCOM::UnLoadObjectCOM()
{
	if(m_pVaxSIP)
	{
		m_pVaxSIP->Release();
		m_pVaxSIP = NULL;
	}

	if(m_pVaxEvents)
	{
		LPUNKNOWN pUnk = GetIDispatch(FALSE);
		AfxConnectionUnadvise(m_pVaxEvents, DIID__IVaxServerSIPEvents, pUnk, FALSE, m_dwCookie);

		m_pVaxEvents->Release();
		m_pVaxEvents = NULL;
	}
}

BOOL CVaxServerCOM::LoadObjectCOM()
{
	UnLoadObjectCOM();

	CoInitialize(NULL);
	
	HRESULT hr = CoCreateInstance(CLSID_VaxServerSIP, NULL, CLSCTX_INPROC_SERVER, IID_IDispatch, (void**) &m_pVaxEvents);
	if(FAILED(hr)) return FALSE;

	m_pVaxEvents->QueryInterface(IID_IVaxServerSIP, (void**) &m_pVaxSIP);
	
	m_dwCookie = 1;
		
	LPUNKNOWN pUnk = GetIDispatch(FALSE);

	if(!AfxConnectionAdvise(m_pVaxEvents, DIID__IVaxServerSIPEvents, pUnk, FALSE, &m_dwCookie))
	{
		return FALSE;
	}

	return TRUE;
}

BOOL CVaxServerCOM::IsLoadedObjectCOM()
{
	if(m_pVaxSIP == NULL)	
	{
		OnVaxErrorLog("", -1, "Unable to load VaxTeleServerCOM.dll COM component.");
		return FALSE;
	}

	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::SetLicenseKey(LPCTSTR sLicenseKey)
{
	m_pVaxSIP->SetLicenseKey(sLicenseKey);
}

void CVaxServerCOM::UnInitialize()
{
	if(m_pVaxSIP)
		m_pVaxSIP->UnInitialize();
}

BOOL CVaxServerCOM::Initialize(LPCTSTR sDomainName, LPCTSTR sSIPListenIP, UINT nSIPListenPort, LPCTSTR sRTPListenIP, UINT nRTPListenPort)
{
	return m_pVaxSIP->Initialize(sDomainName, sSIPListenIP, nSIPListenPort, sRTPListenIP, nRTPListenPort);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::AddUser(LPCTSTR sUserName, LPCTSTR sPassword, LPCTSTR sCodecList)
{
	return m_pVaxSIP->AddUser(sUserName, sPassword, sCodecList);
}

void CVaxServerCOM::RemoveUser(LPCTSTR sUserName)
{
	m_pVaxSIP->RemoveUser(sUserName);
}

BOOL CVaxServerCOM::RegisterUserExpiry(int nExpiry)
{
	return m_pVaxSIP->RegisterUserExpiry(nExpiry);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::AcceptRegister(LPCTSTR sUserName)
{
	return m_pVaxSIP->AcceptRegister(sUserName);
}

BOOL CVaxServerCOM::RejectRegister(LPCTSTR sUserName, LONG lStatusCode, LPCTSTR sReasonPhrase)
{
	return m_pVaxSIP->RejectRegister(sUserName, lStatusCode, sReasonPhrase);
}

BOOL CVaxServerCOM::AuthRegister(LPCTSTR sUserName)
{
	return m_pVaxSIP->AuthRegister(sUserName);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::AddLine(LPCTSTR sLineName, LPCTSTR sDisplayName, LPCTSTR sUserName, LPCTSTR sAuthUser, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sProxySIP, LPCTSTR sOutboundProxySIP, LPCTSTR sCodecList)
{
	return m_pVaxSIP->AddLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sOutboundProxySIP, sCodecList);
}

void CVaxServerCOM::RemoveLine(LPCTSTR sLineName)
{
	m_pVaxSIP->RemoveLine(sLineName);
}

BOOL CVaxServerCOM::RegisterLine(LPCTSTR sLineName, int nExpire)
{
	return m_pVaxSIP->RegisterLine(sLineName, nExpire);
}

BOOL CVaxServerCOM::UnRegisterLine(LPCTSTR sLineName)
{
	return m_pVaxSIP->UnRegisterLine(sLineName);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::AddDirectProxySIP(LPCTSTR sProxyName, LPCTSTR sAuthLogin, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sProxyIP, LONG lProxyPort, LPCTSTR sCodecList)
{
	return m_pVaxSIP->AddDirectProxySIP(sProxyName, sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP, lProxyPort, sCodecList);
}

void CVaxServerCOM::RemoveDirectProxySIP(LPCTSTR sProxyName)
{
	m_pVaxSIP->RemoveDirectProxySIP(sProxyName);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::AcceptCallSession(LONG lSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, int nToPeerType, LPCTSTR sToPeerName, LONG lTimeout)
{
	return m_pVaxSIP->AcceptCallSession(lSessionId, sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, lTimeout);
}

BOOL CVaxServerCOM::RejectCallSession(LONG lSessionId, LONG lStatusCode, LPCTSTR sReasonPhrase)
{
	return m_pVaxSIP->RejectCallSession(lSessionId, lStatusCode, sReasonPhrase);
}

BOOL CVaxServerCOM::CloseCallSession(LONG lSessionId)
{
	return m_pVaxSIP->CloseCallSession(lSessionId);
}

LONG CVaxServerCOM::OpenCallSession(LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, int nToPeerType, LPCTSTR sToPeerName, LONG lTimeout)
{
	//return m_pVaxSIP->CreateCallSession(sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, lTimeout);
	return 0;
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

LONG CVaxServerCOM::AcceptTransferBlind(LONG lTransfererSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sTransferTo, int nToPeerType, LPCTSTR sToPeerName, LONG lTimeout)
{
	return m_pVaxSIP->AcceptTransferBlind(lTransfererSessionId, sCallerName, sCallerId, sTransferTo, nToPeerType, sToPeerName, lTimeout);
}

LONG CVaxServerCOM::AcceptTransferConsult(LONG lTransfererSessionId, LONG lTransferToSessionId)
{
	return m_pVaxSIP->AcceptTransferConsult(lTransfererSessionId, lTransferToSessionId);
}

void CVaxServerCOM::RejectTransfer(LONG lSessionId)
{
	m_pVaxSIP->RejectTransfer(lSessionId);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::PlayWaveStartToCallSession(LONG lSessionId, LONG lWaveId, BOOL bLoop)
{
	return m_pVaxSIP->PlayWaveStartToCallSession(lSessionId, lWaveId, bLoop);
}

BOOL CVaxServerCOM::PlayWaveStopToCallSession(LONG lSessionId)
{
	return m_pVaxSIP->PlayWaveStopToCallSession(lSessionId);
}

BOOL CVaxServerCOM::RecordWaveStartToCallSession(LONG lSessionId, LPCTSTR sFileName)
{
	return m_pVaxSIP->RecordWaveStartToCallSession(lSessionId, sFileName);
}

BOOL CVaxServerCOM::RecordWaveStopToCallSession(LONG lSessionId)
{
	return m_pVaxSIP->RecordWaveStopToCallSession(lSessionId);
}

BOOL CVaxServerCOM::RecordWavePauseToCallSession(LONG lSessionId, BOOL bEnable)
{
	return m_pVaxSIP->RecordWavePauseToCallSession(lSessionId, bEnable);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

LONG CVaxServerCOM::LoadWaveFile(LPCTSTR sFileName)
{
	return m_pVaxSIP->LoadWaveFile(sFileName);
}

LONG CVaxServerCOM::LoadWavePCM(char* pDataPCM, DWORD dwSizePCM)
{
	return 0;
}

void CVaxServerCOM::UnLoadWaveFile(LONG lWaveId)
{
	m_pVaxSIP->UnLoadWaveFile(lWaveId);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::LoadMusicHold(LPCTSTR sFileName)
{
	return m_pVaxSIP->LoadMusicHold(sFileName);
}

void CVaxServerCOM::UnLoadMusicHold()
{
	m_pVaxSIP->UnLoadMusicHold();
}

BOOL CVaxServerCOM::AcceptOnHoldRequest(LONG lSessionId)
{
	return m_pVaxSIP->AcceptOnHoldRequest(lSessionId);
}

BOOL CVaxServerCOM::AcceptOffHoldRequest(LONG lSessionId)
{
	return m_pVaxSIP->AcceptOffHoldRequest(lSessionId);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////


BOOL CVaxServerCOM::AcceptChatMessage(LONG lChatMsgId, int nToPeerType, LPCTSTR sToPeerName)
{
	return m_pVaxSIP->AcceptChatMessage(lChatMsgId, nToPeerType, sToPeerName);
}

void CVaxServerCOM::RejectChatMessage(LONG lChatMsgId, LONG lStatusCode, LPCTSTR sReasonPhrase)
{
	m_pVaxSIP->RejectChatMessage(lChatMsgId, lStatusCode, sReasonPhrase);
}

BOOL CVaxServerCOM::AcceptChatStatusSubscribe(LONG lSubscrbId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, int nToPeerType, LPCTSTR sToPeerName)
{
	return m_pVaxSIP->AcceptChatStatusSubscribe(lSubscrbId, sMsgFrom, sMsgTo, nToPeerType, sToPeerName);
}

void CVaxServerCOM::RejectChatStatusSubscribe(LONG lSubscrbId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo)
{
	m_pVaxSIP->RejectChatStatusSubscribe(lSubscrbId, sMsgFrom, sMsgTo);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::OpenConferenceRoom(LPCTSTR sRoomName)
{
	return m_pVaxSIP->OpenConferenceRoom(sRoomName);
}

void CVaxServerCOM::CloseConferenceRoom(LPCTSTR sRoomName)
{
	m_pVaxSIP->CloseConferenceRoom(sRoomName);
}

BOOL CVaxServerCOM::AddCallSessionToConferenceRoom(LPCTSTR sRoomName, LONG lSessionId, int nType)
{
	return m_pVaxSIP->AddCallSessionToConferenceRoom(sRoomName, lSessionId, nType);
}

BOOL CVaxServerCOM::RemoveCallSessionFromConferenceRoom(LONG lSessionId)
{
	return m_pVaxSIP->RemoveCallSessionFromConferenceRoom(lSessionId);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::PlayWaveStartToConferenceRoom(LPCTSTR sRoomName, LONG lWaveId, BOOL bLoop)
{
	return m_pVaxSIP->PlayWaveStartToConferenceRoom(sRoomName, lWaveId, bLoop);
}

BOOL CVaxServerCOM::PlayWaveStopToConferenceRoom(LPCTSTR sRoomName)
{
	return m_pVaxSIP->PlayWaveStopToConferenceRoom(sRoomName);
}

BOOL CVaxServerCOM::RecordWaveStartToConferenceRoom(LPCTSTR sRoomName, LPCTSTR sFileName)
{
	return m_pVaxSIP->RecordWaveStartToConferenceRoom(sRoomName, sFileName);
}

BOOL CVaxServerCOM::RecordWaveStopToConferenceRoom(LPCTSTR sRoomName)
{
	return m_pVaxSIP->RecordWaveStopToConferenceRoom(sRoomName);
}

BOOL CVaxServerCOM::RecordWavePauseToConferenceRoom(LPCTSTR sRoomName, BOOL bEnable)
{
	return m_pVaxSIP->RecordWavePauseToConferenceRoom(sRoomName, bEnable);
}


///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::DialToneToCallSession(BOOL bEnable, LONG lSessionId, LONG lWaveId)
{
	return m_pVaxSIP->DialToneToCallSession(bEnable, lSessionId, lWaveId);
}

BOOL CVaxServerCOM::VoiceSessionLost(BOOL bEnable, LONG lTimeout)
{
	return m_pVaxSIP->VoiceSessionLost(bEnable, lTimeout);
}

LONG CVaxServerCOM::SendInfoVM(LPCTSTR sUserLogin, int nNewMsgCount, int nOldMsgCount, BOOL bMsgWaiting)
{
	return m_pVaxSIP->SendInfoVM(sUserLogin, nNewMsgCount, nOldMsgCount, bMsgWaiting);
}

BOOL CVaxServerCOM::StartVaxTeleTick(LONG lTickId, LONG lElapse)
{
	return m_pVaxSIP->StartVaxTeleTick(lTickId, lElapse);
}

BOOL CVaxServerCOM::StopVaxTeleTick(LONG lTickId)
{
	return m_pVaxSIP->StopVaxTeleTick(lTickId);
}

BOOL CVaxServerCOM::SetUserAgentName(LPCTSTR sName)
{
	return m_pVaxSIP->SetUserAgentName(sName);
}

CString CVaxServerCOM::GetUserAgentName()
{
	CString sResult = (LPCTSTR) m_pVaxSIP->GetUserAgentName();
	return sResult;
}
	
BOOL CVaxServerCOM::SetSessionNameSDP(LPCTSTR sName)
{
	return m_pVaxSIP->SetSessionNameSDP(sName);
}

CString CVaxServerCOM::GetSessionNameSDP()
{
	CString sResult = (LPCTSTR) m_pVaxSIP->GetSessionNameSDP();
	return sResult;
}

BOOL CVaxServerCOM::SendDTMFCallSession(LONG lSessionId, int nTypeDTMF, int nDigit)
{
	return m_pVaxSIP->SendDTMFCallSession(lSessionId, nDigit, nTypeDTMF);
}

BOOL CVaxServerCOM::DetectDigitDTMF(LONG lSessionId, int nCallType, int nTypeDTMF, BOOL bEnable, int nMilliSecTimeout)
{
	return m_pVaxSIP->DetectDigitDTMF(lSessionId, nCallType, nTypeDTMF, bEnable, nMilliSecTimeout);
}

LONG CVaxServerCOM::GetVaxObjectError()
{
	return  m_pVaxSIP->GetVaxObjectError();
}

BOOL CVaxServerCOM::DiagnosticLogSIP(BOOL bInbound, BOOL bOutbound)
{
	return m_pVaxSIP->DiagnosticLogSIP(bInbound, bOutbound);
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::CallSessionSwapCalls(LONG lSessionId)
{
	return m_pVaxSIP->CallSessionSwapCalls(lSessionId);
}

LONG CVaxServerCOM::MergeCallSession(LONG lFromSessionId, LONG lToSessionId)
{
	return m_pVaxSIP->MergeCallSession(lFromSessionId, lToSessionId);
}

BOOL CVaxServerCOM::CallSessionSendStatusResponse(LONG lSessionId, LONG lStatusCode, LPCTSTR sReasonPhrase)
{
	return m_pVaxSIP->CallSessionSendStatusResponse(lSessionId, lStatusCode, sReasonPhrase);
}

BOOL CVaxServerCOM::CallSessionDetectAMD(LONG lSessionId, LONG lCallType, BOOL bEnable, int nAnalysisTime, int nSilenceTime, int nSilenceCount)
{
	return m_pVaxSIP->CallSessionDetectAMD(lSessionId, lCallType, bEnable, nAnalysisTime, nSilenceTime, nSilenceCount);
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::AddCustomHeader(int nReqId, LPCTSTR sName, LPCTSTR sValue)
{
	return m_pVaxSIP->AddCustomHeader(nReqId, sName, sValue);
}

BOOL CVaxServerCOM::RemoveCustomHeader(int nReqId, LPCTSTR sName)
{
	return m_pVaxSIP->RemoveCustomHeader(nReqId, sName);
}

BOOL CVaxServerCOM::RemoveCustomHeaderAll(int nReqId)
{
	return m_pVaxSIP->RemoveCustomHeaderAll(nReqId);
}

BOOL CVaxServerCOM::AddListenIP(LPCTSTR sSIPListenIP, LPCTSTR sRTPListenIP)
{
	return m_pVaxSIP->AddListenIP(sSIPListenIP, sRTPListenIP);
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

LONG CVaxServerCOM::GetCallSessionTxCodec(LONG lSessionId, LONG lCallType)
{
	return m_pVaxSIP->GetCallSessionTxCodec(lSessionId, lCallType);
}

LONG CVaxServerCOM::GetCallSessionRxCodec(LONG lSessionId, LONG lCallType)
{
	return m_pVaxSIP->GetCallSessionRxCodec(lSessionId, lCallType);
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::BusyLampSubscribeAccept(LONG lSubScrbId, BOOL bAuthenticate, int nExpires)
{
	return m_pVaxSIP->BusyLampSubscribeAccept(lSubScrbId, bAuthenticate, nExpires);
}

BOOL CVaxServerCOM::BusyLampSubscribeReject(LONG lSubScrbId, int nStatusCode, LPCTSTR sReasonPhrase)
{
	return m_pVaxSIP->BusyLampSubscribeReject(lSubScrbId, nStatusCode, CString(sReasonPhrase).AllocSysString());
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::SetCallSessionData(LONG lSessionId, HANDLE hCustomData)
{
	return m_pVaxSIP->SetCallSessionData(lSessionId, (LONGLONG) hCustomData);
}

HANDLE CVaxServerCOM::GetCallSessionData(LONG lSessionId)
{
	return (HANDLE) m_pVaxSIP->GetCallSessionData(lSessionId);
}
		
BOOL CVaxServerCOM::SetUserData(LPCTSTR sUserName, HANDLE hCustomData)
{
	return m_pVaxSIP->SetUserData(sUserName, (LONGLONG) hCustomData);
}

HANDLE CVaxServerCOM::GetUserData(LPCTSTR sUserName)
{
	return (HANDLE) m_pVaxSIP->GetUserData(sUserName);
}

BOOL CVaxServerCOM::SetLineData(LPCTSTR sLineName, HANDLE hCustomData)
{
	return m_pVaxSIP->SetLineData(sLineName, (LONGLONG) hCustomData);
}

HANDLE CVaxServerCOM::GetLineData(LPCTSTR sLineName)
{
	return (HANDLE) m_pVaxSIP->GetLineData(sLineName);
}

BOOL CVaxServerCOM::SetDirectProxyData(LPCTSTR sProxyName, HANDLE hCustomData)
{
	return m_pVaxSIP->SetDirectProxyData(sProxyName, (LONGLONG) hCustomData);
}
	
HANDLE CVaxServerCOM::GetDirectProxyData(LPCTSTR sProxyName)
{
	return (HANDLE) m_pVaxSIP->GetDirectProxyData(sProxyName);
}

BOOL CVaxServerCOM::SetConferenceRoomData(LPCTSTR sRoomName, HANDLE hCustomData)
{
	return m_pVaxSIP->SetConferenceRoomData(sRoomName, (LONGLONG) hCustomData);
}

HANDLE CVaxServerCOM::GetConferenceRoomData(LPCTSTR sRoomName)
{
	return (HANDLE) m_pVaxSIP->GetConferenceRoomData(sRoomName);
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::TrvsUserStart()
{
	return m_pVaxSIP->TrvsUserStart();
}

CString CVaxServerCOM::TrvsUserNext()
{
	CString sResult = (LPCTSTR) m_pVaxSIP->TrvsUserNext();
	return sResult;
}

BOOL CVaxServerCOM::TrvsLineStart()
{
	return m_pVaxSIP->TrvsLineStart();
}

CString CVaxServerCOM::TrvsLineNext()
{
	CString sResult = (LPCTSTR) m_pVaxSIP->TrvsLineNext();
	return sResult;
}

BOOL CVaxServerCOM::TrvsDirectProxyStart()
{
	return m_pVaxSIP->TrvsDirectProxyStart();
}

CString CVaxServerCOM::TrvsDirectProxyNext()
{
	CString sResult = (LPCTSTR) m_pVaxSIP->TrvsDirectProxyNext();
	return sResult;
}

BOOL CVaxServerCOM::TrvsCallSessionStart()
{
	return m_pVaxSIP->TrvsCallSessionStart();
}

LONG CVaxServerCOM::TrvsCallSessionNext()
{
	return m_pVaxSIP->TrvsCallSessionNext();
}

BOOL CVaxServerCOM::TrvsConferenceRoomStart()
{
	return m_pVaxSIP->TrvsConferenceRoomStart();
}

CString CVaxServerCOM::TrvsConferenceRoomNext()
{
	CString sResult = (LPCTSTR) m_pVaxSIP->TrvsConferenceRoomNext();
	return sResult;
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

LONG CVaxServerCOM::GetUserCount()
{
	return m_pVaxSIP->GetUserCount();
}

LONG CVaxServerCOM::GetLineCount()
{
	return m_pVaxSIP->GetLineCount();
}

LONG CVaxServerCOM::GetDirectProxyCount()
{
	return m_pVaxSIP->GetDirectProxyCount();
}

LONG CVaxServerCOM::GetCallSessionCount()
{
	return m_pVaxSIP->GetCallSessionCount();
}

LONG CVaxServerCOM::GetConferenceRoomCount()
{
	return m_pVaxSIP->GetConferenceRoomCount();
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

LONG CVaxServerCOM::CustomListOpen(int nTableSize)
{
	return m_pVaxSIP->CustomListOpen(nTableSize);
}

BOOL CVaxServerCOM::CustomListClose(LONG lListId)
{
	return m_pVaxSIP->CustomListClose(lListId);
}
	
BOOL CVaxServerCOM::CustomListAddData(LONG lListId, LPCTSTR sKey, HANDLE hCustomData)
{
	return m_pVaxSIP->CustomListAddData(lListId, CString(sKey).AllocSysString(), (LONGLONG) hCustomData);
}

BOOL CVaxServerCOM::CustomListRemoveData(LONG lListId, LPCTSTR sKey)
{
	return m_pVaxSIP->CustomListRemoveData(lListId, CString(sKey).AllocSysString());
}

HANDLE CVaxServerCOM::CustomListFindData(LONG lListId, LPCTSTR sKey)
{
	return (HANDLE) m_pVaxSIP->CustomListFindData(lListId, CString(sKey).AllocSysString());
}

LONG CVaxServerCOM::CustomListCount(LONG lListId)
{
	return m_pVaxSIP->CustomListCount(lListId);
}

BOOL CVaxServerCOM::CustomListReset(LONG lListId)
{
	return m_pVaxSIP->CustomListReset(lListId);
}

BOOL CVaxServerCOM::CustomListTrvsStart(LONG lListId)
{
	return m_pVaxSIP->CustomListTrvsStart(lListId);
}

HANDLE CVaxServerCOM::CustomListTrvsNext(LONG lListId)
{
	return (HANDLE) m_pVaxSIP->CustomListTrvsNext(lListId);
}

CString CVaxServerCOM::GetCallSessionHeaderCallId(LONG lSessionId, LONG lCallType)
{
	CString sResult = (LPCTSTR) m_pVaxSIP->GetCallSessionHeaderCallId(lSessionId, lCallType);
	return sResult;
}

BOOL CVaxServerCOM::SetListenPortRangeRTP(LONG lListenStartPort, LONG lListenEndPort)
{
	return m_pVaxSIP->SetListenPortRangeRTP(lListenStartPort, lListenEndPort);
}

BOOL CVaxServerCOM::CallSessionMuteVoice(LONG lSessionId, LONG lCallType, BOOL bListen, BOOL bSpeak)
{
	return m_pVaxSIP->CallSessionMuteVoice(lSessionId, lCallType, bListen, bSpeak);
}

BOOL CVaxServerCOM::VideoCOMM(BOOL bEnable)
{
	return m_pVaxSIP->VideoCOMM(bEnable);
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::OnRegisterUser(LPCTSTR sUserLogin, LPCTSTR sDomain, LPCTSTR sFromIP, LONG lFromPort)
{
	
}

void CVaxServerCOM::OnRegisterUserSuccess(LPCTSTR sUserLogin)
{

}

void CVaxServerCOM::OnRegisterUserFailed(LPCTSTR sUserLogin)
{

}

void CVaxServerCOM::OnUnRegisterUser(LPCTSTR sUserLogin)
{

}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////
	
void CVaxServerCOM::OnCallSessionOpen(LONG lSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, LONG lFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sFromIP, LONG lFromPort)
{
	
}

void CVaxServerCOM::OnCallSessionConnecting(LONG lSessionId, LONG lCallType, LONG lStatusCode, LPCTSTR sReasonPhrase)
{

}

void CVaxServerCOM::OnCallSessionFailed(LONG lSessionId, LONG lCallType, LONG lReasonCode, LPCTSTR sReasonPhrase)
{

}

void CVaxServerCOM::OnCallSessionConnected(LONG lSessionId)
{

}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::OnCallSessionOnHold(LONG lSessionId, LONG lCallType)
{

}

void CVaxServerCOM::OnCallSessionOffHold(LONG lSessionId, LONG lCallType)
{

}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::OnCallSessionTransferBlind(LONG lTransfererSessionId, LONG lTransfererCallType, LPCTSTR sTransferer, LPCTSTR sTransferee, LPCTSTR sTransferTo)
{

}

void CVaxServerCOM::OnCallSessionTransferConsult(LONG lTransfererSessionId, LONG lTransfereeSessionId, LONG lTransferToSessionId, LONG lTransfererCallType, LONG lTransfereeCallType, LONG lTransferToCallType, LPCTSTR sTransferer, LPCTSTR sTransferee, LPCTSTR sTransferTo)
{

}

void CVaxServerCOM::OnCallSessionTransfering(LONG lSessionId, LONG lTransferType, LONG lCallType, LONG lStatusCode, LPCTSTR sReasonPhrase)
{
	
}

void CVaxServerCOM::OnCallSessionTransferFailed(LONG lSessionId, LONG lTransferType, LONG lCallType, LONG lStatusCode, LPCTSTR sReasonPhrase)
{
	
}

void CVaxServerCOM::OnCallSessionTransferTimeout(LONG lSessionId, LONG lTransferType, LONG lCallType)
{
	
}

void CVaxServerCOM::OnCallSessionTransfered(LONG lSessionId, LONG lTransferType)
{
	
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::OnLineRegisterTrying(LPCTSTR sLineName)
{

}

void CVaxServerCOM::OnLineRegisterFailed(LPCTSTR sLineName, LONG lStatusCode, LPCTSTR sReasonPhrase)
{

}

void CVaxServerCOM::OnLineRegisterSuccess(LPCTSTR sLineName)
{

}

void CVaxServerCOM::OnLineUnRegisterTrying(LPCTSTR sLineName)
{

}

void CVaxServerCOM::OnLineUnRegisterFailed(LPCTSTR sLineName, LONG lStatusCode, LPCTSTR sReasonPhrase)
{

}

void CVaxServerCOM::OnLineUnRegisterSuccess(LPCTSTR sLineName)
{

}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::OnChatMessageText(LONG lChatMsgId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, LPCTSTR sMsgText, LONG lFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sFromIP, LONG lFromPort)
{

}

void CVaxServerCOM::OnChatMessageTyping(LONG lChatMsgId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, BOOL IsTypingStart, LONG lFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sFromIP, LONG lFromPort)
{

}

void CVaxServerCOM::OnChatStatusSubscribe(LONG lSubscrbId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, LONG lFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sFromIP, LONG lFromPort)
{

}

void CVaxServerCOM::OnChatMessageSuccess(LONG lChatMsgId)
{

}

void CVaxServerCOM::OnChatMessageFailed(LONG lChatMsgId, LONG lStatusCode, LPCTSTR sReasonPhrase)
{

}

void CVaxServerCOM::OnChatMessageTimeout(LONG lChatMsgId)
{

}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::OnOutgoingDiagnosticLog(LPCTSTR sMsgSIP, LPCTSTR sToIP, LONG lToPort)
{

}

void CVaxServerCOM::OnIncomingDiagnosticLog(LPCTSTR sMsgSIP, LPCTSTR sFromIP, LONG lFromPort)
{

}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::OnDetectedDigitDTMF(LONG lSessionId, LONG lCallType, LPCTSTR sDigitDTMF)
{

}

void CVaxServerCOM::OnVaxTeleTick(LONG lTickId)
{

}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::OnSendTimeoutVM(LONG lMsgIdVM)
{

}

void CVaxServerCOM::OnSendSuccessVM(LONG lMsgIdVM)
{

}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::OnCallSessionDialToneStart(LONG lSessionId, LONG lWaveId)
{

}

void CVaxServerCOM::OnCallSessionDialToneStop(LONG lSessionId, LONG lWaveId)
{

}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::OnCallSessionPlayWaveDone(LONG lSessionId, LONG lWaveId)
{

}

void CVaxServerCOM::OnConferenceRoomPlayWaveDone(LPCTSTR sRoomName, LONG lWaveId)
{

}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::OnCallSessionLost(LONG lSessionId, LONG lCallType)
{

}

void CVaxServerCOM::OnCallSessionHangup(LONG lSessionId, LONG lCallType)
{

}

void CVaxServerCOM::OnCallSessionTimeout(LONG lSessionId, LONG lCallType)
{

}

void CVaxServerCOM::OnCallSessionCancelled(LONG lSessionId)
{

}

void CVaxServerCOM::OnCallSessionCreated(LONG lSessionId, LONG lReasonCode)
{

}

void CVaxServerCOM::OnCallSessionClosed(LONG lSessionId, LONG lCallType, LONG lReasonCode)
{

}

void CVaxServerCOM::OnCallSessionOpenCall(LONG lSessionId, LONG lCallType, LONG lPeerType, LPCTSTR sPeerName)
{

}

void CVaxServerCOM::OnCallSessionCloseCall(LONG lSessionId, LONG lCallType, LONG lPeerType, LPCTSTR sPeerName)
{

}

void CVaxServerCOM::OnCallSessionDetectedAMD(LONG lSessionId, LONG lCallType, BOOL bIsHuman)
{

}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::OnCallSessionRecordedPCM(LONG lSessionId, LONGLONG nDataPCM, LONG lSizePCM, LONG lTypePCM)
{

}

void CVaxServerCOM::OnConferenceRoomRecordedPCM(LPCTSTR sRoomName, LONGLONG nDataPCM, LONG lSizePCM, LONG lTypePCM)
{

}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::OnBusyLampSubscribe(LONG lSubScrbId, LPCTSTR sUserName, LPCTSTR sToUserName, LPCTSTR sFromIP, UINT nFromPort)
{

}

void CVaxServerCOM::OnBusyLampUnSubscribe(LONG lSubScrbId, LPCTSTR sUserName, LPCTSTR sToUserName, LPCTSTR sFromIP, UINT nFromPort)
{

}

void CVaxServerCOM::OnBusyLampSubscribeSuccess(LONG lSubScrbId, LPCTSTR sUserName)
{

}

void CVaxServerCOM::OnBusyLampSubscribeFailed(LONG lSubScrbId, LPCTSTR sUserName)
{

}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::OnVaxErrorLog(LPCTSTR sFuncName, DWORD dwErrorCode, LPCTSTR sErrorMsg)
{

}