#pragma once

#include "VaxServerCOM.h"

class CConfRoom;
class CVaxChat;
class CVaxCallSessionRoute;

class CVaxServerExCOM :	public CVaxServerCOM
{

public:
	
	CVaxServerExCOM();
	~CVaxServerExCOM();

private:

	CConfRoom* m_pConfRoom;
	CVaxChat* m_pChat;
	
	CVaxCallSessionRoute* m_pRouteCallSIP;

	LONG m_lDialToneId;

	UINT m_nTotalCallCount;
	UINT m_nRegisterUserCount;

public:

	CString m_sLicenseKey;

public:

	void SetLicenseKey(LPCTSTR sLicenseKey);
	
	BOOL Initialize(LPCTSTR sDomainRealm, LPCTSTR sSIPListenIP, UINT nSIPListenPort, LPCTSTR sRTPListenIP, UINT nRTPListenPort);
	void UnInitialize();
		
	BOOL AddUser(LPCTSTR sUserName, LPCTSTR sPassword, LPCTSTR sCodecList, BOOL bBlocked, LPCTSTR sUserPrefix, LPCTSTR sDialPrefix, int nToPeerType, LPCTSTR sToPeerName);
	void RemoveUser(LPCTSTR sUserName);
	
	BOOL AddLine(LPCTSTR sLineName, LPCTSTR sDisplayName, LPCTSTR sUserName, LPCTSTR sAuthUser, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sProxySIP, LPCTSTR sCodecList, BOOL bRegister, int nToPeerType, LPCTSTR sToPeerName, BOOL bBlock, LPCTSTR sRoomName);
	void RemoveLine(LPCTSTR sLineName);
		
	void GetLineAll(CStringList* pLineList);
	BOOL GetLineDetails(LPCTSTR sLineName, CString& sDisplayName, CString& sUserName, CString& sAuthUser, CString& sAuthPwd, CString& sDomainRealm, CString& sProxySIP, CString& sCodecList, BOOL& bRegister, int& nToPeerType, CString& sToPeerName, BOOL& bBlocked, CString& sRoomName);

	BOOL AddDirectProxySIP(LPCTSTR sProxyName, LPCTSTR sAuthLogin, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sProxyIP, LONG lProxyPort, LPCTSTR sCodecList, int nToPeerType, LPCTSTR sToPeerName, BOOL bBlocked, LPCTSTR sRoomName);
	void RemoveDirectProxySIP(LPCTSTR sProxyName);

	BOOL GetDirectProxyAll(CStringList* pDirectProxyList);
	BOOL GetDirectProxyDetails(LPCTSTR sProxyName, CString& sAuthLogin, CString& sAuthPwd, CString& sDomainRealm, CString& sProxyIP, LONG& lProxyPort, CString& sCodecList, int& nToPeerType, CString& sToPeerName, BOOL& bBlocked, CString& sRoomName);

	LONG GetVaxObjectError();

	BOOL DialToneToCallSession(BOOL bEnable, LONG lSessionId);
	BOOL DiagnosticLogSIP(BOOL bInbound, BOOL bOutbound);
		
public:

	BOOL AddRoom(LPCTSTR sRoomName, LPCTSTR sRoomNo);
	void RemoveRoom(LPCTSTR sRoomName);

	BOOL GetRoomDetails(LPCTSTR sRoomName, CString& sRoomNo);
	BOOL GetRoomAll(CStringList* pRoomList);

	BOOL IsRoomNoExist(LPCTSTR sRoomNo);

public:

	BOOL AddUserRoute(LPCTSTR sUserName, LPCTSTR sUserPrefix, LPCTSTR sDialPrefix, int nToPeerType, LPCTSTR sToPeerName);
	void RemoveUserRoute(LPCTSTR sUserName);

	BOOL AddLineRoute(LPCTSTR sLineName, int nToPeerType, LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName);
	void RemoveLineRoute(LPCTSTR sLineName);

	BOOL AddDirectProxyRoute(LPCTSTR sProxyName, int nToPeerType, LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName);
	void RemoveDirectProxyRoute(LPCTSTR sProxyName);

public:

	BOOL LoadDialToneMusic(LPCTSTR sFileName);
	void UnLoadDialToneMusic();

	LONG GetCallCount();
	
private:

	void DeleteCallSessionDataAll();
	void DeleteUserDataAll();

public:

	void GetUserAll(CStringList* pLoginList);
	BOOL GetUserDetails(LPCTSTR sUserName, CString& sPassword, CString& sCodecList, BOOL& bBlocked, CString& sUserPrefix, CString& sDialPrefix, int& nToPeerType, CString& sToPeerName);
	UINT GetRegisteredUserCount();

public:

	void GenStatusLog(LPCTSTR sStatus);
					
public:

	void OnRegisterUser(LPCTSTR sUserLogin, LPCTSTR sDomain, LPCTSTR sFromIP, LONG lFromPort);
	void OnRegisterUserSuccess(LPCTSTR sUserLogin);
	void OnRegisterUserFailed(LPCTSTR sUserLogin);
	void OnUnRegisterUser(LPCTSTR sUserLogin);
		
	void OnCallSessionOpen(LONG lSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, LONG lFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sFromIP, LONG lFromPort);
	
	void OnCallSessionCreated(LONG lSessionId, LONG lReasonCode);
	void OnCallSessionClosed(LONG lSessionId, LONG lCallType, LONG lReasonCode);

	void OnCallSessionOnHold(LONG lSessionId, LONG lCallType);
	void OnCallSessionOffHold(LONG lSessionId, LONG lCallType);

	void OnCallSessionTransferBlind(LONG lTransfererSessionId, LONG lTransfererCallType, LPCTSTR sTransferer, LPCTSTR sTransferee, LPCTSTR sTransferTo);
	void OnCallSessionTransferConsult(LONG lTransfererSessionId, LONG lTransfereeSessionId, LONG lTransferToSessionId, LONG lTransfererCallType, LONG lTransfereeCallType, LONG lTransferToCallType, LPCTSTR sTransferer, LPCTSTR sTransferee, LPCTSTR sTransferTo);
			
	void OnLineRegisterTrying(LPCTSTR sLineName);
	void OnLineRegisterFailed(LPCTSTR sLineName, LONG lStatusCode, LPCTSTR sReasonPhrase);
	void OnLineRegisterSuccess(LPCTSTR sLineName);

	void OnChatMessageText(LONG lChatMsgId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, LPCTSTR sMsgText, LONG lFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sFromIP, LONG lFromPort);
	void OnChatMessageTyping(LONG lChatMsgId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, BOOL IsTypingStart, LONG lFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sFromIP, LONG lFromPort);
	void OnChatStatusSubscribe(LONG lSubscrbId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, LONG lFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sFromIP, LONG lFromPort);

	void OnChatMessageSuccess(LONG lChatMsgId);
	void OnChatMessageFailed(LONG lChatMsgId, LONG lStatusId, LPCTSTR sReasonPhrase);
	void OnChatMessageTimeout(LONG lChatMsgId);
		
	void OnDetectedDigitDTMF(LONG lSessionId, LONG lCallType, LPCTSTR sDigitDTMF);
		
	void OnCallSessionOpenCall(LONG lSessionId, LONG lCallType, LONG lPeerType, LPCTSTR sPeerName);
	void OnCallSessionCloseCall(LONG lSessionId, LONG lCallType, LONG lPeerType, LPCTSTR sPeerName);
	
protected:

	virtual void OnStatusLog(LPCTSTR sMsg);
	virtual void OnErrorLog(LPCTSTR sMsg);

	void OnVaxErrorLog(LPCTSTR sFuncName, DWORD dwErrorCode, LPCTSTR sErrorMsg);
};


