#include "stdafx.h"
#include "VaxServerSIP.h"
#include "StatusLogDlg.h"
#include "ErrorLogDlg.h"

CVaxServerSIP::CVaxServerSIP()
{
	
}

CVaxServerSIP::~CVaxServerSIP()
{
}


/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////

BOOL CVaxServerSIP::AddUser(LPCTSTR sLogin, LPCTSTR sPassword, LPCTSTR sCodecList, BOOL bBlocked, LPCTSTR sUserPrefix, LPCTSTR sDialPrefix, int nToPeerType, LPCTSTR sToPeerName)
{
	CString sCallPrefixRoute, sDialPrefixRoute;

	sCallPrefixRoute = sUserPrefix;
	sDialPrefixRoute = sDialPrefix;

	if(!sCallPrefixRoute.IsEmpty() || !sDialPrefixRoute.IsEmpty())
		CVaxServerExCOM::AddUserRoute(sLogin, sUserPrefix, sDialPrefix, nToPeerType, sToPeerName);

	return CVaxServerExCOM::AddUser(sLogin, sPassword, sCodecList, bBlocked, sUserPrefix, sDialPrefix, nToPeerType, sToPeerName);
}

void CVaxServerSIP::RemoveUser(LPCTSTR sLogin)
{
	CVaxServerExCOM::RemoveUser(sLogin);
	CVaxServerExCOM::RemoveUserRoute(sLogin);
}

/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////

BOOL CVaxServerSIP::AddLine(LPCTSTR sLineName, LPCTSTR sDisplayName, LPCTSTR sUserName, LPCTSTR sAuthUser, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sProxySIP, LPCTSTR sCodecList, BOOL bRegister, int nToPeerType, LPCTSTR sToPeerName, BOOL bBlock, LPCTSTR sRoomName)
{
	CVaxServerExCOM::AddLineRoute(sLineName, nToPeerType, sToPeerName, bBlock, sRoomName);
	return CVaxServerExCOM::AddLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sCodecList, bRegister, nToPeerType, sToPeerName, bBlock, sRoomName);
}

void CVaxServerSIP::RemoveLine(LPCTSTR sLineName)
{
	CVaxServerExCOM::RemoveLine(sLineName);
	CVaxServerExCOM::RemoveLineRoute(sLineName);
}

/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////

BOOL CVaxServerSIP::AddDirectProxySIP(LPCTSTR sProxyName, LPCTSTR sAuthLogin, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sProxyIP, LONG lProxyPort, LPCTSTR sCodecList, int nToPeerType, LPCTSTR sToPeerName, BOOL bBlock, LPCTSTR sRoomName)
{
	CVaxServerExCOM::AddDirectProxyRoute(sProxyName, nToPeerType, sToPeerName, bBlock, sRoomName);
	return CVaxServerExCOM::AddDirectProxySIP(sProxyName, sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP, lProxyPort, sCodecList, nToPeerType, sToPeerName, bBlock, sRoomName);
}

void CVaxServerSIP::RemoveDirectProxySIP(LPCTSTR sProxyName)
{
	CVaxServerExCOM::RemoveDirectProxyRoute(sProxyName);
	CVaxServerExCOM::RemoveDirectProxySIP(sProxyName);
}

/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////

void CVaxServerSIP::OnStatusLog(LPCTSTR sStatus)
{
	m_pStatusLogDlg->OnStatusLog(sStatus);
}

void CVaxServerSIP::OnErrorLog(LPCTSTR sError)
{
	m_pErrorLogDlg->OnErrorLog(sError);
}