using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;

using VaxTeleServerApp;

namespace VaxTeleConfigSIP
{
    public partial class MainForm : Form
    {
        public static MainForm m_objMainForm;

        CVaxServerSIP m_objVaxTeleSIP = new CVaxServerSIP();

        private GeneralForm m_objGeneralForm;
        private AddLoginForm m_objAddLoginForm;
        private AddLineForm m_objAddLineForm;
        private AddConfRoom m_objAddConfRoomForm;
        private AddDirectProxyForm m_objAddDirecProxyForm;

        private ErrorLogForm m_objErrorLogForm;
        private StatusLogForm m_objStatusLogForm;

        public MainForm()
        {
            m_objGeneralForm = new GeneralForm(ref m_objVaxTeleSIP);

            m_objAddLoginForm = new AddLoginForm(ref m_objVaxTeleSIP);
            m_objAddLineForm = new AddLineForm(ref m_objVaxTeleSIP);

            m_objAddDirecProxyForm = new AddDirectProxyForm(ref m_objVaxTeleSIP);
            m_objAddConfRoomForm = new AddConfRoom(ref m_objVaxTeleSIP);
                      
            m_objErrorLogForm = new ErrorLogForm();
            m_objVaxTeleSIP.m_objErrorLogDlg = m_objErrorLogForm;

            m_objStatusLogForm = new StatusLogForm();
            m_objVaxTeleSIP.m_objStatusLogDlg = m_objStatusLogForm;

            m_objMainForm = this;
            InitializeComponent();
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            m_objGeneralForm.TopLevel = false;
            m_objGeneralForm.Visible = true;
            m_objGeneralForm.FormBorderStyle = FormBorderStyle.None;
            m_objGeneralForm.Dock = DockStyle.Fill;
            TabCtrlMain.TabPages[0].Controls.Add(m_objGeneralForm);

            m_objAddLoginForm.TopLevel = false;
            m_objAddLoginForm.Visible = true;
            m_objAddLoginForm.FormBorderStyle = FormBorderStyle.None;
            m_objAddLoginForm.Dock = DockStyle.Fill;
            TabCtrlMain.TabPages[1].Controls.Add(m_objAddLoginForm);

            m_objAddLineForm.TopLevel = false;
            m_objAddLineForm.Visible = true;
            m_objAddLineForm.FormBorderStyle = FormBorderStyle.None;
            m_objAddLineForm.Dock = DockStyle.Fill;
            TabCtrlMain.TabPages[2].Controls.Add(m_objAddLineForm);

            m_objAddDirecProxyForm.TopLevel = false;
            m_objAddDirecProxyForm.Visible = true;
            m_objAddDirecProxyForm.FormBorderStyle = FormBorderStyle.None;
            m_objAddDirecProxyForm.Dock = DockStyle.Fill;
            TabCtrlMain.TabPages[3].Controls.Add(m_objAddDirecProxyForm);

            m_objAddConfRoomForm.TopLevel = false;
            m_objAddConfRoomForm.Visible = true;
            m_objAddConfRoomForm.FormBorderStyle = FormBorderStyle.None;
            m_objAddConfRoomForm.Dock = DockStyle.Fill;
            TabCtrlMain.TabPages[4].Controls.Add(m_objAddConfRoomForm);


            m_objErrorLogForm.TopLevel = false;
            m_objErrorLogForm.Visible = true;
            m_objErrorLogForm.FormBorderStyle = FormBorderStyle.None;
            m_objErrorLogForm.Dock = DockStyle.Fill;
            TabCtrlMain.TabPages[5].Controls.Add(m_objErrorLogForm);

            m_objStatusLogForm.TopLevel = false;
            m_objStatusLogForm.Visible = true;
            m_objStatusLogForm.FormBorderStyle = FormBorderStyle.None;
            m_objStatusLogForm.Dock = DockStyle.Fill;
            TabCtrlMain.TabPages[6].Controls.Add(m_objStatusLogForm);

        }

        private void TabCtrlMain_DrawItem(object sender, DrawItemEventArgs e)
        {
            Graphics g = e.Graphics;
            Font f = new Font(e.Font, FontStyle.Bold);
            SolidBrush b = new SolidBrush(SystemColors.Control);
            g.FillRectangle(b, e.Bounds);

            b.Color = Color.Black;
            g.DrawString(this.TabCtrlMain.TabPages[e.Index].Text, e.Font, b, e.Bounds.X + 2, e.Bounds.Y + 2);

            b.Dispose();
            f.Dispose();
        }

        private void TabCtrlMain_SelectedIndexChanged(object sender, EventArgs e)
        {
            int nTabIndex = TabCtrlMain.SelectedIndex;

            if (nTabIndex == 0)
                m_objGeneralForm.OnSetActive();
            else if (nTabIndex == 1)
                m_objAddLoginForm.OnSetActive();
            else if (nTabIndex == 2)
                m_objAddLineForm.OnSetActive();
            else if (nTabIndex == 3)
                m_objAddDirecProxyForm.OnSetActive();
        }

        private void MainForm_Closing(object sender, FormClosingEventArgs e)
        {
            m_objVaxTeleSIP.UnInitialize();
        }

        public void SetPageTitle(string sTitle, int nPageNo)
        {
            TabCtrlMain.TabPages[nPageNo].Text = sTitle;
        }

        public void OnStatusLog(string sStatusMsg)
        {
            m_objStatusLogForm.OnStatusLog(sStatusMsg); 
        }
        
        public void OnErrorLog(string sErrorMsg)
        {
            m_objErrorLogForm.OnErrorLog(sErrorMsg);
        }
    }
}