﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

using VaxTeleServerCOMLib;

namespace VaxTeleServerApp
{
    public class CVaxServerCOM
    {
        public const int VAX_PEER_TYPE_USER = 3001;
        public const int VAX_PEER_TYPE_LINE = 3002;
        public const int VAX_PEER_TYPE_DIRECT_PROXY = 3003;

        public const int CONF_ROOM_NORMAL_LISTENER = 100;
        public const int CONF_ROOM_STEALTH_LISTENER = 101;
        public const int CONF_ROOM_STEALTH_SPEAKER = 102;

        public const int VAX_CLOSED_REASON_CODE_HANGUP = 2001;
        public const int VAX_CLOSED_REASON_CODE_SESSION_LOST = 2002;
        public const int VAX_CLOSED_REASON_CODE_MERGED = 2003;
        public const int VAX_CLOSED_REASON_CODE_TRANSFERED = 2004;
        public const int VAX_CLOSED_REASON_CODE_REJECTED = 2005;
        public const int VAX_CLOSED_REASON_CODE_FAILED = 2006;
        public const int VAX_CLOSED_REASON_CODE_CANCELLED = 2007;
        public const int VAX_CLOSED_REASON_CODE_TIMEOUT = 2008;
        public const int VAX_CLOSED_REASON_CODE_CLOSED = 2009;

        public const int VAX_CALL_TYPE_FROM = 201;
        public const int VAX_CALL_TYPE_TO = 202;

        public const int VAX_CUSTOM_HEADER_REQ_ID_INVITE = 0;

        public const int DTMF_TYPE_RFC2833 = 0;
        public const int DTMF_TYPE_INBAND = 1;
        public const int DTMF_TYPE_INFO = 2;

        public const int VAX_TRANSFER_TYPE_BLIND = 401;
        public const int VAX_TRANSFER_TYPE_CONSULT = 402;

        public const int VAX_CODEC_GSM610 = 0;
        public const int VAX_CODEC_ILBC = 1;
        public const int VAX_CODEC_G711A = 2;
        public const int VAX_CODEC_G711U = 3;
        public const int VAX_CODEC_G729 = 4;
        
        private VaxServerSIP m_objVaxServerSIP = new VaxServerSIP();
                                
        public CVaxServerCOM()
        {
            m_objVaxServerSIP.OnLineRegisterTrying += new _IVaxServerSIPEvents_OnLineRegisterTryingEventHandler(OnLineRegisterTrying);
            m_objVaxServerSIP.OnLineRegisterFailed += new _IVaxServerSIPEvents_OnLineRegisterFailedEventHandler(OnLineRegisterFailed);
            m_objVaxServerSIP.OnLineRegisterSuccess += new _IVaxServerSIPEvents_OnLineRegisterSuccessEventHandler(OnLineRegisterSuccess);

            m_objVaxServerSIP.OnLineUnRegisterTrying += new _IVaxServerSIPEvents_OnLineUnRegisterTryingEventHandler(OnLineUnRegisterTrying);
            m_objVaxServerSIP.OnLineUnRegisterFailed += new _IVaxServerSIPEvents_OnLineUnRegisterFailedEventHandler(OnLineUnRegisterFailed);
            m_objVaxServerSIP.OnLineUnRegisterSuccess += new _IVaxServerSIPEvents_OnLineUnRegisterSuccessEventHandler(OnLineUnRegisterSuccess);
            
            m_objVaxServerSIP.OnUnRegisterUser += new _IVaxServerSIPEvents_OnUnRegisterUserEventHandler(OnUnRegisterUser);
            m_objVaxServerSIP.OnRegisterUser += new _IVaxServerSIPEvents_OnRegisterUserEventHandler(OnRegisterUser);
            m_objVaxServerSIP.OnRegisterUserSuccess += new _IVaxServerSIPEvents_OnRegisterUserSuccessEventHandler(OnRegisterUserSuccess);
            m_objVaxServerSIP.OnRegisterUserFailed += new _IVaxServerSIPEvents_OnRegisterUserFailedEventHandler(OnRegisterUserFailed);
                        
            m_objVaxServerSIP.OnCallSessionOpen += new _IVaxServerSIPEvents_OnCallSessionOpenEventHandler(OnCallSessionOpen);
            m_objVaxServerSIP.OnCallSessionFailed += new _IVaxServerSIPEvents_OnCallSessionFailedEventHandler(OnCallSessionFailed);
            m_objVaxServerSIP.OnCallSessionConnecting += new _IVaxServerSIPEvents_OnCallSessionConnectingEventHandler(OnCallSessionConnecting);
            m_objVaxServerSIP.OnCallSessionConnected += new _IVaxServerSIPEvents_OnCallSessionConnectedEventHandler(OnCallSessionConnected);
            m_objVaxServerSIP.OnCallSessionClosed += new _IVaxServerSIPEvents_OnCallSessionClosedEventHandler(OnCallSessionClosed);

            m_objVaxServerSIP.OnCallSessionLost += new _IVaxServerSIPEvents_OnCallSessionLostEventHandler(OnCallSessionLost);
            m_objVaxServerSIP.OnCallSessionHangup += new _IVaxServerSIPEvents_OnCallSessionHangupEventHandler(OnCallSessionHangup);
            m_objVaxServerSIP.OnCallSessionTimeout += new _IVaxServerSIPEvents_OnCallSessionTimeoutEventHandler(OnCallSessionTimeout);
            m_objVaxServerSIP.OnCallSessionCancelled += new _IVaxServerSIPEvents_OnCallSessionCancelledEventHandler(OnCallSessionCancelled);

            m_objVaxServerSIP.OnCallSessionOnHold += new _IVaxServerSIPEvents_OnCallSessionOnHoldEventHandler(OnCallSessionOnHold);
            m_objVaxServerSIP.OnCallSessionOffHold += new _IVaxServerSIPEvents_OnCallSessionOffHoldEventHandler(OnCallSessionOffHold);

            m_objVaxServerSIP.OnCallSessionTransferBlind += new _IVaxServerSIPEvents_OnCallSessionTransferBlindEventHandler(OnCallSessionTransferBlind);
            m_objVaxServerSIP.OnCallSessionTransferConsult += new _IVaxServerSIPEvents_OnCallSessionTransferConsultEventHandler(OnCallSessionTransferConsult);

            m_objVaxServerSIP.OnCallSessionTransfering += new _IVaxServerSIPEvents_OnCallSessionTransferingEventHandler(OnCallSessionTransfering);
            m_objVaxServerSIP.OnCallSessionTransferFailed += new _IVaxServerSIPEvents_OnCallSessionTransferFailedEventHandler(OnCallSessionTransferFailed);
            m_objVaxServerSIP.OnCallSessionTransferTimeout += new _IVaxServerSIPEvents_OnCallSessionTransferTimeoutEventHandler(OnCallSessionTransferTimeout);
            m_objVaxServerSIP.OnCallSessionTransfered += new _IVaxServerSIPEvents_OnCallSessionTransferedEventHandler(OnCallSessionTransfered);

            m_objVaxServerSIP.OnChatMessageText += new _IVaxServerSIPEvents_OnChatMessageTextEventHandler(OnChatMessageText);
            m_objVaxServerSIP.OnChatMessageTyping += new _IVaxServerSIPEvents_OnChatMessageTypingEventHandler(OnChatMessageTyping);
            m_objVaxServerSIP.OnChatStatusSubscribe += new _IVaxServerSIPEvents_OnChatStatusSubscribeEventHandler(OnChatStatusSubscribe);

            m_objVaxServerSIP.OnChatMessageSuccess += new _IVaxServerSIPEvents_OnChatMessageSuccessEventHandler(OnChatMessageSuccess);
            m_objVaxServerSIP.OnChatMessageFailed += new _IVaxServerSIPEvents_OnChatMessageFailedEventHandler(OnChatMessageFailed);
            m_objVaxServerSIP.OnChatMessageTimeout += new _IVaxServerSIPEvents_OnChatMessageTimeoutEventHandler(OnChatMessageTimeout);

            m_objVaxServerSIP.OnDetectedDigitDTMF += new _IVaxServerSIPEvents_OnDetectedDigitDTMFEventHandler(OnDetectedDigitDTMF);
            
            m_objVaxServerSIP.OnOutgoingDiagnosticLog += new _IVaxServerSIPEvents_OnOutgoingDiagnosticLogEventHandler(OnOutgoingDiagnosticLog);
            m_objVaxServerSIP.OnIncomingDiagnosticLog += new _IVaxServerSIPEvents_OnIncomingDiagnosticLogEventHandler(OnIncomingDiagnosticLog);

            m_objVaxServerSIP.OnVaxTeleTick += new _IVaxServerSIPEvents_OnVaxTeleTickEventHandler(OnVaxTeleTick);
            
            m_objVaxServerSIP.OnSendTimeoutVM += new _IVaxServerSIPEvents_OnSendTimeoutVMEventHandler(OnSendTimeoutVM);
            m_objVaxServerSIP.OnSendSuccessVM += new _IVaxServerSIPEvents_OnSendSuccessVMEventHandler(OnSendSuccessVM);

            m_objVaxServerSIP.OnCallSessionDialToneStart += new _IVaxServerSIPEvents_OnCallSessionDialToneStartEventHandler(OnCallSessionDialToneStart);
            m_objVaxServerSIP.OnCallSessionDialToneStop += new _IVaxServerSIPEvents_OnCallSessionDialToneStopEventHandler(OnCallSessionDialToneStop);

            m_objVaxServerSIP.OnCallSessionPlayWaveDone += new _IVaxServerSIPEvents_OnCallSessionPlayWaveDoneEventHandler(OnCallSessionPlayWaveDone);
            m_objVaxServerSIP.OnConferenceRoomPlayWaveDone += new _IVaxServerSIPEvents_OnConferenceRoomPlayWaveDoneEventHandler(OnConferenceRoomPlayWaveDone);

            m_objVaxServerSIP.OnCallSessionCreated += new _IVaxServerSIPEvents_OnCallSessionCreatedEventHandler(OnCallSessionCreated);
            
            m_objVaxServerSIP.OnCallSessionOpenCall += new _IVaxServerSIPEvents_OnCallSessionOpenCallEventHandler(OnCallSessionOpenCall);
            m_objVaxServerSIP.OnCallSessionCloseCall += new _IVaxServerSIPEvents_OnCallSessionCloseCallEventHandler(OnCallSessionCloseCall);

            m_objVaxServerSIP.OnCallSessionDetectedAMD += new _IVaxServerSIPEvents_OnCallSessionDetectedAMDEventHandler(OnCallSessionDetectedAMD);

            m_objVaxServerSIP.OnCallSessionRecordedPCM += new _IVaxServerSIPEvents_OnCallSessionRecordedPCMEventHandler(OnCallSessionRecordedPCM);
            m_objVaxServerSIP.OnConferenceRoomRecordedPCM += new _IVaxServerSIPEvents_OnConferenceRoomRecordedPCMEventHandler(OnConferenceRoomRecordedPCM);

            m_objVaxServerSIP.OnBusyLampSubscribe += new _IVaxServerSIPEvents_OnBusyLampSubscribeEventHandler(OnBusyLampSubscribe);
            m_objVaxServerSIP.OnBusyLampUnSubscribe += new _IVaxServerSIPEvents_OnBusyLampUnSubscribeEventHandler(OnBusyLampUnSubscribe);
            m_objVaxServerSIP.OnBusyLampSubscribeSuccess += new _IVaxServerSIPEvents_OnBusyLampSubscribeSuccessEventHandler(OnBusyLampSubscribeSuccess);
            m_objVaxServerSIP.OnBusyLampSubscribeFailed += new _IVaxServerSIPEvents_OnBusyLampSubscribeFailedEventHandler(OnBusyLampSubscribeFailed);

            m_objVaxServerSIP.OnVaxErrorLog += new _IVaxServerSIPEvents_OnVaxErrorLogEventHandler(OnVaxErrorLog);
        }

        ~CVaxServerCOM()
        {
           
        }

        #region Methods

        public void SetLicenseKey(string sLicenseKey) 
        {
            m_objVaxServerSIP.SetLicenseKey(sLicenseKey);
        }

        public Boolean AddListenIP(string sSIPListenIP, string sRTPListenIP)
        {
            return m_objVaxServerSIP.AddListenIP(sSIPListenIP, sRTPListenIP);
        }

        public bool Initialize(string sDomainRealm, string sSIPListenIP, int nSIPListenPort, string sRTPListenIP, int nRTPListenPort)
        {
           return m_objVaxServerSIP.Initialize(sDomainRealm, sSIPListenIP, nSIPListenPort, sRTPListenIP, nRTPListenPort);
        }

        public void UnInitialize() 
        {
            m_objVaxServerSIP.UnInitialize();
        }

        public Boolean SetListenPortRangeRTP(int nListenStartPort, int nListenEndPort)
        {
            return m_objVaxServerSIP.SetListenPortRangeRTP(nListenStartPort, nListenEndPort);
        }

        public bool AddUser(string sUserName, string sPassword, string sCodecList)
        {
            return m_objVaxServerSIP.AddUser(sUserName, sPassword, sCodecList);
        }
        public void RemoveUser(string sUserName) 
        {
            m_objVaxServerSIP.RemoveUser(sUserName);
        }

        public bool AcceptRegister(string sUserName)
        {
            return m_objVaxServerSIP.AcceptRegister(sUserName);
        }
        public bool RejectRegister(string sUserName, int nStatusCode, string sReasonPhrase)
        {
            return m_objVaxServerSIP.RejectRegister(sUserName, nStatusCode, sReasonPhrase);
        }
        public bool AuthRegister(string sUserName)
        {
            return m_objVaxServerSIP.AuthRegister(sUserName);
        }

        public bool RegisterUserExpiry(int nExpiry)
        {
            return m_objVaxServerSIP.RegisterUserExpiry(nExpiry);
        }

        public bool AddLine(string sLineName, string sDisplayName, string sUserName, string sAuthUser, string sAuthPwd, string sDomainRealm, string sProxySIP, string sOutboundProxySIP, string sCodecList)
        {
            return m_objVaxServerSIP.AddLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sOutboundProxySIP, sCodecList);
        }
        public void RemoveLine(string sLineName) 
        {
            m_objVaxServerSIP.RemoveLine(sLineName);
        }

        public bool RegisterLine(string sLineName, int nExpire)
        {
            return m_objVaxServerSIP.RegisterLine(sLineName, nExpire);
        }
        public bool UnRegisterLine(string sLineName)
        {
            return m_objVaxServerSIP.UnRegisterLine(sLineName);
        }

        public bool AddDirectProxySIP(string sProxyName, string sAuthLogin, string sAuthPwd, string sDomainRealm, string sProxyIP, int nProxyPort, string sCodecList)
        {
            return m_objVaxServerSIP.AddDirectProxySIP(sProxyName, sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP, nProxyPort, sCodecList);
        }
        public void RemoveDirectProxySIP(string sProxyName) 
        {
            m_objVaxServerSIP.RemoveDirectProxySIP(sProxyName);
        }

        public bool AcceptCallSession(int nSessionId, string sCallerName, string sCallerId, string sDialNo, int nToPeerType, string sToPeerName, int nTimeout)
        {
            return m_objVaxServerSIP.AcceptCallSession(nSessionId, sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, nTimeout);
        }
        public bool RejectCallSession(int nSessionId, int nStatusCode, string sReasonPhrase)
        {
            return m_objVaxServerSIP.RejectCallSession(nSessionId, nStatusCode, sReasonPhrase);
        }
        public bool CloseCallSession(int nSessionId) 
        {
            return m_objVaxServerSIP.CloseCallSession(nSessionId);
        }

        public long CreateCallSession(string sCallerName, string sCallerId, string sDialNo, int nToPeerType, string sToPeerName, int nTimeout)
        {
            return m_objVaxServerSIP.OpenCallSession(sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, nTimeout);
        }

        public long OpenCallSession(string sCallerName, string sCallerId, string sDialNo, int nToPeerType, string sToPeerName, int nTimeout)
        {
            return m_objVaxServerSIP.OpenCallSession(sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, nTimeout);
        }

        public long AcceptTransferBlind(int nTransfererSessionId, string sCallerName, string sCallerId, string sTransferTo, int nToPeerType, string sToPeerName, int nTimeout)
        {
            return m_objVaxServerSIP.AcceptTransferBlind(nTransfererSessionId, sCallerName, sCallerId, sTransferTo, nToPeerType, sToPeerName, nTimeout);
        }
        public long AcceptTransferConsult(int nTransfererSessionId, int nTransferToSessionId)
        {
            return m_objVaxServerSIP.AcceptTransferConsult(nTransfererSessionId, nTransferToSessionId);
        }
        public void RejectTransfer(int nSessionId) 
        {
            m_objVaxServerSIP.RejectTransfer(nSessionId);
        }

        public bool PlayWaveStartToCallSession(int nSessionId, int nWaveId, bool bLoop)
        {
            return m_objVaxServerSIP.PlayWaveStartToCallSession(nSessionId, nWaveId, bLoop);
        }
        public bool PlayWaveStopToCallSession(int nSessionId)
        {
            return m_objVaxServerSIP.PlayWaveStopToCallSession(nSessionId);
        }

        public bool RecordWaveStartToCallSession(int nSessionId, string sFileName)
        {
            return m_objVaxServerSIP.RecordWaveStartToCallSession(nSessionId, sFileName);
        }
        public bool RecordWaveStopToCallSession(int nSessionId)
        {
            return m_objVaxServerSIP.RecordWaveStopToCallSession(nSessionId);
        }
        public bool RecordWavePauseToCallSession(int nSessionId, bool bEnable)
        {
            return m_objVaxServerSIP.RecordWavePauseToCallSession(nSessionId, bEnable);
        }

        public int LoadWaveFile(string sFileName)
        {
            return m_objVaxServerSIP.LoadWaveFile(sFileName);
        }
        public int LoadWavePCM(Byte[] aDataPCM, int nSizePCM)
        {
            GCHandle hHandleGC = GCHandle.Alloc(aDataPCM, GCHandleType.Pinned);
            IntPtr AddrDataPCM = hHandleGC.AddrOfPinnedObject();
            long lDataPCM = AddrDataPCM.ToInt64();
            
            int nWaveId = m_objVaxServerSIP.LoadWavePCM(lDataPCM, nSizePCM, 0);
            
            hHandleGC.Free();
            return nWaveId;
        }
        public void UnLoadWaveFile(int nWaveId) 
        {
            m_objVaxServerSIP.UnLoadWaveFile(nWaveId);
        }

        public bool LoadMusicHold(string sFileName)
        {
            return m_objVaxServerSIP.LoadMusicHold(sFileName);
        }
        public void UnLoadMusicHold() 
        {
            m_objVaxServerSIP.UnLoadMusicHold();
        }

        public bool AcceptOnHoldRequest(int nSessionId)
        {
            return m_objVaxServerSIP.AcceptOnHoldRequest(nSessionId);
        }
        public bool AcceptOffHoldRequest(int nSessionId)
        {
            return m_objVaxServerSIP.AcceptOffHoldRequest(nSessionId);
        }

        public bool AcceptChatMessage(int nChatMsgId, int nToPeerType, string sToPeerName)
        {
            return m_objVaxServerSIP.AcceptChatMessage(nChatMsgId, nToPeerType, sToPeerName);
        }
        public void RejectChatMessage(int nChatMsgId, int nStatusCode, string sReasonPhrase)
        {
            m_objVaxServerSIP.RejectChatMessage(nChatMsgId, nStatusCode, sReasonPhrase);
        }

        public int SendChatMessageText(string sMsgFrom, string sMsgTo, string sMsgText, int nToPeerType, string sToPeerName)
        {
            return m_objVaxServerSIP.SendChatMessageText(sMsgFrom, sMsgTo, sMsgText, nToPeerType, sToPeerName);
        }

        public bool AcceptChatStatusSubscribe(int nStatusSubscribe, string sMsgFrom, string sMsgTo, int nToPeerType, string sToPeerName)
        {
            return m_objVaxServerSIP.AcceptChatStatusSubscribe(nStatusSubscribe, sMsgFrom, sMsgTo, nToPeerType, sToPeerName);
        }
        public void RejectChatStatusSubscribe(int nStatusSubscribe, string sMsgFrom, string sMsgTo) 
        {
            m_objVaxServerSIP.RejectChatStatusSubscribe(nStatusSubscribe, sMsgFrom, sMsgTo);
        }

        public bool OpenConferenceRoom(string sRoomName)
        {
            return m_objVaxServerSIP.OpenConferenceRoom(sRoomName);
        }
        public void CloseConferenceRoom(string sRoomName) 
        {
            m_objVaxServerSIP.CloseConferenceRoom(sRoomName);
        }

        public bool AddCallSessionToConferenceRoom(string sRoomName, int nSessionId, int nType)
        {
            return m_objVaxServerSIP.AddCallSessionToConferenceRoom(sRoomName, nSessionId, nType);
        }
        public bool RemoveCallSessionFromConferenceRoom(int nSessionId)
        {
            return m_objVaxServerSIP.RemoveCallSessionFromConferenceRoom(nSessionId);
        }

        public bool PlayWaveStartToConferenceRoom(string sRoomName, int nWaveId, bool bLoop)
        {
            return m_objVaxServerSIP.PlayWaveStartToConferenceRoom(sRoomName, nWaveId, bLoop);
        }
        public bool PlayWaveStopToConferenceRoom(string sRoomName)
        {
            return m_objVaxServerSIP.PlayWaveStopToConferenceRoom(sRoomName);
        }

        public bool RecordWaveStartToConferenceRoom(string sRoomName, string sFileName)
        {
            return m_objVaxServerSIP.RecordWaveStartToConferenceRoom(sRoomName, sFileName);
        }
        public bool RecordWaveStopToConferenceRoom(string sRoomName)
        {
            return m_objVaxServerSIP.RecordWaveStopToConferenceRoom(sRoomName);
        }
        public bool RecordWavePauseToConferenceRoom(string sRoomName, bool bEnable)
        {
            return m_objVaxServerSIP.RecordWavePauseToConferenceRoom(sRoomName, bEnable);
        }

        public bool VoiceSessionLost(bool bEnable, int nTimeout)
        {
            return m_objVaxServerSIP.VoiceSessionLost(bEnable, nTimeout);
        }

        public long SendInfoVM(string sUserLogin, int nNewMsgCount, int nOldMsgCount, bool bMsgWaiting)
        {
            return m_objVaxServerSIP.SendInfoVM(sUserLogin, nNewMsgCount, nOldMsgCount, bMsgWaiting);
        }

        public bool StartVaxTeleTick(int nTickId, int nElapse)
        {
            return m_objVaxServerSIP.StartVaxTeleTick(nTickId, nElapse);
        }
        public bool StopVaxTeleTick(int nTickId)
        {
            return m_objVaxServerSIP.StopVaxTeleTick(nTickId);
        }

        public bool SetUserAgentName(string sName)
        {
            return m_objVaxServerSIP.SetUserAgentName(sName);
        }
        public string GetUserAgentName()
        {
            return m_objVaxServerSIP.GetUserAgentName().ToString();
        }

        public bool SetSessionNameSDP(string sName)
        {
            return m_objVaxServerSIP.SetSessionNameSDP(sName);
        }
        public string GetSessionNameSDP()
        {
            return m_objVaxServerSIP.GetSessionNameSDP().ToString();
        }

        public bool SendDTMFCallSession(int nSessionId, int nTypeDTMF, int nDigit)
        {
            return m_objVaxServerSIP.SendDTMFCallSession(nSessionId, nDigit, nTypeDTMF);
        }
        public bool DetectDigitDTMF(int nSessionId, int nCallType, int nTypeDTMF, bool bEnable, int nMilliSecondTimeout)
        {
            return m_objVaxServerSIP.DetectDigitDTMF(nSessionId, nCallType, nTypeDTMF, bEnable, nMilliSecondTimeout);
        }

        public int GetVaxObjectError()
        {
            return m_objVaxServerSIP.GetVaxObjectError();
        }

        public bool DialToneToCallSession(bool bEnable, int nSessionId, int nWaveId)
        {
            return m_objVaxServerSIP.DialToneToCallSession(bEnable, nSessionId, nWaveId);
        }

        public bool DiagnosticLogSIP(bool bInbound, bool bOutbound)
        {
            return m_objVaxServerSIP.DiagnosticLogSIP(bInbound, bOutbound);
        }

        public bool CallSessionSwapCalls(int nSessionId)
        {
            return m_objVaxServerSIP.CallSessionSwapCalls(nSessionId);
        }

        public long MergeCallSession(int nFromSessionId, int nToSessionId)
        {
            return m_objVaxServerSIP.MergeCallSession(nFromSessionId, nToSessionId);
        }

        public bool CallSessionSendStatusResponse(int nSessionId, int nStatusCode, string sReasonPhrase)
        {
            return m_objVaxServerSIP.CallSessionSendStatusResponse(nSessionId, nStatusCode, sReasonPhrase);
        }

        public bool CallSessionDetectAMD(int nSessionId, int nCallType, bool bEnable, int nAnalysisTime, int nSilenceTime, int nSilenceCount)
        {
            return m_objVaxServerSIP.CallSessionDetectAMD(nSessionId, nCallType, bEnable, nAnalysisTime, nSilenceTime, nSilenceCount);
        }

        public bool AddCustomHeader(int nReqId, string sName, string sValue)
        {
            return m_objVaxServerSIP.AddCustomHeader(nReqId, sName, sValue);
        }

        public bool RemoveCustomHeader(int nReqId, string sName)
        {
            return m_objVaxServerSIP.RemoveCustomHeader(nReqId, sName);
        }

        public bool RemoveCustomHeaderAll(int nReqId)
        {
            return m_objVaxServerSIP.RemoveCustomHeaderAll(nReqId);
        }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        public int GetCallSessionTxCodec(int nSessionId, int nCallType)
        {
	        return m_objVaxServerSIP.GetCallSessionTxCodec(nSessionId, nCallType);
        }

        public int GetCallSessionRxCodec(int nSessionId, int nCallType)
        {
	        return m_objVaxServerSIP.GetCallSessionRxCodec(nSessionId, nCallType);
        }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        public bool BusyLampSubscribeAccept(int nSubScrbId, bool bAuthenticate, int nExpires)
        {
	        return m_objVaxServerSIP.BusyLampSubscribeAccept(nSubScrbId, bAuthenticate, nExpires);
        }

        public bool BusyLampSubscribeReject(int nSubScrbId, int nStatusCode, string sReasonPhrase)
        {
	        return m_objVaxServerSIP.BusyLampSubscribeReject(nSubScrbId, nStatusCode, sReasonPhrase);
        }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        public bool SetCallSessionData(int nSessionId, object objCustomData)
        {
            GCHandle hGC = GCHandle.Alloc(objCustomData);
            
	        if(!m_objVaxServerSIP.SetCallSessionData(nSessionId, (long) (IntPtr)hGC))
            {
                hGC.Free();
                return false;
            }

            return true;
        }

        public object GetCallSessionData(int nSessionId)
        {
            long lData = m_objVaxServerSIP.GetCallSessionData(nSessionId);
            if (lData == 0) return null;

            GCHandle hGC = (GCHandle)((IntPtr)lData);
            return (hGC.Target as object);
        }

        public void FreeCallSessionData(int nSessionId)
        {
            long lData = m_objVaxServerSIP.GetCallSessionData(nSessionId);
            if (lData == 0) return;

            GCHandle hGC = (GCHandle)((IntPtr)lData);
            hGC.Free();
        }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        public bool SetUserData(string sUserName, object objCustomData)
        {
	        GCHandle hGC = GCHandle.Alloc(objCustomData);
            
	        if(!m_objVaxServerSIP.SetUserData(sUserName, (long) (IntPtr)hGC))
            {
                hGC.Free();
                return false;
            }

            return true;
        }

        public object GetUserData(string sUserName)
        {
            long lData = m_objVaxServerSIP.GetUserData(sUserName);
            if (lData == 0) return null;

            GCHandle hGC = (GCHandle)((IntPtr)lData);
            return (hGC.Target as object);
        }

        public void FreeUserData(string sUserName)
        {
            long lData = m_objVaxServerSIP.GetUserData(sUserName);
            if (lData == 0) return;

            GCHandle hGC = (GCHandle)((IntPtr) lData);
            hGC.Free();
        }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        public bool SetLineData(string sLineName, object objCustomData)
        {
	        GCHandle hGC = GCHandle.Alloc(objCustomData);
            
	        if(!m_objVaxServerSIP.SetLineData(sLineName, (long) (IntPtr)hGC))
            {
                hGC.Free();
                return false;
            }

            return true;
        }

        public object GetLineData(string sLineName)
        {
            long lData = m_objVaxServerSIP.GetLineData(sLineName);
            if (lData == 0) return null;

            GCHandle hGC = (GCHandle)((IntPtr)lData);
            return (hGC.Target as object);
        }

        public void FreeLineData(string sLineName)
        {
            long lData = m_objVaxServerSIP.GetLineData(sLineName);
            if (lData == 0) return;

            GCHandle hGC = (GCHandle)((IntPtr)lData);
            hGC.Free();
        }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        public bool SetDirectProxyData(string sProxyName, object objCustomData)
        {
	        GCHandle hGC = GCHandle.Alloc(objCustomData);
            
	        if(!m_objVaxServerSIP.SetDirectProxyData(sProxyName, (long) (IntPtr)hGC))
            {
                hGC.Free();
                return false;
            }

            return true;
        }
	
        public object GetDirectProxyData(string sProxyName)
        {
            long lData = m_objVaxServerSIP.GetDirectProxyData(sProxyName);
            if (lData == 0) return null;

            GCHandle hGC = (GCHandle)((IntPtr)lData);
            return (hGC.Target as object);
        }

        public void FreeDirectProxyData(string sProxyName)
        {
            long lData = m_objVaxServerSIP.GetDirectProxyData(sProxyName);
            if (lData == 0) return;

            GCHandle hGC = (GCHandle)((IntPtr)lData);
            hGC.Free();
        }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        public bool SetConferenceRoomData(string sRoomName, object objCustomData)
        {
	        GCHandle hGC = GCHandle.Alloc(objCustomData);
            
	        if(!m_objVaxServerSIP.SetConferenceRoomData(sRoomName, (long) (IntPtr)hGC))
            {
                hGC.Free();
                return false;
            }

            return true;
        }

        public object GetConferenceRoomData(string sRoomName)
        {
            long lData = m_objVaxServerSIP.GetConferenceRoomData(sRoomName);
            if (lData == 0) return null;

            GCHandle hGC = (GCHandle)((IntPtr)lData);
            return (hGC.Target as object);
        }

        public void FreeConferenceRoomData(string sRoomName)
        {
            long lData = m_objVaxServerSIP.GetConferenceRoomData(sRoomName);
            if (lData == 0) return;

            GCHandle hGC = (GCHandle)((IntPtr)lData);
            hGC.Free();
        }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        public bool TrvsUserStart()
        {
	        return m_objVaxServerSIP.TrvsUserStart();
        }

        public string TrvsUserNext()
        {
	        return m_objVaxServerSIP.TrvsUserNext();
        }

        public bool TrvsLineStart()
        {
	        return m_objVaxServerSIP.TrvsLineStart();
        }

        public string TrvsLineNext()
        {
	        return m_objVaxServerSIP.TrvsLineNext();
        }

        public bool TrvsDirectProxyStart()
        {
	        return m_objVaxServerSIP.TrvsDirectProxyStart();
        }

        public string TrvsDirectProxyNext()
        {
	        return m_objVaxServerSIP.TrvsDirectProxyNext();
        }

        public bool TrvsCallSessionStart()
        {
	        return m_objVaxServerSIP.TrvsCallSessionStart();
        }

        public int TrvsCallSessionNext()
        {
	        return m_objVaxServerSIP.TrvsCallSessionNext();
        }

        public bool TrvsConferenceRoomStart()
        {
	        return m_objVaxServerSIP.TrvsConferenceRoomStart();
        }

        public string TrvsConferenceRoomNext()
        {
	        return m_objVaxServerSIP.TrvsConferenceRoomNext();
        }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        public int GetUserCount()
        {
	        return m_objVaxServerSIP.GetUserCount();
        }

        public int GetLineCount()
        {
	        return m_objVaxServerSIP.GetLineCount();
        }

        public int GetDirectProxyCount()
        {
	        return m_objVaxServerSIP.GetDirectProxyCount();
        }

        public int GetCallSessionCount()
        {
	        return m_objVaxServerSIP.GetCallSessionCount();
        }

        public int GetConferenceRoomCount()
        {
	        return m_objVaxServerSIP.GetConferenceRoomCount();
        }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        public int CustomListOpen(int nTableSize)
        {
	        return m_objVaxServerSIP.CustomListOpen(nTableSize);
        }

        public bool CustomListClose(int nListId)
        {
	        return m_objVaxServerSIP.CustomListClose(nListId);
        }
	
        public bool CustomListAddData(int nListId, string sKey, object objCustomData)
        {
	         GCHandle hGC = GCHandle.Alloc(objCustomData);
            
	        if(!m_objVaxServerSIP.CustomListAddData(nListId, sKey, (long) (IntPtr)hGC))
            {
                hGC.Free();
                return false;
            }

            return true;
        }

        public bool CustomListRemoveData(int nListId, string sKey)
        {
            long lData = m_objVaxServerSIP.CustomListFindData(nListId, sKey);
            if (lData == 0) return false;

            GCHandle hGC = (GCHandle)((IntPtr)lData);
            hGC.Free();

            return m_objVaxServerSIP.CustomListRemoveData(nListId, sKey);
        }

        public object CustomListFindData(int nListId, string sKey)
        {
            long lData = m_objVaxServerSIP.CustomListFindData(nListId, sKey);
            if (lData == 0) return null;

            GCHandle hGC = (GCHandle)((IntPtr)lData);
            return (hGC.Target as object);
        }

        public int CustomListCount(int nListId)
        {
	        return m_objVaxServerSIP.CustomListCount(nListId);
        }

        public bool CustomListReset(int nListId)
        {
	        return m_objVaxServerSIP.CustomListReset(nListId);
        }

        public bool CustomListTrvsStart(int nListId)
        {
	        return m_objVaxServerSIP.CustomListTrvsStart(nListId);
        }

        public object CustomListTrvsNext(int nListId)
        {
	        long lData = m_objVaxServerSIP.CustomListTrvsNext(nListId);
            if (lData == 0) return null;

            GCHandle hGC = (GCHandle)((IntPtr)lData);
            return (hGC.Target as object);
        }

        public string GetCallSessionHeaderCallId(int nSessionId, int nCallType)
        {
            return m_objVaxServerSIP.GetCallSessionHeaderCallId(nSessionId, nCallType);
        }

        public bool CallSessionMuteVoice(int nSessionId, int nCallType, bool bListen, bool bSpeak)
        {
            return m_objVaxServerSIP.CallSessionMuteVoice(nSessionId, nCallType, bListen, bSpeak);
        }

        public bool VideoCOMM(bool bEnable)
        {
            return m_objVaxServerSIP.VideoCOMM(bEnable);
        }
        
        #endregion


        #region Events

        public virtual void OnLineRegisterTrying(string sLineName)
        {
        }
        public virtual void OnLineRegisterFailed(string sLineName, int nStatusCode, string sReasonPhrase)
        {
        }
        public virtual void OnLineRegisterSuccess(string sLineName)
        {
        }
        public virtual void OnLineUnRegisterTrying(string sLineName)
        {
        }
        public virtual void OnLineUnRegisterFailed(string sLineName, int nStatusCode, string sReasonPhrase)
        {
        }
        public virtual void OnLineUnRegisterSuccess(string sLineName)
        {
        }

        public virtual void OnUnRegisterUser(string sUserLogin)
        {
        }
        public virtual void OnRegisterUser(string sUserLogin, string sDomain, string sFromIP, int nFromPort)
        {
           
        }
        public virtual void OnRegisterUserSuccess(string sUserLogin)
        {
        }
        public virtual void OnRegisterUserFailed(string sUserLogin)
        {
        }

        public virtual void OnChatMessageText(int nChatMsgId, string sMsgFrom, string sMsgTo, string sMsgText, int nFromPeerType, string sFromPeerName, string sFromIP, int nFromPort)
        {
        }
        public virtual void OnChatMessageTyping(int nChatMsgId, string sMsgFrom, string sMsgTo, bool bIsTypingStart, int nFromPeerType, string sFromPeerName, string sFromIP, int nFromPort)
        {
        }
        public virtual void OnChatStatusSubscribe(int nSubscrbId, string sMsgFrom, string sMsgTo, int nFromPeerType, string sFromPeerName, string sFromIP, int nFromPort)
        {
        }

        public virtual void OnChatMessageSuccess(int nChatMsgId)
        {
        }
        public virtual void OnChatMessageFailed(int nChatMsgId, int nStatusCode, string sReasonPhrase)
        {
        }
        public virtual void OnChatMessageTimeout(int nChatMsgId)
        {
        }

        public virtual void OnCallSessionOpen(int nSessionId, string sCallerName, string sCallerId, string sDialNo, int nFromPeerType, string sFromPeerName, string sFromIP, int nFromPort)
        {
        }

        public virtual void OnCallSessionConnecting(int nSessionId, int nCallType, int nStatusCode, string sReasonPhrase)
        {
        }
        public virtual void OnCallSessionFailed(int nSessionId, int nCallType, int nStatusCode, string sReasonPhrase)
        {
        }
        public virtual void OnCallSessionConnected(int nSessionId)
        {
        }
        public virtual void OnCallSessionClosed(int nSessionId, int nCallType, int nReasonCode)
        {
        }

        public virtual void OnCallSessionLost(int nSessionId, int nCallType)
        {
        }

        public virtual void OnCallSessionHangup(int nSessionId, int nCallType)
        {
        }

        public virtual void OnCallSessionTimeout(int nSessionId, int nCallType)
        {
        }

        public virtual void OnCallSessionCancelled(int nSessionId)
        {
        }

        public virtual void OnCallSessionOnHold(int nSessionId, int nCallType)
        {
        }
        public virtual void OnCallSessionOffHold(int nSessionId, int nCallType)
        {
        }

        ////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////

        public virtual void OnCallSessionTransferBlind(int nTransfererSessionId, int nTransfererCallType, string sTransferer, string sTransferee, string sTransferTo)
        {
        }
        public virtual void OnCallSessionTransferConsult(int nTransfererSessionId, int nTransfereeSessionId, int nTransferToSessionId, int nTransfererCallType, int nTransfereeCallType, int nTransferToCallType, string sTransferer, string sTransferee, string sTransferTo)
        {
        }

        public virtual void OnCallSessionTransfering(int nSessionId, int nTransferType, int nCallType, int nStatusCode, string sReasonPhrase)
        {
        }

        public virtual void OnCallSessionTransferFailed(int nSessionId, int nTransferType, int nCallType, int nStatusCode, string sReasonPhrase)
        {
        }

        public virtual void OnCallSessionTransferTimeout(int nSessionId, int nTransferType, int nCallType)
        {
        }

        public virtual void OnCallSessionTransfered(int nSessionId, int nTransferType)
        {
        }

        ////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////

        public virtual void OnDetectedDigitDTMF(int nSessionId, int nCallType, string sDigitDTMF)
        {
        }

        public virtual void OnOutgoingDiagnosticLog(string sMsgSIP, string sToIP, int nToPort)
        {
        }
        public virtual void OnIncomingDiagnosticLog(string sMsgSIP, string sFromIP, int nFromPort)
        {
        }

        public virtual void OnVaxTeleTick(int nTickId)
        {
        }

        public virtual void OnSendTimeoutVM(int nMsgIdVM)
        {
        }
        public virtual void OnSendSuccessVM(int nMsgIdVM)
        {
        }

        public virtual void OnCallSessionDialToneStart(int nSessionId, int nWaveId)
        {
        }
        public virtual void OnCallSessionDialToneStop(int nSessionId, int nWaveId)
        {
        }

        public virtual void OnCallSessionPlayWaveDone(int nSessionId, int nWaveId)
        {
        }
        public virtual void OnConferenceRoomPlayWaveDone(string sRoomName, int nWaveId)
        {
        }

        public virtual void OnCallSessionCreated(int nSessionId, int nReasonCode)
        {

        }

        public virtual void OnCallSessionOpenCall(int nSessionId, int nCallType, int nPeerType, string sPeerName)
        {

        }
        public virtual void OnCallSessionCloseCall(int nSessionId, int nCallType, int nPeerType, string sPeerName)
        {

        }

        public virtual void OnCallSessionDetectedAMD(int nSessionId, int nCallType, bool bIsHuman)
        {

        }

        public void OnCallSessionRecordedPCM(int nSessionId, long lDataPCM, int nSizePCM, int nTypePCM)
        {
            Byte[] aDataPCM = new byte[nSizePCM];
            Marshal.Copy(new IntPtr(lDataPCM), aDataPCM, 0, nSizePCM);

            OnCallSessionRecordedPCM(nSessionId, aDataPCM, nSizePCM);
        }

        public virtual void OnCallSessionRecordedPCM(int nSessionId, Byte[] aDataPCM, int nSizePCM)
        {
            
        }

        public void OnConferenceRoomRecordedPCM(string sRoomName, long lDataPCM, int nSizePCM, int nTypePCM)
        {
            Byte[] aDataPCM = new byte[nSizePCM];
            Marshal.Copy(new IntPtr(lDataPCM), aDataPCM, 0, nSizePCM);

            OnConferenceRoomRecordedPCM(sRoomName, aDataPCM, nSizePCM);
        }

        public virtual void OnConferenceRoomRecordedPCM(string sRoomName, Byte[] aDataPCM, int nSizePCM)
        {
        }

        public virtual void OnBusyLampSubscribe(int nSubScrbId, string sUserName, string sToUserName, string sFromIP, int nFromPort)
        {
        }

        public virtual void OnBusyLampUnSubscribe(int nSubScrbId, string sUserName, string sToUserName, string sFromIP, int nFromPort)
        {
        }

        public virtual void OnBusyLampSubscribeSuccess(int nSubScrbId, string sUserName)
        {
        }

        public virtual void OnBusyLampSubscribeFailed(int nSubScrbId, string sUserName)
        {
        }

        public virtual void OnVaxErrorLog(string sFuncName, int nErrorCode, string sErrorMsg)
        {

        }

        #endregion

    }
}
