﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using VaxTeleConfigSIP;

namespace VaxTeleServerApp
{
    public class CVaxServerSIP : CVaxServerExCOM
    {
        public ErrorLogForm m_objErrorLogDlg = null;
        public StatusLogForm m_objStatusLogDlg = null;

        public CVaxServerSIP()
        {
        }

        ~CVaxServerSIP()
        { 
        
        }

        /////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////
        
	    public bool AddUser(string sLogin, string sPassword, string sCodecList, bool bBlocked, string sUserPrefix, string sDialPrefix, int nToPeerType, string sToPeerName)
        {
            if (sUserPrefix.Length != 0 || sDialPrefix.Length != 0)
                base.AddUserRoute(sLogin, sUserPrefix, sDialPrefix, nToPeerType, sToPeerName);
            
            return base.AddUser(sLogin, sPassword, sCodecList, bBlocked, sUserPrefix, sDialPrefix, nToPeerType, sToPeerName);
        }

	    public void RemoveUser(string sLogin)
        {
            base.RemoveUser(sLogin);
            base.RemoveUserRoute(sLogin);
        }

        /////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////

        public bool AddLine(string sLineName, string sDisplayName, string sUserName, string sAuthUser, string sAuthPwd, string sDomainRealm, string sProxySIP, string sCodecList, bool bRegister, int nToPeerType, string sToPeerName, bool bBlock, string sRoomName)
        {
            base.AddLineRoute(sLineName, nToPeerType, sToPeerName, bBlock, sRoomName);
            return base.AddLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sCodecList, bRegister, nToPeerType, sToPeerName, bBlock, sRoomName);
        }
	    public void RemoveLine(string sLineName)
        {
            base.RemoveLine(sLineName);
            base.RemoveLineRoute(sLineName);
        }

        /////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////

        public bool AddDirectProxySIP(string sProxyName, string sAuthLogin, string sAuthPwd, string sDomainRealm, string sProxyIP, int nProxyPort, string sCodecList, int nToPeerType, string sToPeerName, bool bBlock, bool bAddToConf, string sRoomName)
        {
            base.AddDirectProxyRoute(sProxyName, nToPeerType, sToPeerName, bBlock, sRoomName);
            return base.AddDirectProxySIP(sProxyName, sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP, nProxyPort, sCodecList, nToPeerType, sToPeerName, bBlock, sRoomName);
        }
	    public void RemoveDirectProxySIP(string sProxyName)
        {
            base.RemoveDirectProxyRoute(sProxyName);
            base.RemoveDirectProxySIP(sProxyName);
        }

        /////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////

        public override void OnStatusLog(string sMsg)
        {
            m_objStatusLogDlg.OnStatusLog(sMsg);
        }
        public override void OnErrorLog(string sMsg)
        {
            m_objErrorLogDlg.OnErrorLog(sMsg);
        }
    }
}
