﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace VaxTeleServerApp
{
    class CConfRoom
    {

        CConfRoomList m_objConfRoomList = new CConfRoomList();
        CVaxServerExCOM m_objServerExCOM = null;

        public CConfRoom(CVaxServerExCOM objServerExCOM)
        {
            m_objServerExCOM = objServerExCOM;
        }
	    
        ~CConfRoom()
        {
        }

	    public bool AddRoom(string sRoomName, string sRoomNo)
        {
            if (!m_objConfRoomList.AddRoom(sRoomName, sRoomNo))
                return false;

            if (!m_objServerExCOM.OpenConferenceRoom(sRoomName))
            {
                m_objConfRoomList.RemoveRoom(sRoomName);
                return false;
            }

            return true;
        }
	    
        public void RemoveRoom(string sRoomName)
        {
            m_objServerExCOM.CloseConferenceRoom(sRoomName);
            m_objConfRoomList.RemoveRoom(sRoomName);
        }

	    public bool GetRoomDetails(string sRoomName, ref string sRoomNo)
        {
            return m_objConfRoomList.GetRoomDetails(sRoomName, ref sRoomNo);
        }

        public bool IsRoomNoExists(string sRoomNo)
        {
            return m_objConfRoomList.IsRoomNoExists(sRoomNo);
        }

	    public bool GetRoomAll(ref ArrayList pRoomList)
        {
            return m_objConfRoomList.GetRoomAll(ref pRoomList);
        }

        public string GetRoomName(string sRoomNo)
        {
            return m_objConfRoomList.GetRoomName(sRoomNo);
        }

        public void DeleteRoomAll()
        {
            m_objConfRoomList.DeleteRoomAll();
        }
    }
}
