﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace VaxTeleServerApp
{
    class CConfRoomDetails
    {

	    public CConfRoomDetails(){}
	    ~CConfRoomDetails(){}

	    public string m_sRoomName = "", m_sRoomNo = "";
    }

    class CConfRoomList
    {

        Hashtable m_objMapConfRoomByName;
        Hashtable m_objMapConfRoomByNo;

        public CConfRoomList()
        {
            m_objMapConfRoomByName = new Hashtable(256);
            m_objMapConfRoomByNo = new Hashtable(256);
        }

        ~CConfRoomList()
        {
            DeleteRoomAll();
        }

	    private string GenKey(string sValue)
        {
            return sValue.ToLower();
        }

	    private CConfRoomDetails FindRoomByName(string sRoomName)
        {
            return (CConfRoomDetails)m_objMapConfRoomByName[sRoomName.ToLower()];
        }

	    private CConfRoomDetails FindRoomByNo(string sRoomNo)
        {
            return (CConfRoomDetails)m_objMapConfRoomByNo[sRoomNo.ToLower()];
        }

	    public void DeleteRoomAll()
        {
            m_objMapConfRoomByName.Clear();
            m_objMapConfRoomByNo.Clear();
        }

        public bool AddRoom(string sRoomName, string sRoomNo)
        {
            CConfRoomDetails pConfRoom = FindRoomByName(sRoomName);
            if (pConfRoom != null) return false;

            pConfRoom = FindRoomByNo(sRoomNo);
            if (pConfRoom != null) return false;

            pConfRoom = new CConfRoomDetails();

            pConfRoom.m_sRoomName = sRoomName;
            pConfRoom.m_sRoomNo = sRoomNo;

            // Save by RoomName

            string sKey = GenKey(sRoomName);
            m_objMapConfRoomByName.Add(sKey, pConfRoom);

            // Save by RoomNo

            sKey = GenKey(sRoomNo);
            m_objMapConfRoomByNo.Add(sKey, pConfRoom);

            return true;
        }
	    
        public void RemoveRoom(string sRoomName)
        {
            CConfRoomDetails pConfRoom = FindRoomByName(sRoomName);
            if (pConfRoom == null) return;

            string sKey = GenKey(pConfRoom.m_sRoomNo);
            m_objMapConfRoomByNo.Remove(sKey);

            sKey = GenKey(sRoomName);
            m_objMapConfRoomByName.Remove(sKey);

            pConfRoom = null;
        }

	    public string GetRoomName(string sRoomNo)
        {
            CConfRoomDetails pConfRoom = FindRoomByNo(sRoomNo);
            if (pConfRoom == null) return "";

            return pConfRoom.m_sRoomName;
        }

	    public bool GetRoomDetails(string sRoomName, ref string sRoomNo)
        {
            CConfRoomDetails pConfRoom = FindRoomByName(sRoomName);
            if (pConfRoom == null) return false;

            sRoomNo = pConfRoom.m_sRoomNo;

            return true;
        }
	    
        public bool IsRoomNoExists(string sRoomNo)
        {
            CConfRoomDetails pConfRoom = FindRoomByNo(sRoomNo);
            if (pConfRoom == null) return false;

            return true;
        }

	    public bool GetRoomAll(ref ArrayList pRoomList)
        {
            foreach (object objValue in m_objMapConfRoomByName.Values)
            {
                CConfRoomDetails objRoom = (CConfRoomDetails)objValue;
                pRoomList.Add(objRoom.m_sRoomName);
            }

            return true;
        }
    }
}
