﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.Linq;
using System.Text;

namespace VaxTeleServerApp
{
    class CVaxUser
    {
        CVaxServerExCOM m_objServerExCOM;

        public string m_sPassword, m_sCodecList;
        public string m_sUserPrefix, m_sDialPrefix, m_sToPeerName;

        public bool m_bBlocked = false, m_bRegistered = false;
        public int m_nToPeerType = -1;
        
        public CVaxUser(CVaxServerExCOM objServerExCOM)
        {
            m_objServerExCOM = objServerExCOM;
        }

        ~CVaxUser()
        {
        }

        //////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////

        public void OnRegisterUser(string sUserLogin, string sDomain, string sFromIP, int nFromPort)
        {
	        if(m_bBlocked)
	        {
		        m_objServerExCOM.RejectRegister(sUserLogin, 404, "Not Found");
		        return;
	        }
	
	        m_objServerExCOM.AuthRegister(sUserLogin);

            string sStatus = sUserLogin + " " + CDefine.USER_REG_TRYING;
            m_objServerExCOM.GenStatusLog(sStatus);
        }

        public void OnRegisterUserSuccess(string sUserLogin)
        {
	        m_bRegistered = true;
	
	        string sStatus = sUserLogin + " " + CDefine.USER_REG_SUCCESS;
            m_objServerExCOM.GenStatusLog(sStatus);
        }

        public void OnRegisterUserFailed(string sUserLogin)
        {
            string sStatus = sUserLogin + " " + CDefine.USER_REG_FAILED;
            m_objServerExCOM.GenStatusLog(sStatus);
        }

        public void OnUnRegisterUser(string sUserLogin)
        {
            m_bRegistered = false;
	
	        string sStatus = sUserLogin + " " + CDefine.USER_UNREGISTER;
            m_objServerExCOM.GenStatusLog(sStatus);
        }

        //////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////
        
        public void GetData(ref string sPassword, ref string sCodecList, ref bool bBlocked, ref string sUserPrefix, ref string sDialPrefix, ref int nToPeerType, ref string sToPeerName)
        {
            sPassword = m_sPassword;
            sCodecList = m_sCodecList;
            bBlocked = m_bBlocked;

            sUserPrefix = m_sUserPrefix;
            sDialPrefix = m_sDialPrefix;

            nToPeerType = m_nToPeerType;
            sToPeerName = m_sToPeerName;
        }

        public void SetData(string sPassword, string sCodecList, bool bBlocked, string sUserPrefix, string sDialPrefix, int nToPeerType, string sToPeerName)
        {
            m_sPassword = sPassword;
            m_sCodecList = sCodecList;
            m_bBlocked = bBlocked;

            m_sUserPrefix = sUserPrefix;
            m_sDialPrefix = sDialPrefix;

            m_nToPeerType = nToPeerType;
            m_sToPeerName = sToPeerName;
        }

        //////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////

        public Boolean IsRegistered()
        {
	        return m_bRegistered;
        }   

    }
}
